1/25/92:

	Rlab is _not_ a clone of languages such as those used by tools
	like MATLAB or matrix_X/Xmath. However, as Rlab focuses on
	creating a good experimental environment (or laboratory) in
	which to do matrix math, it can be called "MATLAB-like" since
	the programming language possesses similar operators and
	concepts.  Extensive use has been made of the LAPACK, FFTPACK
	and RANLIB sources available from netlib.

	The most significant difference between the other proprietary
	tools and RLaB is the GNU Copyleft.

	See the file INSTALL for installation instructions.

	See the file INSTALL.2 for a guided installation.

	See the file WHATS.NEW for release news.

	See the file PROBLEMS for solutions to some commonly
	encountered installation/operation problems.

	See the examples directory for simple examples on how to use
	the program, and the plotting capabilities.

	See the RlaB Primer for a guided tour of the program, and more
	examples.

	Ian Searle
   	ians@eskimo.com

//---------------------------------------------------------------------------
//
// center
//
// Syntax: center(string,screen_width)
//
//  Same as printf("%s",string), but with the string centered on the screen.
//
//  If screen_width is given as an input argument, the string is centered
//  for a screen of the given width.  Otherwise, screen_width is 80. 
//
// Originally written for MATLAB by Lee P. Peterson
// Modified by Jeff Layton and ported to RLaB by Jeff Layton
//---------------------------------------------------------------------------

center = function(string,screen_width)
{
   local(i,j,str1,strout,sw)

   if (!exist (screen_width)) { sw = 80; else sw = screen_width; }
   i=(sw-(length(string)))/2;
   str1="";

   for (j in 1:i) {
        str1=str1+" ";
   }
   strout="";
   strout=str1+string+"\n";
   printf("%s",strout);

};

//
// The beginning of an eval() demonstration
//

//
// First define two functions for evaluating string matrices.
//

evalm = function ( M )
{
  local (m, i)

  if (class (M) != "string") 
  {
    error ("evalm: argument must be class string");
  }

  for (i in 1:M.n)
  {
    m[i] = eval (M[i]);
  }

  return m;
};

eval2m = function ( M )
{
  local (m)

  // The first time
  m = evalm (M);

  //
  // Now do it again if the result
  // is all string
  //

  if (class (m) != "string")
  {
    return m;
  else
    return evalm (m);
  }
};

// house_qr.r
// Given A, with M >= N, the following function finds Householder
// matrices H1,...Hn, such that if Q = H1*...Hn, then Q'*A = R is
// upper triangular.

// House.qr returns a MxN matrix, with the upper triangular part 
// containing [R]

house_qr = function ( A )
{
  local (A)

  m = A.nr; n = A.nc;
  v = zeros(m,1);

  for(j in 1:n)
  {
    v[j:m] = house_v( A[j:m;j] );
    A[j:m;j:n] = house_row( A[j:m;j:n], v[j:m] );
    if (j < m) 
    {
      A[ (j+1):m;j ] = v[(j+1):m];
    }
  }
  return A;
};

//
// Demonstrate the effect of adding terms to a Fourier expansion
//

// We want to approximate a square wave...
// The Fourier Series for a square wave is a 
// sum of odd harmonics - we will demonstrate.

// Start up a plot window...

//_plsori(1);
pstart(2,2, "xwin");

// Compute the 1st term in the Fourier series and plot.

t = (0:10:.1)';
y = sin (t);

ptitle ("Fundamental Frequency");
plwid(10);
plfont(1);
plot ( [t,y] );
plptex ("Pen width = 10", 4, 0.4);
plptex ("Font = 1 (Normal)", 4, 0.1);
pause ();

// Now add the third harmonic to the fundamental, and plot.

y = sin (t) + sin (3*t)/3;

ptitle ("1st and 3rd Harmonics");
plwid(7);
plfont(4);
plot ( [t,y] );
plptex ("Pen width = 7", 4, 0.4);
plptex ("Font = 4 (Script)", 4, 0.1);
pause ();

// Now use the first, third, fifth, seventh, and ninth harmonics.

y = sin (t) + sin (3*t)/3 + sin (5*t)/5 + sin (7*t)/7 + sin (9*t)/9;
ptitle ("1st, 3rd, 5th, 7th, 9th Harmonics");
plwid(4);
plfont(3);
plot ( [t,y] ); 
plptex ("Pen width = 3", 4, 0.4);
plptex ("Font = 3 (Italic)", 4, 0.1);
pause ();

//
// Now create a matrix with rows that represent adding
// more and more terms to the series.
// 

t = (0:3.14:.02);
y = zeros(10,max(size(t)));
x = zeros(size(t));

for (k in 1:19:2)
{
  x = x + sin(k*t)/k; 
  y[(k+1)/2;] = x;
}

//
// Now make a nice 3-D plot that shows the effect
// of adding more and more terms to the series.
//

plfont (2);
plwid(1);
ptitle ("Square Wave via Fourier Series");
ylabel ("No. Terms");
plaz (140);
plot3 (<< x = t; y=1:10; z=y' >>);
plptex ("Pen width = 1", -1, 4.5);
plptex ("Font = 2 (Roman)", -1, 3.8);

plprint ("p6.ps");	// Make hardcopy (Postscript default).

//
// Beginning of test file `test.r' (just `load(test.r)' to test the
// memory problem)
//
load("estimate.r");
rand ("uniform", 0, 1);
B = rand(10,10)/20+eye(10,10);
x = [1:10]';
f = B*x;
ans = 0;
h = [0;0;0;0;0;0;1;0;0;0];
for (i in 1:10) {
  ans[i] = 0;
  for (j in 1:5) {
    ans[i] = ans[i] + estimate(B, f, h, 10, 2^i);
    system("ps -aux | grep rlab");
  }
  ans[i] = ans[i] / 5
}
write("stdout",ans);

//-------------------------------------------------------------------//
// lyap.r:
//
// Syntax:	lyap ( A , B , C )
//		lyap ( A ,   , C )
//
// Description:
//
// lyap solves the general form of the Lyapunov (Sylvester) equation:
//
//	A*X + X*B = -C
//
// To solve the special form of the Lyapunov equation:
//
//	A*X + X*A' = -C
//
// Skip the second argument when using lyap (`lyap (A,,C)').

// See Also: schur, sylv
//-------------------------------------------------------------------//

lyap = function ( A, B, C )
{
  if (!exist (B)) 
  { 
    B = A';	// Solve the special form: A*X + X*A' = -C
  }

  if ((A.nr != A.nc) || (B.nr != B.nc) || (C.nr != A.nr) || (C.nc != B.nr)) 
  {
    error ("Dimensions do not agree.");
  }

  //
  // Schur decomposition on A and B
  //

  sa = schur (A);
  sb = schur (B);

  //
  // transform C
  //

  tc = sa.z' * C * sb.z;

  X = sylv (sa.t, sb.t, tc);

  //
  // Undo the transformation
  //

  X = sa.z * X * sb.z';

  return X;
};

//---------------------------------------------------------------------------
//  faxis.r

//  Syntax:	faxis ( X )
//		faxis ( X , T )
//		faxis ( X , T, axis_type )

//  Description:

//  Faxis generates a frequency axis for FFT plots.
//
//  X = FFT data
//  T = sampling period (optional argument)
//  axis_type = type of axis to create:
//              1 = Digital Rad/s [0,2pi], 2 = Analog Radians/s
//              3 = Analog Hertz           4 = Normalized frequency [0,2]
//
//  Defaults if not specified:   T = 1, axis_type = 1
//
//---------------------------------------------------------------------------

faxis = function ( X, _T, axis_type )
{
  global (pi)

  if (!exist (axis_type)) { axis_type = 1; }
  if (!exist (_T)) { T = 1; axis_type = 1; else T = _T; } 

  N = length (X);
  a = (0:N-1)/N;
  a = reshape (a, X.nr, X.nc);

  if (axis_type == 3)
  {
    a = a/T;
  else if (axis_type == 2) {
    a = a * (2*pi/T);
  else if (axis_type == 4) {
    a = 2 * a;
  else
    a = a * (2*pi);
  }}}

  return a
};

//-------------------------------------------------------------------//

//  Syntax:	expm ( A )

//  Description:

//  The expm function computes the matrix exponential, or exp (A),
//  where A is a square matrix.

//  Reference: "Matrix Computations" Gene  Golub, and Charles Van
//  		Loan. Section 11.3.

//-------------------------------------------------------------------//

expm = function ( a_ )
{
  local (X, a, c, cX, d, k, N, n, q, j);

  if (a_.nr != a_.nc) { error ("expm: A must be square"); }

  //
  // Scale A if neccesary, such that the infinity-norm of A divided
  // by some power of 2 is less than 1/2.
  //

  j = norm(a_, "i");
  if (j > 0) 
  { 
    j = max ([0, fix (log (j)/log (2))+2]);
  }
  a = a_/2^j;
  n = a.nr;

  //
  // k = 1
  //

  c = 1/2;
  X = a; 
  d = eye (n, n) - c*a;
  N = eye (n, n) + c*a;
  q = 6;

  for (k in 2:q)
  {
    c = c*(q - k + 1)/(k*(2*q - k + 1));
    X = a*X;
    cX = c*X;
    N = N + cX;
    d = d + (-1)^k*cX;
  }

  //
  // Solve d*F = N for F, overwrite N for efficiency
  //

  N = d\N;

  for (k in 1:j)
  {
    N = N*N;
  }

  return N;
};

//-------------------------------------------------------------------//

//  Synopsis:	Convert a number object into a string-object.

//  Syntax:	num2str ( N )

//  Description:

//  Num2str converts the real-numeric argument into a string, which
//  is the return value. 
//-------------------------------------------------------------------//

num2str = function ( N )
{
  local (i, j, s, stmp)

  if (class (N) == "num" && type (N) == "real")
  {
    s = [];
    for (i in 1:N.nr)
    {
      for (j in 1:N.nc)
      {
        sprintf (stmp, "%.4g", N[i;j]);
        s[i;j] = stmp;
      }
    }
    return s;
  else
    error ("num2str: argument must be numeric-real");
  }
};

// ODE78  Integrates a system of ordinary differential equations using
// 7th order formulas.
//
// out = ode78(F, t0, tfinal, y0, Uoutput, tol, trace)
//
// INPUT:
// Ufun  - variable containing user-supplied problem description.
//         Call: yprime = fun(t,y)
//         t      - Time (scalar).
//         y      - Solution row-vector.
//         yprime - Returned derivative vector; yprime(i) = dy(i)/dt.
// t0    - Initial value of t.
// tfinal- Final value of t.
// y0    - Initial value column-vector.
// Uoutput User output function
// tol   - The desired accuracy. (Default: tol = 1.e-6).
// trace - If nonzero, each step is printed. (Default: trace = 0).
//
// OUTPUT:
// out  - Returned integration time points (1st column).
//        Remaining columns are solutions of equations specified in Ufun
//
// The result can be displayed by: plot(tout, yout).

//   Daljeet Singh
//   Dept. Of Electrical Engg., The University of Alabama.
//   11-24-1988.

//   Modified by Ian Searle
//   4-18-93

static (collapse);

ode78 = function (Ufun, t0, tfinal, y0, Uoutput, tol, trace)
{
  local (alpha, beta, chi, delta, f, gamma1, h, hmax, ...
         hmin, j, psi, pow, t, tau, tout, y, yout, lout, I, output);

  // The Fehlberg coefficients:
  alpha = [ 2./27., 1/9,  1/6,    5/12,      .5, 5/6, 1/6, 2/3, 1/3, 1, 0, 1 ]';
  beta =  [ 2/27,    0,     0,       0,       0, 0, 0, 0, 0, 0, 0, 0, 0 ;
      1/36, 1/12,     0,       0,       0, 0, 0, 0, 0, 0, 0, 0, 0 ;
      1/24,    0,   1/8,       0,       0, 0, 0, 0, 0, 0, 0, 0, 0 ;
      5/12,    0,-25/16,   25/16,       0, 0, 0, 0, 0, 0, 0, 0, 0 ;
       .05,    0,     0,     .25,      .2, 0, 0, 0, 0, 0, 0, 0, 0 ;
   -25/108,    0,     0, 125/108,  -65/27, 125/54,  0, 0, 0, 0, 0, 0, 0 ;
    31/300,    0,     0,       0,  61/225,    -2/9, 13/900, 0, 0, 0, 0, 0, 0 ;
         2,    0,     0,   -53/6,  704/45,  -107/9,  67/90, 3, 0, 0, 0, 0, 0 ;
   -91/108,    0,     0,  23/108,-976/135,  311/54, -19/60, 17/6, -1/12, 0, 0, 0, 0 ;
 2383/4100, 0, 0, -341/164, 4496/1025, -301/82, 2133/4100, 45/82, 45/164, 18/41, 0,...
                                                                       0, 0 ;
  3/205, 0, 0,  0, 0, -6/41, -3/205, -3/41, 3/41, 6/41, 0, 0, 0 ;
  -1777/4100, 0, 0, -341/164, 4496/1025, -289/82, 2193/4100, ...
  51/82, 33/164, 12/41, 0, 1, 0 ]';

  chi = [0, 0, 0, 0, 0, 34/105, 9/35, 9/35, 9/280, 9/280, 0, 41/840, 41/840]';
  psi = [1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1, -1,  -1 ]';
  pow = 1/8;
  if (!exist (tol)) { tol = 1.e-6; }
  if (!exist (trace)) { trace = 0; }

  // Initialization
  t = t0;
  // the following step parameters are used in ODE45
  // hmax = (tfinal - t)/5;
  // hmin = (tfinal - t)/20000;
  // h = (tfinal - t)/100;
  // The following parameters were taken because the integrator has
  // higher order than ODE45. This choice is somewhat subjective.
  hmax = (tfinal - t)/2.5;
  hmin = (tfinal - t)/10000;
  h = (tfinal - t)/50;
  y = y0[:];
  f = y*zeros (1,13);
  tout = t;
  yout = y.';

  if (!exist (Uoutput)) 
  {
    output = 1;
    lout = << [tout, yout] >>;
  else
    output = 0;
    lout = << Uoutput (t, y).' >>;
  }
  I = 2;

  tau = tol * max( [norm(y, "I"), 1]);

  if (trace) { [t, y[:].'] ? }

  // The main loop

  while ((t < tfinal) && (h >= hmin))
  {
    if (t + h > tfinal) { h = tfinal - t; }

    // Compute the slopes
    f[;1] = Ufun (t, y)[:];
    for (j in 1:12)
    {
      f[;j+1] = Ufun (t+alpha[j]*h, y+h*f*beta[;j])[:];
    }

    // Truncation error term
    gamma1 = h*41/840*f*psi;

    // Estimate the error and the acceptable error
    delta = norm (gamma1,"I");
    tau = tol*max ([norm (y,"I"),1.0]);

    // Update the solution only if the error is acceptable
    if (delta <= tau)
    {
      t = t + h;
      y = y + h*f*chi;
      if (output) 
      {
        lout.[I] = [t, y.'];
      else
        lout.[I] = Uoutput (t, y).';
      }
      I++;
    }
    if (trace) { [t, y[:].']; }

    // Update the step size
    if (delta != 0.0)
    {
      h = min ([hmax, 0.8*h*(tau/delta).^pow]);
    }
  }

  if (t < tfinal)
  {
    fprintf ("stderr", "SINGULARITY LIKELY, at t = %d\n", t);
  }

  return collapse (lout);
};

//
// Collapse a LIST of matrices into a single matrix.
//

collapse = function ( LIST )
{
  local (i, m, row, col);

  row = size (LIST.[members (LIST)[1]])[1];
  col = size (LIST.[members (LIST)[1]])[2];
  m = zeros (length (LIST)*row, col);

  for (i in 1:length (LIST))
  {
    m[i;] = LIST.[i];
  }
  return m;
};

//-------------------------------------------------------------------//

//  Syntax:	logm ( A )

//  Description:

//  The logm function computes the matrix natural logarithm. Logm uses
//  Parlett's method in the rfile funm.r.

//  Another way to compute logm (A) is to:

//  logm ( X ) = e.vec * log (e.val) / e.vec

//  See Also: expm, funm
//-------------------------------------------------------------------//

//  Dependencies

require funm

logm = function ( X )
{
  return funm (X, log)
};

#
#NMSMAX  [x, fmax, nf] = NMSMAX(fun, x0, STOPIT, SAVIT) attempts to
#        maximize the function specified by the string fun, using the
#        starting vector x0.  The Nelder-Mead direct search method is used.
#        Output arguments:
#               x    = vector yielding largest function value found,
#               fmax = function value at x,
#               nf   = number of function evaluations.
#        The iteration is terminated when either
#               - the relative size of the simplex is <= STOPIT(1)
#                 (default 1e-3),
#               - STOPIT(2) function evaluations have been performed
#                 (default inf, i.e., no limit), or
#               - a function value equals or exceeds STOPIT(3)
#                 (default inf, i.e., no test on function values).
#        The form of the initial simplex is determined by STOPIT(4):
#           STOPIT(4) = 0: regular simplex (sides of equal length, the default)
#           STOPIT(4) = 1: right-angled simplex.
#        Progress of the iteration is not shown if STOPIT(5) = 0 (default 1).
#        If a non-empty fourth parameter string SAVIT is present, then
#        `SAVE SAVIT x fmax nf' is executed after each inner iteration.
#        NB: x0 can be a matrix.  In the output argument, in SAVIT saves,
#            and in function calls, x has the same shape as x0.

# References:
# J.E. Dennis, Jr., and D.J. Woods, Optimization on microcomputers:
#     The Nelder-Mead simplex algorithm, in New Computing Environments:
#     Microcomputers in Large-Scale Computing, A. Wouk, ed., Society for
#     Industrial and Applied Mathematics, Philadelphia, 1987, pp. 116-122.
#  N.J. Higham, Optimization by direct search in matrix computations,
#     Numerical Analysis Report No. 197, University of Manchester, UK, 1991;
#     to appear in SIAM J. Matrix Anal. Appl, 14 (2), April 1993.

# This is a heavily modified version of FMINS.M supplied with 386-MATLAB
# version 3.5j.

# By Nick Higham, Department of Mathematics, University of Manchester, UK.
#                 na.nhigham@na-net.ornl.gov
# July 27, 1991.

# Translated to RLaB, Ian Searle
# Feburary 1994.

nmsmax = function (fun, X, stopit, savit)
{
  global (eps)

  x = X;	# Copy the input
  n = prod(size(x));
  x0 = x[:];	# Work with column vector internally.

  # Set up convergence parameters etc.
  if (!exist (stopit)) { stopit[1] = 1e-3; }
  tol = stopit[1];	# Tolerance for cgce test based on relative size of simplex.
  if (max(size(stopit)) == 1) { stopit[2] = inf(); }	# Max no. of f-evaluations.
  if (max(size(stopit)) == 2) { stopit[3] = inf(); }	# Default target for f-values.
  if (max(size(stopit)) == 3) { stopit[4] = 0; }	# Default initial simplex.
  if (max(size(stopit)) == 4) { stopit[5] = 1; }	# Default: show progress.
  trace  = stopit[5];
  if (!exist (savit)) { savit = []; }			# File name for snapshots.

  V = [zeros(n,1), eye(n,n)];
  f = zeros(n+1,1);
  V[;1] = x0; 
  x = reshape (x0, x.nr, x.nc); 
  f[1] = fun (x);
  fmax_old = f[1];

  if (trace) { printf("f(x0) = %9.4e\n", f[1]); }

  k = 0; m = 0;

  # Set up initial simplex.
  scale = max([norm(x0,"i"),1]);
  if (stopit[4] == 0)
  {
    # Regular simplex - all edges have same length.
    # Generated from construction given in reference [18, pp. 80-81] of [1].
    alpha = scale / (n*sqrt(2)) * [ sqrt(n+1)-1+n, sqrt(n+1)-1 ];
    V[;2:n+1] = (x0 + alpha[2]*ones(n,1)) * ones(1,n);
    for (j in 2:n+1)
    {
      V[j-1;j] = x0[j-1] + alpha[1];
      x = reshape (V[;j], x.nr, x.nc); 
      f[j] = fun (x);
    }
  else
    # Right-angled simplex based on co-ordinate axes.
    alpha = scale*ones(n+1,1);
    for (j in 2:n+1)
    {
      V[;j] = x0 + alpha[j]*V[;j];
      x = reshape (V[;j], x.nr, x.nc); 
      f[j] = fun (x);
    }
  }
  nf = n+1;
  how = "initial  ";

  temp = sort (f).val;
  j = sort (f).ind;
  j = j[n+1:1:-1];
  f = f[j]; 
  V = V[;j];

  alpha = 1;  beta = 1/2;  gamma = 2;

  while (1)	###### Outer (and only) loop.
  {
    k = k+1;

    fmax = f[1];
    if (fmax > fmax_old)
    {
      if (!isempty(savit))
      {
        x = reshape (V[;1], x.nr, x.nc); 
        write("savit", x, fmax, nf);
      }
      if (trace)
      {
        printf("Iter. %2.0f"', k);
        printf("  how = %s  ", how);
        printf("nf = %3.0f,  f = %9.4e  (%2.1f)\n", nf, fmax, ...
               100*(fmax-fmax_old)/(abs(fmax_old)+eps));
      }
    }
    fmax_old = fmax;

    ### Three stopping tests from MDSMAX.M

    # Stopping Test 1 - f reached target value?
    if (fmax >= stopit[3])
    {
      msg = "Exceeded target...quitting\n";
      break  # Quit.
    }

    # Stopping Test 2 - too many f-evals?
    if (nf >= stopit[3])
    {
      msg = "Max no. of function evaluations exceeded...quitting\n";
      break  # Quit.
    }

    # Stopping Test 3 - converged?   This is test (4.3) in [1].
    v1 = V[;1];
    size_simplex = norm(V[;2:n+1]-v1[;ones(1,n)],"1") / max([1, norm(v1,"1")]);
    if (size_simplex <= tol)
    {
      sprintf(msg, "Simplex size %9.4e <= %9.4e...quitting\n", ...
              size_simplex, tol);
      break  # Quit.
    }

    #  One step of the Nelder-Mead simplex algorithm
    #  NJH: Altered function calls and changed CNT to NF.
    #       Changed each `fr < f(1)' type test to `>' for maximization
    #       and re-ordered function values after sort.

    vbar = (sum(V[;1:n]')/n)';	# Mean value
    vr = (1 + alpha)*vbar - alpha*V[;n+1]; 
    x = reshape (vr, x.nr, x.nc);
    fr = fun (x);
    nf = nf + 1;
    vk = vr;  fk = fr; how = "reflect, ";
    if (fr > f[n])
    {
      if (fr > f[1])
      {
        ve = gamma*vr + (1-gamma)*vbar; 
        x = reshape (ve, x.nr, x.nc);
        fe = fun (x);
        nf = nf + 1;
        if (fe > f[1])
        {
          vk = ve; fk = fe;
          how = "expand,  ";
        }
      }
    else
      vt = V[;n+1];
      ft = f[n+1];
      if (fr > ft)
      {
        vt = vr;
        ft = fr;
      }
      vc = beta*vt + (1-beta)*vbar; 
      x = reshape (vc, x.nr, x.nc);
      fc = fun (x);
      nf = nf + 1;
      if (fc > f[n])
      {
        vk = vc; fk = fc;
        how = "contract,";
      else
        for (j in 2:n)
        {
          V[;j] = (V[;1] + V[;j])/2;
          x = reshape (V[;j], x.nr, x.nc);
          f[j] = fun (x);
        }
        nf = nf + n-1;
        vk = (V[;1] + V[;n+1])/2; 
        x = reshape (vk, x.nr, x.nc);
        fk = fun (x);
        nf = nf + 1;
        how = "shrink,  ";
      }
    }
    V[;n+1] = vk;
    f[n+1] = fk;
    temp = sort(f).val;
    j = sort (f).ind;
    j = j[n+1:1:-1];
    f = f[j]; 
    V = V[;j];

  }	###### End of outer (and only) loop.

  # Finished.
  if (trace) { printf(msg); }
  x = reshape (V[;1], x.nr, x.nc);

  return <<x = x; fmax = fmax; nf = nf>>;
};

//--------------------------------------------------------------------------------
// printmat

// Synopsis: Print a matrix with title and labels.

// Syntax: printmat(A, Aname, ROWLAB, COLLAB);

// Description:

// This routine prints the matrix A using the title contained in the
// string Aname and the row labels contained in ROWLAB and the
// column labels contained in COLLAB. Note: ROWLAB and COLLAB are
// vectors of strings, such as
//
//         rowlab[1]="alpha";
//         rowlab[2]="beta";
//         rowlab[3]="gamma";
//
//  Note: Aname, ROWLAB, and COLLAB are optional variables.
//
//--------------------------------------------------------------------------------

printmat = function (a, mname, rowlab, collab, fn)
{
  // Set defaults, error check.

  if (!exist (a)) { error ("printmat: must supply a matrix"); }
  if (!exist (mname)) { mname = ""; }
  if (!exist (rowlab)) { rl = []; else rl = rowlab; }
  if (!exist (collab)) { cl = []; else cl = collab; }
  if (!exist (fn))     { fn = "stdout"; }
  
  if (!isempty (rl)) {
    if (rl.n != a.nr) { error ("printmat: ROWLAB.n != A.nr"); }
  }
  if (!isempty (cl)) {
    if (cl.n != a.nc) { error ("printmat: COLLAB.n != A.nc"); }
  }

  nrows=a.nr;
  ncols=a.nc;
  
  // Create row and column labels if necessary
  if (rl.n == 0)
  {
    for (i in 1:nrows) 
    {
      sprintf (tmp, "%3i", i);
      rl[i]="--"+ tmp +" --> ";
    }
  }
  if (cl.n == 0)
  {   
    for (i in 1:ncols) { cl[i]="----"+int2str(i)+"---- "; }
  }
  
  col_per_scrn=5;
  len=12;
  
  if ((nrows==0)||(ncols==0)) 
  { 
    if (length (mname)) 
    {
      fprintf(fn," \n%s = \n \n",mname);
      return 0;
    }
    fprintf(fn," \n%s \n","     [] \n");
    return 0;
  }

  // Print matrix name
  col=1;
  n = min([col_per_scrn-1,ncols-1]);
  if (length (mname)) 
  {
    fprintf(fn,"\n%s = \n \n",mname);
  }

  // Print column labels
  s="";
  icol=0;
  while (col <= ncols) 
  {
    icol=icol+1;
    s="            ";
    for (j in 0:n) 
    {
      ishift=13-length(cl[j+col]);
      for (k in 1:ishift) 
      {
	s=s+" ";
      }
      s=s+cl[j+col];
    }
    fprintf(fn,"%s\n",s);
    
    // Print Row Labels
    for (i in 1:nrows) 
    {
      s=""+rl[i];
      ishift=12-length(rl[i]);
      for (k in 1:ishift) 
      {
	s=s+" ";
      }
      for (j in 0:n) 
      {
	element = a[i;col+j];
	if (element == 0) {
	  s=s+"           0";
	else if (element >= 1.0e+06) {
	  sdum="";
	  sprintf(sdum," %12.5e",element);
	  s=s+sdum;
	else if (element <= -1.0e+05) {
	  sdum="";
	  sprintf(sdum," %12.5e",element);
	  s=s+sdum;
	else if (abs(element) < 0.0001) {
	  sdum="";
	  sprintf(sdum," %12.5e",element);
	  s=s+sdum;
	else
	  sdum="";
	  sprintf(sdum," %12.5f",element);
	  s=s+sdum;
        } } } }
      }
      fprintf(fn,"%s\n",s);
    }
    col = col+col_per_scrn;
    fprintf(fn,"%s"," \n");
    if ((ncols-col) < n) 
    {
      n=ncols-col;
    }
  }
  
  return 0;  
};

//-------------------------------------------------------------------//

//  Syntax:  fix ( X )

//  Description:

//  Fix rounds the elements of X to the nearest integer towards zero.

//  See Also ceil, floor, round, sign, abs

//-------------------------------------------------------------------//

fix = function ( X )
{
  if (X.type == "real")
  {
    return sign (X) .* floor (abs (X));
  else if (X.type == "complex") {
    return (sign (real (X)) .* floor (abs (real (X)))) + ...
           ((0+1j)*(sign (imag (X))) .* floor (abs (imag (X))));
  else
    error("fix() only takes real or complex (scalar and matrix) arguments");
  }}
};

printf( "Starting the lqr test...\n" );
rfile ode23

lqr = function( a, b, q, r ) 
{
  m = size(a)[1]; n = size(a)[2];
  mb = size(b)[1]; nb = size(b)[2];
  mq = size(q)[1]; nq = size(q)[2];
  
  if ( m != mq || n != nq ) 
  {
    fprintf( "stderr", "A and Q must be the same size.\n" );
    quit
  }
    
  mr = size(r)[1]; nr = size(r)[2];
  if ( mr != nr || nb != mr ) 
  {
    fprintf( "stderr", "B and R must be consistent.\n" );
    quit
  }
    
  nn = zeros( m, nb );
  
  // Start eigenvector decomposition by finding eigenvectors of Hamiltonian:
  
  e = eig( [ a, solve(r',b')'*b'; q, -a' ] );
  v = e.vec; d = e.val;
    
  index = sort( real( d ) ).ind;
  d = real( d[ index ] );
  
  if ( !( d[n] < 0 && d[n+1] > 0 ) ) 
  {
    fprintf( "stderr", "Can't order eigenvalues.\n" );
    quit
  }
    
  chi = v[ 1:n; index[1:n] ];
  lambda = v[ (n+1):(2*n); index[1:n] ];
  s = -real(solve(chi',lambda')');
  k = solve( r, nn'+b'*s );
  
  return << k=k; s=s >>;
  
};


// Now run a little test problem.

k = 1; m = 1; c = .1;
a = [    0,    1,    0,    0; -k/m, -c/m,  k/m,  c/m; 0,    0,    0,    1; k/m,  c/m, -k/m, -c/m ];
b = [ 0; 1/m; 0; 0 ];
qxx = diag( [0, 0, 100, 0] );
ruu = [1];

K = lqr( a, b, qxx, ruu ).k;

dot = function( t, x ) 
{
  global (a, b, K)
  return (a-b*K)*x + b*K*([1,0,1,0]')
};

x = ode( dot, 0, 15, [0,0,0,0]',.01, 1.e-5, 1.e-5);

m = maxi( x[;2] );

if ( (abs( x[m;2] - 1.195 ) > 0.001)  || ...
     any (abs( x[x.nr;2,4] - 1 ) > 0.001) ) {
     printf( "...failed.\a\n" );
else
     plgrid ();
     ptitle ("LQR Test Results");
     plot (x);
     printf( "...passed.\n" );
}

//-------------------------------------------------------------------

// Syntax:	redit ( F , editor )

// Description:

// The redit function is a convenient way to edit an rfile, and have
// it automatically re-loaded upon exiting the editor. The argument F
// is a string, and is the name of the rfile (including the extension).

// The file must be in the present working directory to function
// properly.

// The second string argument is optional, and specifies an editor
// other than the default (vi).
//------------------------------------------------------------------

redit = function ( file , editor )
{
  local (ED, r);

  if (class (file) != "string") 
  {
    error ("1st argument to edit() must be string");
  }
  if (!exist (editor))
  {
    ED = "vi";
  else
    if (class (editor) != "string")
    {
      error ("2nd argument ot edit() must be string");
    }
    ED = editor;
  }

  system (ED + " " + file);
  r = load (file);
  printf ("edited and loaded rfile: %s\n", file);
  return r;
};

//-------------------------------------------------------------------//
//
//  Syntax:     max2 ( A, B )

//  Description:

//  Return a matrix the same size as A and B with the largest
//  elements taken from A and B.

//  Note: the builtin function max now handles this condition.
//        This file is maintained for backward compatibility.

//-------------------------------------------------------------------//

max2 = function(a,b)
{
  return max(a,b);
  // return (b+(a-b).*(a>b));
};

//
// Create and manipulate sparse matrices via RLaB lists.
//

//
// Given row and column indices, create a sparse matrix
// structure using lists.
//

make_sparse = function ( cm )
{
  sm = <<>>;  // Create initial list.

  ri = set (cm[;1]);  // Get a set of the row indices.
  for (i in 1:ri.n)   // Create the row lists.
  {
    sm.[ri[i]] = <<>>;
  }

  // Now load up the sparse matrix
  
  for (i in 1:cm.nr)
  {
    sm.[cm[i;1]].[cm[i;2]] = cm[i;3];
  }

  return sm;
};

//
// Print out a sparse matrix.
//

print_sparse = function ( sm )
{
  for (i in members (sm))
  {
    for (j in members (sm.[i]))
    {
      printf (" row: %6s\tcol: %6s\tvalue: %g\n", i, j, sm.[i].[j]);
    }
  }
};

//
// Add two sparse matrices.
//

//
// Multiply two sparse matrices.
//

// -------------------------------------------------------------------
//
// Beginning of codes to test memory allocation/deallocation.
//
// The following lines are in a file called `estimate.r'

mysum = function(X) 
{
  //
  // Treat vectors, scalars and matrices differently.  If X is a scalar,
  // do nothing...

  if (X.n == 1) { return X; }

  //
  // if X is a matrix, return the vector of row-sums, except in the special
  // case that X.nc==1 or X.rc==1; in that case, return the scalar sum.
  //

  if (X.n  > 1)
  {
    if (X.nc == 1) 
    {
      tmp = 0;
      for(i in 1:X.nr) 
      {
        tmp = tmp + X[i;1];
      }
      return tmp;
    }
    if (X.nr == 1) 
    {
      tmp = 0;
      for(i in 1:X.nc) 
      {
        tmp = tmp + X[1;i];
      }
      return tmp;
    }
    tmp = zeros(X.nr);
    for(i in 1:X.nr) 
    {
      for(j in 1:X.nc) 
      {
        tmp[i] = tmp[i] + X[i;j];
      }
    }
    return tmp;
  }
}

initstate = function(v) 
{
  local (prob, tmp, i);

  tmp = 0;
  prob = rand();
  for(i in 1:v.nr) 
  {
    tmp = tmp + v[i;1];
    if (tmp >= prob) 
    {
      break;
    }
  }
  if (v[i;1] == 0) 
  {
    error("initstate: Attempting to initialize to invalid state.");
  }
  return i;
}

nextstate = function(thisstate, trans) 
{
  local (prob, tmp, i);

  tmp = 0;
  prob = rand();
  for(i in 1:trans.nc) 
  {
    tmp = tmp + trans[thisstate;i];
    if (tmp >= prob) 
    {
      break;
    }
  }
  if (trans[thisstate;i] == 0) 
  {
    error("nextstate: Attempting transition to invalid state.");
  }
  return i;
}

randwalk = function(A, P, f, init, h, p, chlen) 
{
  //
  // Randwalk uses the transition matrix P, the initial state init,
  // and the number of steps chlen to take a random walk.  The other
  // input variables are required in order to keep the statistics we
  // need to accumulate. 
  //

  local (old, new, i, W, total);

  old = init;
  W = 1.0;
  total = f[old;1];
  for (i in 1:chlen) 
  {
    new=nextstate(old, P);
    W = W * A[old;new] ./ P[old;new];
    total = total + W * f[new;1];
    old = new;
  }
  return h[init;1] * total ./ p[init;1];
}

estimate = function(B, f, h, chlen, niters) 
{
  // Given a matrix equation Bx = f with known coefficient matrix B and
  // known right-hand-side f, the function `estimate' uses a Markov chain
  // technique to approximate the inner product of the known vector h
  // with the unknown vector x (or rather, the inner product of h with the
  // chlen+1st iterate of the fixed point iteration x = Ax+f, where
  // B = I - A).  The input `niters' controls how many random walks are taken.
  // For details of the method, see Chapter 5 of R. Rubinstein's ``Simulation
  // and the Monte Carlo Method.''

  local (A, n, i, j, tmp, P, p, total, eta);
  n = B.nr;
  A = eye(n,n) - B;
  
  //
  // Now generate P, the ergodic Markov chain, by scaling the rows of A so
  // that the row-sums are all = 1.  Note: we are making an implicit assumption
  // that the infinity norm of the matrix A is less than one.  (see Rubinstein).
  //

  P=zeros(n,n);
  for(i in 1:n) 
  {
    tmp = mysum(abs(A[i;]));
    P[i;] = abs(A[i;])./tmp;
  }

  //
  // Generate the initial distribution vector p.
  //
  
  p=abs(h)/mysum(abs(h));

  //
  // Now we're ready to take some `walks'.
  //

  total = 0;
  for(i in 1:niters) 
  {
    //
    // Generate an initial state for the particle, and then call randwalk.
    // Randwalk will keep track of the statistics we need for each walk.
    //
    j = initstate(p);
    //  printf("Walk no. %d...",i);
    eta = randwalk(A, P, f, j, h, p, chlen);
    //  printf("done\n");
    total = total + eta;
  }
  return total/niters;
}

//
// End of file `estimate.r'
//

%SP_STMAG Short-time magnitude.

%       [Y,TSCALE] = SP_STMAG(X,FRAME,OVERLAP,FS) computes
%       the short-time magnitude of X using a frame size
%       of LENGTH and a percentage OVERLAP between successive
%       frames using a rectangular data window.  The sampling
%       frequency is given by FS. The short-time magnitude
%       curve is returned in Y and a time scale corresponding
%       to the end of the data frame is returned in TSCALE.
%       The curve may be displayed with the command
%       'plot(y,tscale)'.
%
%       [Y,TSCALE] = SP_STMAG(X,FRAME,OVERLAP,FS,'WINDOW')
%       windows the data through the specified 'WINDOW' before
%       computing the short-time magnitude.  'WINDOW' can be
%       one of the following: 'hamming', 'hanning', 'bartlett',
%       'blackman' or 'triang'.
%
%       See also: STENG, STZCR, AVSMOOTH, MDSMOOTH

%       Matlab original by:
%       LT Dennis W. Brown 7-11-93, DWB 11-11-94
%       Naval Postgraduate School, Monterey, CA
%       May be freely distributed.
%       Not for use in commercial products.

%       Ref: Rabiner & Schafer, Digital Processing of Speech
%       Signals, 1978, ss 4.2, pp 120-126.

require window

stmag = function (x, frame, overlap, fs, win)
{
  local (x, frame, overlap, fs, win)

  % default values
  y = [];
  tscale = [];

  % must have at least 3 args
  if (nargs < 3)
  {
    error("sp_stmag: Requires first three arguments.");
  }

  % percentage must be in range 0-100
  if (overlap < 0 || overlap > 100)
  {
    error("sp_stmag: Overlap percentage must be in range 0-100%");
  }

  % figure out if we have a vector
  if (min(size(x)) != 1)
  {
    error("sp_stmag: Input arg \"x\" must be a 1xN or Nx1 vector.");
  }

  % work with Nx1 vectors
  x = x[:];

  % variables
  Ns = length(x);                         % number of samples
  N = floor(fs * frame);                  % samples-per-frame
  Ndiff = floor(N * (1 - overlap/100));   % samples between windows
  L = floor((Ns-N)/Ndiff);                % number of windows
  y = zeros(L,1);                         % space for answer
  tscale = zeros(L,1);	                  % space for time

  % data window
  datawindow = ones(N,1);                 % rectangular default
  if (nargs == 5)
  {
    datawindow = window (N, win);
  }

  % use the absolute value of x
  x = abs(x);

  % windows with overlap
  for (k in 1:L)
  {
    s1 = (k-1) * Ndiff + 1;                 % start of window
    tscale[k;1] = k * Ndiff/fs;
    y[k;1] = sum(x[s1:s1+N-1;1] .* datawindow);
  }
  
  return << tscale=tscale ; y=y >>;
};

//-------------------------------------------------------------------//
//  set

//  Syntax:	set ( A )

//  Description:

//  The set function takes an vector argument (A), and returns a
//  vector that is sorted in ascending order, and has no duplicate
//  values. 

//  See Also: complement, intersection, union
//-------------------------------------------------------------------//

set = function ( A )
{
  if (min (size (A)) != 1) 
  {
    error ("set: requires vector argument");
  }

  i = j = 1;
  a = sort (A).val;
  while (i <= a.n)
  {
    tmp = find (a[i] == a);
    if (tmp.n > 1) 
    {
      s[j] = a[tmp[1]];
      i = i + tmp.n;
    else
      s[j] = a[tmp];
      i++;
    }
    j++;
  }
  return s
};

//-------------------------------------------------------------------//
//  intersection

//  Syntax:	intersection ( A , B )

//  Description:

//  Intersection finds the intersection-set of the two vector sets A,
//  and B.

//  See Also: complement, set, union

//-------------------------------------------------------------------//

intersection = function ( A , B )
{
  if(A.nr == 0 || B.nr == 0) 
  {
    return [];
  }

  if (min (size (A)) != 1) 
  {
    error ("intersection: 1st arg must be a vector");
  }

  if (min (size (B)) != 1) 
  {
    error ("intersection: 2st arg must be a vector");
  }

  a = set (A); b = set (B);
  j = 1;
  Int = [];

  for (i in 1:b.n)
  {
    tmp = find (b[i] == a);
    if (tmp.n > 0) 
    {
      Int[j] = b[i];
      j++;
    }
  }
  return Int
};

#
# Simple contour plotting demonstration
#

NX = 20;
NY = 20;
xx = zeros (1, NX);
yy = zeros (1, NY);
for (i in 1:NX) { xx[i] = (i - NX/2)/(NX/2); }
for (i in 1:NY) { yy[i] = (i - NY/2)/(NY/2); }

zz = zeros (NX, NY);

for (i in 1:NX)
{
  for (j in 1:NY)
  {
    r = sqrt (xx[i]^2 + yy[j]^2);
    zz[i;j] = exp (-r * r) * cos (2*pi*r);
  }
}

# Sin - Cos surface

x1 = -3:3:.2;
y1 = -3:3:.2;
z1 = zeros (x1.n, y1.n);

for (i in 1:x1.n)
{
  for(j in 1:y1.n)
  {
    z1[i;j] = sin(y1[j]) * cos(x1[i]);
  }
}

# Now create some plots

xlabel("X-Axis");
ylabel("Y-Axis");
ptitle ("Contour Demonstration");

plmesh (<< x = xx; y = yy; z = zz>>);
pause();
plaspect(0.5);
plcont (<< x = xx; y = yy; z = zz>>);
pause();
plmesh (<< x = x1; y = y1; z = z1>>);
pause();
plcont (<< x = x1; y = y1; z = z1>>);

////-------------------------------------------------------------------//

//  Syntax:  bessely ( ALPHA, X )

//  Description:

//  Bessely is the bessel function of the second kind of order ALPHA.
//  Either ALPHA or X may a vector in which case a vector result of
//  the same dimension is returned.  If both ALPHA and X are vectors
//  a matrix result of dimension length(ALPHA) x length(X) is returned.
//  If either ALPHA or X is a scalar, the other argument may be a matrix
//  and a matrix result of the same dimension is returned.

//-------------------------------------------------------------------//

// See Numerical Recipes in C (second edition)
// Currently only integer order supported.

static (besselyn, bessely0, bessely1);

bessely = function(alph,x) 
{
  global (pi)

  // Checking the class will automatically result in an error if
  // the argument doesn't exist.
  if(class(alph) != "num" || class(x) != "num") {
    error("bessely: argument is non-numeric.");
  }

  if(min(size(alph)) > 1 && min(size(x)) > 1) {
    // Both arguments are matrices.
    error("bessely: only one argument may be a matrix.");
  }

  if(length(alph) == 1) {
    // x is a matrix (or scalar), alph a scalar
    if(alph == 0 || mod(alph,int(alph)) == 0) {
      return besselyn(alph,x);
    else
      error("bessely: fractional orders not yet supported.");
      // return besselyr(alph,x);
    }
  else if(length(x) == 1) {
    // alph is a matrix (or vector), x a scalar
    y = zeros(size(alph));

    // Use integer order routines for integer alph
    inte_ind = find(alph == 0 || mod(alph,int(alph)) == 0);
    frac_ind = complement(inte_ind,1:alph.n);

    if(inte_ind.n) {
      for(index in inte_ind) {
        y[index] = besselyn(alph[index],x);
      }
    }
    if(frac_ind.n) {
      error("bessely: fractional orders not yet supported.");
      // for(index in frac_ind) {
        // y[index] = besselyr(alph[index],x);
      // }
    }
    return y;
  else
    // alph and x are both vectors
    y = zeros(length(alph),length(x));

    // Use integer order routines for integer alph
    inte_ind = find(alph == 0 || mod(alph,int(alph)) == 0);
    frac_ind = complement(inte_ind,1:alph.n);

    if(inte_ind.n) {
      for(index in inte_ind) {
        y[index;] = besselyn(alph[index],x);
      }
    }
    if(frac_ind.n) {
      error("bessely: fractional orders not yet supported.");
      // for(index in frac_ind) {
        // y[index;] = besselyr(alph[index],x);
      // }
    }
    return y;
  }}
};

// In these functions x can be a vector (or matrix), but n
// must be a scalar.

// No argument checking is performed on static functions.

besselyn = function ( n, x ) {

  local(abs_x,y,index,index_1,index_2,index_3,arg,p_1,p_2,p_3, ...
        two_over_x,m,y_2,Norm,even,limit,lim_ind);

  if(n == 0) {
    return bessely0(x);
  else if (n == 1) {
    return bessely1(x);
  else
    // integer order greater than two

    y = zeros(size(x));

    index_1 = 1:x.n;
    index_2 = find(x == 0);

    index_1 = complement(intersection(index_1,index_2),index_1);

    if(index_2.n) {
      y[index_2] = -1./zeros(size(index_2));
    }

    if(index_1.n) {
      arg = x[index_1];

      p_1 = bessely0(arg);
      p_2 = bessely1(arg);
      two_over_x = 2./arg;
      for(index in 1:(n-1)) {
        p_3 = index * (two_over_x .* p_2) - p_1;
        p_1 = p_2;
        p_2 = p_3;
      }
      y[index_1] = p_3;
    }

    return y;
  }}
};

bessely0 = function(x) {
  local(index_1,index_2,index_3,y,c_1,c_2,arg_1,arg_2,p_1,p_2);

  index_1 = find(x < 8);
  index_2 = complement(index_1,1:x.n);
  index_3 = find(x == 0.);

  index_1 = complement(intersection(index_1,index_3),index_1);

  // First evaluate using rational approx. for small arguments.

  y = zeros(size(x));

  if(index_3.n) {
    y[index_3] = -1./zeros(size(index_3));
  }

  if(index_1.n) {
    c_1 = [ -2957821389, 7062834065, -512359803.6, ...
            10879881.29, -86327.92757, 228.4622733 ];
    c_2 = [ 40076544269, 745249964.8, 7189466.438, ...
            47447.26470, 226.1030244 ];

    arg_1 = x[index_1];
    arg_2 = arg_1 .* arg_1;

    // Rational approximation to the "regular part"
    p_1 = c_1[1] + arg_2 .* (c_1[2] + arg_2 .* (c_1[3] + arg_2 .* ...
          (c_1[4] + arg_2 .* (c_1[5] + arg_2 .* c_1[6]))));
    p_2 = c_2[1] + arg_2 .* (c_2[2] + arg_2 .* (c_2[3] + arg_2 .* ...
          (c_2[4] + arg_2 .* (c_2[5] + arg_2))));
    y[index_1] = p_1./p_2 + (2/pi)*besselj(0,arg_1).*log(arg_1);
  }

  // Now evaluate for large arguments using approximating form.

  if(index_2.n) {
    c_1 = [ -0.1098628627e-2, 0.2734510407e-4, -0.2073370639e-5, ...
            0.2093887211e-6 ];
    c_2 = [ -0.1562499995e-1, 0.1430488765e-3, -0.6911147651e-5, ...
            0.7621095161e-6, -0.934945152e-7 ];

    arg_1 = 8./x[index_2];
    arg_2 = arg_1 .* arg_1;

    p_1 = 1 + arg_2 .* (c_1[1] + arg_2 .* (c_1[2] + arg_2 .* (c_1[3] + ...
          arg_2 .* c_1[4])));
    p_2 = c_2[1] + arg_2 .* (c_2[2] + arg_2 .* (c_2[3] + arg_2 .* (c_2[4] + ...
          arg_2 .* c_2[5])));

    c_1 = x[index_2];
    c_2 = c_1 - pi/4;
    y[index_2] = sqrt(2./(pi*c_1)).*(p_1.*sin(c_2) + arg_1.*p_2.*cos(c_2));
  }

  return y;
};


bessely1 = function(x) {
  local(index_1,index_2,index_3,y,c_1,c_2,arg_1,arg_2,p_1,p_2);

  index_1 = find(x < 8);
  index_2 = complement(index_1,1:x.n);
  index_3 = find(x == 0.);

  index_1 = complement(intersection(index_1,index_3),index_1);

  // First evaluate using rational approx. for small arguments.

  y = zeros(size(x));

  if(index_3.n) {
    y[index_3] = -1./zeros(size(index_3));
  }

  if(index_1.n) {
    c_1 = [ -0.4900604943e13, 0.1275274390e13, -0.5153438139e11, ...
            0.7349264551e9, -0.4237922726e7, 0.8511937935e4 ];           
    c_2 = [ 0.2499580570e14, 0.4244419664e12, 0.3733650367e10, ...
            0.2245904002e8, 0.1020426050e6, 0.3549632885e3 ];
    
    arg_1 = x[index_1];
    arg_2 = arg_1 .* arg_1;

    p_1 = arg_1.*(c_1[1] + arg_2 .* (c_1[2] + arg_2 .* (c_1[3] + arg_2 .* ...
          (c_1[4] + arg_2 .* (c_1[5] + arg_2 .* c_1[6])))));
    p_2 = c_2[1] + arg_2 .* (c_2[2] + arg_2 .* (c_2[3] + arg_2 .* ...
          (c_2[4] + arg_2 .* (c_2[5] + arg_2 .* (c_2[6] +arg_2)))));
    y[index_1] = p_1./p_2 + (2/pi)*(besselj(1,arg_1).*log(arg_1) - 1./arg_1);
  }

  // Now evaluate for large arguments using approximating form.

  if(index_2.n) {
    c_1 = [ 0.183105e-2, -0.3516396496e-4, 0.2457520174e-5, ...
            -0.240337019e-6 ];
    c_2 = [ 0.04687499995, -0.2002690873e-3, 0.8449199096e-5, ...
            -0.88228987e-6, 0.105787412e-6 ];

    arg_1 = 8./x[index_2];
    arg_2 = arg_1 .* arg_1;

    p_1 = 1 + arg_2 .* (c_1[1] + arg_2 .* (c_1[2] + arg_2 .* (c_1[3] + ...
          arg_2 .* c_1[4])));
    p_2 = c_2[1] + arg_2 .* (c_2[2] + arg_2 .* (c_2[3] + arg_2 .* (c_2[4] + ...
          arg_2 .* c_2[5])));

    c_1 = x[index_2];
    c_2 = c_1 - 3*pi/4;
    y[index_2] = sqrt(2./(pi*c_1)).*(p_1.*sin(c_2) + arg_1.*p_2.*cos(c_2));

  }

  return y;
};

//
//  This is an adaptive 4th-order Runge-Kutta integrator.
//  See Numerical Recipes.
//

static (rk4, collapse);

ode4 = function( ydot, t0, tf, y0, output, tol, h, yscale ) 
{
  global (eps)

  TINY = 1e-4;

  //  Supply defaults.
  if (!exist (tol)) { tol = 1e-3; }
  if (!exist (h)) { h = abs( tf - t0 ) / 1000.0; }

  //  Initialize.
  t = t0;
  h = h * ( tf - t0 ) ./ abs( tf - t0 );
  y = y0[:];
  I = 2;

  // Save the initial  conditions

  if (!exist (output)) 
  {
    yout.[1] = [t, y.'];
  else
    yout.[1] = output(t,y).';
  }

  while ( (t-tf)*(tf-t0) < 0.0 ) 
  {

    dydt = ydot( t, y );
    if (!exist (yscale)) { scale = abs(y) + abs(h*dydt) + TINY; }

    //	If the step can overshoot end, cut the stepsize.

    if ( (t+h-tf)*(t+h-t0) > 0.0 ) { h = tf - t; }

    //	Take a step
    ys = y;

    while ( 1 ) 
    {
      //  Take two half steps.

      hh = 0.5 * h;
      yt = rk4( ydot, t, hh, ys, dydt );
      y =  rk4( ydot, t+hh, hh, yt, ydot( t+hh, yt ) );

      //  Check for step too small.

      if ( t+h == t ) 
      {
      	fprintf("stderr", "rlab: run time error: Step size too small in ode4\n");
      	yt = 0.0;
        errmax = 1.0;
        tf = t;
      else
	//  Take the full step.
      	yt = y - rk4( ydot, t, h, ys, dydt );
    
	//  Evaluate accuracy.
    	errmax = norm( abs( yt ) ./ scale, "I" ) / tol;
      }

      //  Success?
      if ( errmax <= 1.0 ) { break; }

      //  Try again.  Reduce step size, but by no more than
      //  a factor of about 50.

      if ( errmax > 4e6 ) 
      {
      	h = 0.02*h;
      else
        h = 0.9*h*errmax.^-0.25;
      }
    }

    t = t + h;

    //	Take care of 5th order.
    y = y + yt./15.0;

    //	Save output at the current point.

    if (!exist (output))
    {
      yout.[I] = [t, y.'];
    else
      yout.[I] = output( t, y ).';
    }
    I++;

    //	Determine next step size.
    if ( errmax > 6e-4 ) 
    {
      h = 0.9*h*errmax.^-0.2;
    else
      h = 4*h;
    }
  }
  return collapse (yout);
};

rk4 = function(ydot, t, h, y, dydt) 
{
  local( k1, k2, k3, k4 );

  k1 = h * dydt;
  k2 = h * ydot( t+h/2, y+k1/2 );
  k3 = h * ydot( t+h/2, y+k2/2 );
  k4 = h * ydot( t+h, y+k3 );

  return y + ( k1 + 2.0*k2 + 2.0*k3 + k4 ) / 6.0;
};

//
// Collapse a LIST of matrices into a single matrix.
//

collapse = function ( LIST )
{
  local (i, m, row, col);

  row = size (LIST.[members (LIST)[1]])[1];
  col = size (LIST.[members (LIST)[1]])[2];
  m = zeros (length (LIST)*row, col);

  for (i in 1:length (LIST))
  {
    m[i;] = LIST.[i];
  }
  return m;
};

//
//  a = trapz(y,x)
//
//  find the area under the curve y = f(x) using the trapezoidal rule
//
//   x = vector containing the independent variable data points
//       the elements of x need not be equally spaced
//   y = f(x) = vector of the function values corresponding to the
//       elements in x
//
//  a = the area under f(x) in the interval defined by x
//

// Written by: Duane Hanselman, University of Maine, (207)-581-2246

trapz = function (y, x)
{
  local (x, y)

  x = x[:]';  // make sure x and y are row vectors 
  y = y[:]';
  ly = length(y);
  lx = length(x);
  if (lx != ly) {
    error(" x and y must be the same length");
  }
  a = 0.5*([0, y] + [y, 0]) .* ([x, 0] - [0, x]);
  a = sum (a[1;2:ly]);
  return a;
};

//-------------------------------------------------------------------//
//  join

//  Syntax: join (s)
//          join (s, delimeter)

//  Description:

//  Join strings/numbers together to form a single string
//
//  s can be any class (list, matrix, vector) containing 
//  string/numeric data to be concatenated together.
//
//  delimiter is an optional string to be stuffed between 
//  strings/numbers.
// 
//  The output is a single string.
//

//  Example 1:
//  > s = ["January","February","March"]
//   s =
//  January   February  March
//  > t = join(s)
//   t =
//  JanuaryFebruaryMarch
//  > t = join(s," ")
//   t =
//  January February March
//  > t = join(s,", ")
//   t =
//  January, February, March
//  
 
//  Example 2:
//  > n = [1,2,3,4,5]
//   n =
//          1          2          3          4          5
//  > t = join(n)
//   t =
//  12345
//  > t = join(n,":")
//   t =
//  1:2:3:4:5
//

//  Example 3:
//  > r.[1] = "My zip code is";
//  > r.[2] = 94720;
//  > t = join(r," ")
//   t =
//  My zip code is 94720
//  >

//  Example 4:
//  > r = getline("file");
//  > line = join(r," ");
//

//  See Also: strsplt, strtod, num2str, getline, sprintf

//  Tzong-Shuoh Yang (tsyang@ce.berkeley.edu)  5/10/94
//
//-------------------------------------------------------------------//

join = function(s,delimiter)
{  
   local (i,del,n,ts,tmp,txt);

   if (exist(delimiter)) {
      if (class(delimiter) != "string") {
         error("Argument delimiter of function join() must be a string");
      }
      del = delimiter;
   else
      del = "";
   }
   
   txt = "";
   
   if (class(s) == "list") {
     n = length(s);
     for (i in 1:n) {
        if (class(s.[i])=="num") {
          if (type(s.[i]) == "real") {
             sprintf(tmp,"%g",s.[i]);
          else
             sprintf(tmp,"%g+%gi",real(s.[i]),imag(s.[i]));
          }
          txt = txt + tmp;
        else
          txt = txt + s.[i];       
        }
        if (i < n) {
           txt = txt + del;
        }
     }
  else
     ts = s[:];
     for (i in 1:ts.n) {
        if (class(ts[i])=="num") {
          if (type(ts[i]) == "real") {
             sprintf(tmp,"%g", ts[i]);
          else
             sprintf(tmp,"%g+%gi",real(ts[i]),imag(ts[i]));
          }        
          txt = txt + tmp;
        else
          txt = txt + ts[i];       
        }
        if (i < ts.n) {
           txt = txt + del;
        }
     }    
  }
  return txt;
};

%SP_STZCR Short-time zero crossings.

%       [Y,TSCALE] = SP_STZCR(X,FRAME,OVERLAP,FS) computes the
%       short-time zero-crossing rate of X using a frame size
%       of LENGTH and a percentage OVERLAP between successive
%       frames using a rectangular data window.  The sampling
%       frequency is given by FS. The short-time zero-crossing
%       curve is returned in Y and a time scale corresponding
%       to the end of the data frame is returned in TSCALE.
%       The curve may be displayed with the command
%       'plot(y,tscale)'.
%
%       See also: STMAG, STENG, AVSMOOTH, MDSMOOTH

%       Matlab original by:
%       LT Dennis W. Brown 7-11-93, DWB 11-11-94
%       Naval Postgraduate School, Monterey, CA
%       May be freely distributed.
%       Not for use in commercial products.

%       Ref: Rabiner & Schafer, Digital Processing of Speech
%       Signals, 1978, ss 4.3, pp 127-130.

% window argument is not used but is here to maintain consistency with
% the other sp_ routines.

static (sgn)

stzcr = function (x, frame, overlap, fs, win)
{
  local (x, frame, overlap, fs, win)

  % default values
  y = [];
  tscale = [];

  % must have at least 3 args
  if (nargs < 4)
  {
    error("sp_stzcr: Requires first four arguments.");
  }

  % figure out if we have a vector
  if (min(size(x)) != 1)
  {
    error("sp_stzcr: Input arg \"x\" must be a 1xN or Nx1 vector.");
  }
  
  % work with Nx1 vectors
  x = x[:];

  % variables
  Ns = length(x);                             % number of samples
  N = floor(fs * frame);                      % samples per frame
  Ndiff = floor(N * (1 - overlap/100));       % samples between windows
  L = floor((Ns-N)/Ndiff);                    % number of windows
  y = zeros(L,1);                             % space for answer
  tscale = zeros(L,1);                        % space for time

  % use the absolute value of x
  t = abs( sgn( x[2:Ns;1] ) - sgn( x[1:Ns-1;1] ) );

  % windows with overlap
  for (k in 1:L)
  {
    s1 = (k-1) * Ndiff + 1;                     % start of window
    tscale[k;1] = k * Ndiff/fs;
    y[k;1] = sum(t[s1:s1+N-1;1])/2/N;
  }

  return << tscale=tscale ; y=y >>;
};


% function y = sgn(x)
%
% Returns the signum function.
%
%         { 1    x >= 0
%    y = {
%         {-1    x < 0
%
% by Dennis W. Brown, Last modified: 7/11/93
% Naval Postgraduate School, Monterey, CA

sgn = function ( x )
{
  y = sign(x);
  y = (y >= 0) + (-1) * (y == -1);
  return y;
};

%AVSMOOTH Median smoothing filter.
%       [y] = AVSMOOTH(X,L) smooths the input vector X using a
%       median filter with a rectangular window of "L" samples.
%
%       See also: SP_STENG, SP_STMAG, SP_STZCR, MDSMOOTH
%

%       Matlab original by:
%       LT Dennis W. Brown 7-11-93, DWB 8-17-93
%       Naval Postgraduate School, Monterey, CA
%       May be freely distributed.
%       Not for use in commercial products.

avsmooth = function ( x , L )
{
  local ( x , L )

  % default output
  y = [];

  % check args
  if (nargs != 2)
  {
    error("avsmooth: Invalid number of input arguments...");
  }

  % figure out if we have a vector
  if (min(size(x)) != 1)
  {
    error("avsmooth: Input arg \"x\" must be a 1xN or Nx1 vector.");
  }

  % work with Nx1 vectors
  x = x[:];

  % number of samples
  Ns = length(x);

  % room for output
  y = zeros(Ns,1);

  % pad ends to compensate for filter length
  x = [zeros(L/2,1); x ; 0 ; zeros(L/2+1,1)];

  % average filter
  for (k in 1:Ns)
  {
    y[k;1] = mean(x[k:k+L-1;1]);
  }

  return y;
};

//
// curve_fit.r
//

// Use a minimization scheme to fit a model to a set of data
// points.

// Create the data...

require rem

x = (0:10:.1)';
y = 3.2.*1.5.^x;

ptitle ("Original Contrived Data");
plot ([x,y]);
pause ();

// Now add some random-ness

rand ("uniform", -max(abs(y))/5, max(abs(y))/5);
y_orig = y;
y = y + rand (size (y));

ptitle ("Original Data with some Random-ness Added");
plot ([x,y]);
pause ();

// Now make up a model function

fmodel = function (a, b, x) { return a.*b.^x; }

// Now make up a cost function

fcost = function ( A ) 
{
  global (x, y)
  return -sum ( abs ((y - fmodel (A[1], A[2], x))).*x); 
}

// Now load the min/max - imizer

rfile mdsmax
rfile nmsmax

#fit = nmsmax (fcost, [1, 1]);
fit = mdsmax (fcost, [1, 1]);

// Plot the result

ptitle ("Original+Random-ness and Fitted Model");
plot ([ x, y, fmodel (fit.x[1], fit.x[2], x) ]);
pause ();

ptitle ("Original and Fitted Model");
plot ([ x, y_orig, fmodel (fit.x[1], fit.x[2], x) ]);

"\tNow compare original model coefficients and fitted"

original = [3.2, 1.5]
fitted = fit.x

difference = [3.2, 1.5] - fit.x

//
// SYMM  SYMM(A) is the symmetric (Hermitian) part of A, (A+A')/2.
//       It is the nearest symmetric (Hermitian) matrix to A in both the
//       2- and the Frobenius norms.
//

symm = function( A )
{
  return (A + A')./2;
};

% LININSRT Linear insertion between neighboring points.
%	[XO,MASK] = LININSRT(X,N) Inserts N points
%	between each two points of the input vector X.
%	N can be a number or a vector with the length
%	equal to length(X)-1.
%	Returns output vector XO with inserted points 
%	and vector MASK of the same size as XO with
%	0 for old elements and for new ones.

%  Kirill Pankratov, kirill@plume.mit.edu
%  01/16/95

lininsrt = function ( x , n )
{
  local ( x , n )

  % Handle input ...................................
  if (nargs < 2) { n = 1; }

  szx = size(x);
  n = n[:];
  ln = length(n);

  if (ln == 1) % If scalar, make a uniform vector
  { 
    c = szx[1] == 1;
    c = (!c) * szx[1] + c * szx[2] - 1;
    n = n[ones(c,1)];
    ln = c;
  }

  % Check that length of n be equal to the number of
  % columns or number of rows of x minus 1.
  c = (ln == szx - 1);
  if (!any(c))
  {
    error("Second argument length must be size(x,1)-1");
  }
  c = c[2] - c[1];

  if (!any(n))  % If no points to be inserted
  {
    xo = x;
    if (c > 0) 
    { 
      mask = zeros(1, szx[2]);
    else
      mask = zeros(szx[1], 1);
    }
    return << xo=xo; mask=mask >>;
  }

  % Check if transposition is needed
  is_transpose = 0;
  if (c > 0)
  {
    x = x';
    is_transpose = 1;
  }
  
  szx = size(x);

  % Check that all values of n are finite and
  % non-negative.
  mask = find( !finite(n) || n < 0 );
  n[mask] = zeros(size(mask));

  % Calculate old and new intervals dx and dxo ........
  dx = diff(x);
  n = n + 1;
  dxo = dx ./ n[;ones(1,szx[2])];
  n = [1; cumsum(n)+1];
  lxo = n[szx[1]];  % Length of the output vector

  % Calculate mask .............................
  mask = zeros(lxo, 1);
  mask[n] = ones(size(n));
  a = cumsum(mask);

  % Calculate output vector (or matrix) ........
  n = ones(lxo-1,1);
  xo = [x[1;]; x[n;]+cumsum(dxo[a[1:lxo-1];])];

  % Make sure "old" values of x are exact
  % (possible round-off error)
  xo[find (mask)] = x;

  mask = !mask; % Invert mask (1 - for new points)

  % Transpose back if necessary ................
  if (is_transpose)
  {
    xo = xo';
    mask = mask';
  }

  return << xo=xo; mask=mask >>;
};

//-------------------------------------------------------------------//

//  Syntax:	diff ( X )
//		diff ( X , k )

//  Description:

//  The function diff computes the difference between adjacent
//  elements in a vector. The function diff merely does:

//	x = x[2:n] - x[1:n-1];

//  If X is a matrix, then the operation is performed on each column
//  of X.

//  The default value for `k' is 1. If k is specified as other than 1,
//  then the operation is performed k times.

//-------------------------------------------------------------------//

diff = function ( X, k )
{
  local (X, k)

  if (!exist (k)) { k = 1; }

  for (i in 1:k)
  {
    m = X.nr; n = X.nc;
    if (m == 1)
    {
      X = X[2:n] - X[1:n-1];
    else
      X = X[2:m;] - X[1:m-1;];
    }
  }
  return X;
};

////-------------------------------------------------------------------//

//  Syntax:  besselj ( ALPHA, X )

//  Description:

//  Besselj is the bessel function of the first kind of order ALPHA.
//  Either ALPHA or X may a vector in which case a vector result of
//  the same dimension is returned.  If both ALPHA and X are vectors
//  a matrix result of dimension length(ALPHA) x length(X) is returned.
//  If either ALPHA or X is a scalar, the other argument may be a matrix
//  and a matrix result of the same dimension is returned.

//-------------------------------------------------------------------//

// See Numerical Recipes in C (second edition)
// Currently only integer order supported.

static (besseljn, besselj0, besselj1);

besselj = function(alph,x) 
{
  global (pi)

  // Checking the class will automatically result in an error if
  // the argument doesn't exist.
  if(class(alph) != "num" || class(x) != "num") {
    error("besselj: argument is non-numeric.");
  }

  if(min(size(alph)) > 1 && min(size(x)) > 1) {
    // Both arguments are matrices.
    error("besselj: only one argument may be a matrix.");
  }

  if(length(alph) == 1) {
    // x is a matrix (or scalar), alph a scalar
    if(alph == 0 || mod(alph,int(alph)) == 0) {
      return besseljn(alph,x);
    else
      error("besselj: fractional orders not yet supported.");
      // return besseljr(alph,x);
    }
  else if(length(x) == 1) {
    // alph is a matrix (or vector), x a scalar
    y = zeros(size(alph));

    // Use integer order routines for integer alph
    inte_ind = find(alph == 0 || mod(alph,int(alph)) == 0);
    frac_ind = complement(inte_ind,1:alph.n);

    if(inte_ind.n) {
      for(index in inte_ind) {
        y[index] = besseljn(alph[index],x);
      }
    }
    if(frac_ind.n) {
      error("besselj: fractional orders not yet supported.");
      // for(index in frac_ind) {
        // y[index] = besseljr(alph[index],x);
      // }
    }
    return y;
  else
    // alph and x are both vectors
    y = zeros(length(alph),length(x));

    // Use integer order routines for integer alph
    inte_ind = find(alph == 0 || mod(alph,int(alph)) == 0);
    frac_ind = complement(inte_ind,1:alph.n);

    if(inte_ind.n) {
      for(index in inte_ind) {
        y[index;] = besseljn(alph[index],x);
      }
    }
    if(frac_ind.n) {
      error("besselj: fractional orders not yet supported.");
      // for(index in frac_ind) {
        // y[index;] = besseljr(alph[index],x);
      // }
    }
    return y;
  }}
};

// In these functions x can be a vector (or matrix), but n
// must be a scalar.

// No argument checking is performed on static functions.

besseljn = function ( n, x ) {

  local(abs_x,y,index,index_1,index_2,index_3,arg,p_1,p_2,p_3, ...
        two_over_x,m,y_2,Norm,even,limit,lim_ind);

  if(n == 0) {
    return besselj0(x);
  else if (n == 1) {
    return besselj1(x);
  else
    // integer order greater than two
    abs_x = abs(x);
    y = zeros(size(x));
    index_1 = find(abs_x > n);
    index_2 = complement(index_1,1:x.n);
    index_3 = find(abs_x == 0);

    index_1 = complement(intersection(index_1,index_3),index_1);
    index_2 = complement(intersection(index_2,index_3),index_2);

    if(index_1.n) {
      arg = x[index_1];

      p_1 = besselj0(arg);
      p_2 = besselj1(arg);
      two_over_x = 2./arg;
      for(index in 1:(n-1)) {
        p_3 = index * (two_over_x .* p_2) - p_1;
        p_1 = p_2;
        p_2 = p_3;
      }
      if(mod(n,2) == 1) {
        index = find(arg < 0.);
        if(index.n) {
          p_3[index] = -p_3[index];
        }
      }
      y[index_1] = p_3;
    }

    if(index_2.n) {
      limit=1.e20;
      arg = x[index_2];
      two_over_x = 2./arg;
      // Downward recurrence from arbitrary starting values.
      // Find a starting upper even index (this give 16 digits
      // of accuracy).
      m = 2*int((n + 16*sqrt(n))/2);
      p_1 = zeros(size(arg));
      p_2 = ones(size(arg));
      Norm = zeros(size(arg));
      y_2 = zeros(size(arg));
      even = 0;
      for(index in m:1:-1) {
        p_3 = index * (two_over_x .* p_2) - p_1;
        p_1 = p_2;
        p_2 = p_3;
        if(even) {
          Norm = Norm + p_2;
        }
        lim_ind = find(abs(p_2) > limit);
        if(!isempty(lim_ind)) {
          p_2[lim_ind] = p_2[lim_ind] / limit;
          p_1[lim_ind] = p_1[lim_ind] / limit;
          Norm[lim_ind] = Norm[lim_ind] / limit;
          if(index < n) {
            y_2[lim_ind] = y_2[lim_ind] / limit;
          }
        }
        even = !even;

        if(index == n) {
          // Save the unnormalized answer, continue looping to get
          // normalization.
          y_2 = p_1;
        }
      }
      // Only need 1*j0(x) so subtract off p_2 after doubling.
      Norm = 2*Norm - p_2;
      y_2 = y_2 ./ Norm;
      
      if(mod(n,2) == 1) {
        index = find(arg < 0.);
        if(index.n) {
          y_2[index] = -y_2[index];
        }
      }
      y[index_2] = y_2;
    }

    if(index_3.n) {
      y[index_3] = zeros(size(index_3));
    }

    return y;
  }}
};

besselj0 = function(x) {
  local(abs_x,index_1,index_2,y,c_1,c_2,arg_1,arg_2,p_1,p_2);

  abs_x = abs(x);

  index_1 = find(abs_x < 8);
  index_2 = complement(index_1,1:x.n);

  // First evaluate using rational approx. for small arguments.

  y = zeros(size(x));

  if(index_1.n) {
    c_1 = [ 57568490574, -13362590354, 651619640.7, ...
           -11214424.18, 77392.33017, -184.9052456];
    c_2 = [ 57568490411, 1029532985, 9494680.718, ...
            59272.64853, 267.8532712];

    arg_1 = x[index_1] .* x[index_1];

    p_1 = c_1[1] + arg_1 .* (c_1[2] + arg_1 .* (c_1[3] + arg_1 .* ...
          (c_1[4] + arg_1 .* (c_1[5] + arg_1 .* c_1[6]))));
    p_2 = c_2[1] + arg_1 .* (c_2[2] + arg_1 .* (c_2[3] + arg_1 .* ...
          (c_2[4] + arg_1 .* (c_2[5] + arg_1))));
    y[index_1] = p_1./p_2;
  }

  // Now evaluate for large arguments using approximating form.

  if(index_2.n) {
    c_1 = [ -0.1098628627e-2, 0.2734510407e-4, ...
            -0.2073370639e-5, 0.2093887211e-6 ];
    c_2 = [ -0.1562499995e-1, 0.1430488765e-3, ...
            -0.6911147651e-5, 0.7621095161e-6, 0.934935152e-7 ];

    arg_1 = 8./x[index_2];
    arg_2 = arg_1 .* arg_1;

    p_1 = 1 + arg_2 .* (c_1[1] + arg_2 .* (c_1[2] + arg_2 .* (c_1[3] + ...
          arg_2 .* c_1[4])));
    p_2 = c_2[1] + arg_2 .* (c_2[2] + arg_2 .* (c_2[3] + arg_2 .* (c_2[4] + ...
          arg_2 .* c_2[5])));

    c_1 = abs_x[index_2];
    c_2 = c_1 - pi/4;
    y[index_2] = sqrt(2./(pi*c_1)).*(p_1.*cos(c_2) - arg_1.*p_2.*sin(c_2));
  }

  return y;
};


besselj1 = function(x) {
  local(abs_x,index_1,index_2,y,c_1,c_2,arg_1,arg_2,p_1,p_2);

  abs_x = abs(x);

  index_1 = find(abs_x < 8);
  index_2 = complement(index_1,1:x.n);

  // First evaluate using rational approx. for small arguments.

  y = zeros(size(x));

  if(index_1.n) {
    c_1 = [ 72362614232, -7895059235, 242396853.1, ...
            -2972611.439, 15704.48260, -30.16036606 ]; 
           
    c_2 = [ 144725228442, 2300535178, 18583304.74, ...
            99447.43394, 376.9991397];

    
    arg_1 = x[index_1];
    arg_2 = arg_1 .* arg_1;

    p_1 = arg_1.*(c_1[1] + arg_2 .* (c_1[2] + arg_2 .* (c_1[3] + arg_2 .* ...
          (c_1[4] + arg_2 .* (c_1[5] + arg_2 .* c_1[6])))));
    p_2 = c_2[1] + arg_2 .* (c_2[2] + arg_2 .* (c_2[3] + arg_2 .* ...
          (c_2[4] + arg_2 .* (c_2[5] + arg_2))));
    y[index_1] = p_1./p_2;
  }

  // Now evaluate for large arguments using approximating form.

  if(index_2.n) {
    c_1 = [ 0.183105e-2, -0.3516396496e-4, 0.2457520174e-5, ...
            -0.240337019e-6 ];
    c_2 = [ 0.04687499995, -0.2002690873e-3, 0.8449199096e-5, ...
            -0.88228987e-6, 0.105787412e-6 ];

    arg_1 = 8./x[index_2];
    arg_2 = arg_1 .* arg_1;

    p_1 = 1 + arg_2 .* (c_1[1] + arg_2 .* (c_1[2] + arg_2 .* (c_1[3] + ...
          arg_2 .* c_1[4])));
    p_2 = c_2[1] + arg_2 .* (c_2[2] + arg_2 .* (c_2[3] + arg_2 .* (c_2[4] + ...
          arg_2 .* c_2[5])));

    c_1 = abs_x[index_2];
    c_2 = c_1 - 3*pi/4;
    arg_2 = sqrt(2./(pi*c_1)).*(p_1.*cos(c_2) - arg_1.*p_2.*sin(c_2));
    index_1 = find(arg_1 < 0);
    if(!isempty(index_1)) {
      arg_2[index_1] = -arg_2[index_1];
    }

    y[index_2] = arg_2;
  }

  return y;
};

//-------------------------------------------------------------------//
// czt.r

// Syntax:	czt ( X , M , W , A )

// Description:

//	czt returns the M element Chirp z-transform, where:
//	M: The number of points in the returned spectrum.
//	W: The "spacing" between points along the z-pane spiral.
//	   A complex number along the unit circle.
//	A: the complex starting point of the evaluated transform.
//	   A complex number along the unit circle.

//	At present X must be a row or column matrix. The column-wise
//	matrix czt operation will be added later.

//      Ian Searle, 10/10/93

//	References:
//	Rabiner, L.R. and B. Gold, Theory and Application of
//	 Digital Signal Processing, Prentice-Hall, Englewood
//	 Cliffs, New Jersey, pp. 393-399, 1975.
//-------------------------------------------------------------------//

czt = function ( _x, M, W, A )
{
  global (pi)

  x = _x;
  if (min (size (x)) != 1) { error ("czt: only vector X allowed"); }
  nr = x.nr; nc = x.nc;

  if (nc == 1) 
  { 
    x = x'; 
    nr = x.nr; nc = x.nc;
    column = 1;
  else
    column = 0;
  }
  N = nc;

  if (!exist (M)) { M = length (x); }
  if (!exist (W)) { W = exp (-1j .* 2 .* pi ./ M); }
  if (!exist (A)) { A = 1; }

  //
  // Compute a power of 2 value for fft()
  //

  L = 1;
  while (L < (N + M - 1)) { L = 2 .* L; }

  //
  // Form the L-point sequence y(n)
  //

  n = 0:(N-1);
  y = [ A.^(-n) .* W.^((n.^2)./2) .* x , zeros (size (N+1:L)) ];

  //
  // Form the L-point sequence v(n)
  //

  n = 0:(M-1);
  v = W.^(-(n.^2)./2);
  v = [v, zeros (size (M+1:(L - N + 1)))];
  n = (L-N+1):(L-1);
  v[(L-N+2):L] = W.^(-((L-n).^2)./2);

  //
  // Convolution
  //

  Y = fft (y, L);
  V = fft (v, L);
  G = V.*Y;
  g = ifft (G, L);

  k = 0:(M-1);
  X = g[1:M] .* W.^((k.^2)./2);

  if (column)
  {
    return X';
  else
    return X;
  }
};

//-------------------------------------------------------------------//

//  Syntax:	tril ( A )
//		tril ( A , K )

//  Description:

//  tril(x) returns the lower triangular part of A.

//  tril(A,K) returns the elements on and below the K-th diagonal of
//  A.

//  K = 0: main diagonal
//  K > 0: above the main diag.
//  K < 0: below the main diag.

//  See Also: triu
//-------------------------------------------------------------------//

tril = function(x, k) 
{
  if (!exist (k)) { k = 0; }
  nr = x.nr; nc = x.nc;
  if(k > 0) 
  { 
    if (k > (nc - 1)) { error ("tril: invalid value for k"); }
  else
    if (abs (k) > (nr - 1)) { error ("tril: invalid value for k"); }
  }

  y = zeros(nr, nc);

  for(i in max( [1,1-k] ):nr) 
  {
    j = 1:min( [nc, i+k] );
    y[i;j] = x[i;j];
  }

  return y;
};

#
# Test dltest2
#

rfile ode23
rfile ode4

#
# Link in the rhs function (builtin)
#

vdpol = dlopen("./dltest2", "VDPolEq")

#
# Create a user-function equivilent
#

uvdpol = function ( t , x ) 
{
  local(xdot);

  xdot[1;1] = x[1] * (1 - x[2]^2) - x[2];
  xdot[2;1] = x[1];
  return xdot;
};

t0 = 0;
tf = 100;
x0 = [0; 0.25];

tic();
out = ode (vdpol, t0, tf, x0);
printf ("DL ode vdpol time = %f\n", toc());

tic();
out = ode (uvdpol, t0, tf, x0);
printf ("UF ode vdpol time = %f\n", toc());

tic();
out23 = ode23 (vdpol, t0, tf, x0);
printf ("DL ode23 vdpol time = %f\n", toc());

tic();
out23 = ode23 (vdpol, t0, tf, x0);
printf ("UF ode23 vdpol time = %f\n", toc());

//
//  Order the symbol table
//

//  Use global array A to hold ordered strings.
i = 0;

order = function ( S )
{
  local(hm, lh, rh);

  if (S.n >= 3)
  {
    hm = int (S.n/2);
    lh = S[1:hm-1];
    rh = S[hm+1:S.n];

    i = i+1;
    A[i] = S[hm];

    # Now call ourselves

    order (lh);
    order (rh);
  else
    if (S.n >= 1)
    {
      i++;
      A[i] = S[1];
    }
    if (S.n == 2)
    {
      i++;
      A[i] = S[2];
    }
    return 1;
  }
};

//-------------------------------------------------------------------//

// Synopsis:    Toeplitz matrix.

// Syntax:	toeplitz ( C )
//		toeplitz ( C , R )

//  Description:

//      The toeplitz function returns a non-symmetric Toeplitz matrix
//      having C as its first column and R as its first
//      row. `toeplitz(C)' is a symmetric (or Hermitian) Toeplitz 
//      matrix. 

//      If the 1st element of C and R do not agree, then C[1] "wins".

//  See also hankel.r
//-------------------------------------------------------------------//

toeplitz = function ( c , r ) 
{
  local(c, r, nc, nr, t, i);

  if (class(c) != "num") 
  {
    error ("toeplitz: Inputs must be numeric");
  }

  c = c[:];                 // Force column-vector.
  nr = length (c);          // No. of rows in t.

  if (!exist (r)) 
  {
    r = c';                 // Symmetric / Hermitian
  else
    if (class(r) != "num") 
    { 
      error ("toeplitz: Inputs must be numeric"); 
    }
  }
  
  r = r[:].';               // Force row-vector.
  nc = length (r);          // No. of columns in t.
  t = zeros (nr, nc);

  for (i in 1:min(nr,nc))
  {
    t[i;i:t.nc] = r[1:r.n-i+1];  // Fill upper triangle rows.
    t[i:t.nr;i] = c[1:c.n-i+1];  // Fill lower triangle columns.
  }
  return t;
};

//---------------------------------------------------------------------------
//  window.r

//  Syntax:	window ( N , wt )

//  Description:

//  Window generates a window function.
//
//  N = length of desired window
//  wt = window type desired
//       "rect" = rectangular      "tria" = triangular (Bartlett)
//       "hann" = Hanning          "hamm"  = Hamming
//       "blac" = Blackman

//  Window returns a row vector containing samples of the desired
//  window.
//---------------------------------------------------------------------------

window = function ( N, wt )
{
  local (m, nn, pn, w)
  global (pi)

  nn = N-1;
  pn = 2*pi*(0:nn)/nn;
  if (wt == "rect")
  {
    w = ones (1, N);
  else if (wt == "tria") {
    m = nn/2;
    w = (0:m)/m;
    w = [w, w[ceil(m):1:-1]];
  else if (wt == "hann") {
    w = 0.5*(1 - cos (pn));
  else if (wt == "hamm") {
    w = .54 - .46*cos (pn);
  else if (wt == "blac") {
    w = .42 -.5*cos (pn) + .08*cos (2*pn);
  else
    disp("Incorrect Window type requested");
  }}}}}

  return w';
};

//-------------------------------------------------------------------//

//  Syntax:	hankel ( C )
//		hankel ( C , R )

//  Description:

//  Hankel(C) is a square Hankel matrix whose first column is C and
//  whose elements are zero below the first anti-diagonal.

//  Hankel(C,R) is a Hankel matrix whose first column is C and whose
//  last row is R.

//  Hankel matrices are symmetric, constant across the anti-diagonals,
//  and have elements H[i;j] = R[i+j-1].  

//  See also toeplitz.r.
//-------------------------------------------------------------------//

hankel = function ( c_ , r_ ) 
{
  local(c, r, nc, h, j, nr);

  if (class(c_) != "num") { error("hankel: Input must be numeric"); }

  c = c_[:];
  nc = length (c);

  if (!exist (r_)) 
  {
    h = zeros (nc, nc);
    for (j in 1:nc) 
    {
      h[1:nc-j+1;j] = c[j:nc];
    }
  else
    if (class (r_) != "num") { error("hankel: Inputs must be numeric"); }
    if (length(c_) != length(r_)) 
    {
      error("hankel: Inputs must have the same length");
    }
    r = r_[:];
    nr = length (r);
    h = zeros (nc, nr);
    if (c[nc] != r[1]) 
    {
      error("hankel: First element of row must match last element of column");
    }
    for (j in 1:nc-1) 
    {
      h[;j] = [c[j:nc-1]; r[1:j]];
    }
    h[;nc] = r;
  }
  return h;
};

#
# plhold_demo.r
# A simple demonstration of plhold().
#

#
# Start a normal plot window.
#

  #  pstart(,,);

#
# Set the limits cause plhold may not have enough
# information to do so itself.
#

  plimits (-3,3,-3,3);

#
# Take care of miscelaneous items
#

  ptitle ("Plhold Demo");
  xlabel ("X");
  ylabel ("Xdot");
  plegend ("Phase-Plane Trajectory");

#
# Set up for ode() usage.
#

  vdpol = function ( t , x ) 
  {
    local(xdot);
  
    xdot[1;1] = x[1] * (1 - x[2]^2) - x[2];
    xdot[2;1] = x[1];
    return xdot;
  };


  t0 = 0; dt = 0.1; x0 = [0.3; 0.25];

#
# Now go into a loop plotting the phase plane as we integrate.
# This is not a very efficient way to integrate, but it is kind
# of fun.
#

  sout = [];
  for (i in 1:200)
  {
    plhold ( (out = ode (vdpol, t0, tf=t0+dt, x0, dt))[;2,3] );
    t0 = tf;
    x0 = out[out.nr;2,3];
    sout = [sout; out];
  }
  plptex ("STOP", out[out.nr;2], out[out.nr;3]);

#
# Calling plhold_off is VERY important, plotting will
# not work afterwords otherwise.
#

  plhold_off ();

  plimits ();

//
//  Calculate Fibonacci numbers
//

"Starting the fibonacci test..."
i=1; 
while ( i < 2 ) { 
  i=i+1;
  a=0; b=1;
  while ( b < 10000 ) {
    c = b;
    b = a+b;
    a = c;
  }
}

b

if ( b != 10946 ) {
  error("failed fibonacci test");
else
"...passed fibonacci test..."
}

//-------------------------------------------------------------------//
//
//  Syntax:     rem ( A, B )

//  Description:

//  Calculate remainders.
//  `mod ( A, B )' is equivilant to `rem ( A, B)'. Mod is a builtin
//  function, and is much faster when operating on matrices. Rem is
//  provided mostly for MATLAB compatibility.

//-------------------------------------------------------------------//

rem = function(x,y) 
{
  # return (x-y.*int(x./y));
  return mod (x, y);
};

//-------------------------------------------------------------------//
//
//  Syntax:	logspace ( L1 , L2 )
//		logspace ( L1 , L2 , n )

//  Description:

//  Generate a logarithmically spaced vector. logspace(L1, L2)
//  generates a vector of 50 points, logarithmically spaced between
//  decades 10^L1 and 10^L2.

//  Logspace(L1, L2, N) generates N points.

//  If L2 is pi, then the generated values are between 10^L1 and pi. 
//-------------------------------------------------------------------//

logspace = function(d1, d2, n) 
{
  global (pi)

  if(!exist (n)) { n = 50; }

  if(d2 == pi) { 
    D2 = log10 (pi); 
  else
    D2 = d2;
  }

  if (n < 2) { error ("logspace: N must be >= 2"); }

  return (10).^ [d1+(0:n-2)*(D2-d1)/(n-1), D2]; 
};

//-------------------------------------------------------------------//

//  Syntax:	mret ( LIST, a, b, c, d, e, f, g, h )

//  Description:

//  The function mret is provided to allow users to use functions that
//  return multiple arguments in a "MATLAB"-like fashion. Mret stands
//  for Matlab RETurn. Proper usage of mret() is best shown with
//  examples: 

//  In MATLAB you might call eig like:

//	[v,d] = eig (a);

//  Using mret you could:

//	mret (eig (a), v="vec", d="val");

//  The above example assigns the list members that eig() returns to
//  the variables `v', and `d'. The values of the strings determine
//  the mapping between RLaB list elements, and user variable names.

//  The list returned by the 1st argument is destroyed after the
//  assignments are complete.

//  If eight return-element mappings are not enough, mret() can easily
//  be expanded.

//-------------------------------------------------------------------//

mret =  function ( L, a, b, c, d, e, f, g, h )
{
  if (class (L) == "list")
  {
    if (exist (a)) {  a = L.[a]; }
    if (exist (b)) {  b = L.[b]; }
    if (exist (c)) {  c = L.[c]; }
    if (exist (d)) {  d = L.[d]; }
    if (exist (e)) {  e = L.[e]; }
    if (exist (f)) {  f = L.[f]; }
    if (exist (g)) {  g = L.[g]; }
    if (exist (h)) {  h = L.[h]; }
  else
    error ("mret: 1st argument must be a list-object");
  }
  clear (L);
};

//-------------------------------------------------------------------//

//  Syntax:	triu ( A )
//		triu ( A , K )

//  Description:

//  triu(x) returns the upper triangular part of A.

//  tril(x; k) returns the elements on and above the k-th diagonal of
//  A. 

//  K = 0: main diagonal
//  K > 0: above the main diag.
//  K < 0: below the main diag.

//  See Also: tril
//-------------------------------------------------------------------//

triu = function(x, k) 
{
  if (!exist (k)) { k = 0; }
  nr = x.nr; nc = x.nc;

  if(k > 0) 
  { 
    if (k > (nc - 1)) { error ("triu: invalid value for k"); }
  else
    if (abs (k) > (nr - 1)) { error ("triu: invalid value for k"); }
  }

  y = zeros(nr, nc);

  for(j in max( [1,1+k] ):nc) 
  {
    i = 1:min( [nr, j-k] );
    y[i;j] = x[i;j];
  }

  return y;
};

//-------------------------------------------------------------------//

//  Syntax:     loaddir ( DIRNAME )

//  Description:

//  loaddir loads all of the Rfiles in the directory DIRNAME. DIRNAME
//  is a string identifying the directory of Rfiles to be loaded. Only
//  files with a postfix of `.r' will be loaded.

//  Example: 
//  > loaddir ("/u1/ian/rlab/testmatrix");
//  > loaddir (".");

//-------------------------------------------------------------------//


loaddir = function ( dir )
{
  local (dir)

  dirnm = "| ls " + dir + "/*.r";
  while (length (fn = getline (dirnm)))
  {
    printf ("\tLoading:\t%s\n", fn.[1]);
    load (fn.[1]);
  }
  close (dirnm);
};

#
# Simplistic convolution function.
# x and y must be vectors...
# No error checking.
#

conv = function( x , y )
{
  local( X , Y , n, tmp );

  n = x.n + y.n - 1;
  X = fft( x, n );
  Y = fft( y, n );

  tmp = ifft( X .* Y );
  if( type(x) == "real" && type(y) == "real") { tmp = real(tmp); }

  return tmp;
};

//-------------------------------------------------------------------//

// Synopsis:   Compute the short-time periodic windowed FFT of a signal.

// Syntax:     spectrogram ( SEQ, FRAMESIZE, NOVERLAP )
//             spectrogram ( SEQ, FRAMESIZE, NOVERLAP, ZEROPAD )

// Description:

//      For each frame, window it with a Hanning window, compute the
//      FFT, remove the negative frequencies, and take the log of
//      the resulting elements.  Then hop ahead by (FRAMESIZE -
//      NOVERLAP) elements to the next frame. 

//      If the ZEROPAD argument is supplied, that many zeros are
//      appended to the frame before computing the FFT.
//      ZEROPAD + FRAMESIZE should be a power of two.

//      The resulting array has (FRAMESIZE+ZEROPAD)/2 rows and a
//      number of columns determined by the framesize and overlap
//      values. Low frequencies come first, i.e. they have low row
//      indices. 

// Sample seq:     seq = readb("somedatafile.rb");
//                 spect = spectrogram(seq, 512, 0);
//                 plmesh(<< x=1:spect.nr; y=1:spect.nc; z=spect >>);

// This file is a translation of spectrogram.m from the Osprey toolbox.
// The results of this function may differ from Matlab's slightly 
// since the Hanning window is computed differently.

require window

//-------------------------------------------------------------------//

spectrogram = function (seq, frameSize, nOverlap, zeroPad)
{
  local (seq, frameSize, nOverlap, zeroPad)

  if (!exist (zeroPad)) { zeroPad = 0; }

  inrows = seq.nr;
  incols = seq.nc;

  if (inrows != 1 && incols != 1)
  {
    error ("Spectrogram requires a 1-dimensional sequence");
  }

  nfft    = frameSize + zeroPad;
  seqsize = max (inrows, incols);
  outcols = floor(1 + (seqsize - frameSize) / (frameSize - nOverlap));
  outrows = nfft / 2;
  result  = zeros (outrows, outcols);

  // column vector
  win  = window (frameSize, "hann");

  for (i in 1:outcols)
  {
    start = 1 + (frameSize - nOverlap) * (i - 1);
    frame = reshape (seq[start:(start + frameSize - 1)], frameSize, 1);

    // column vector
    spectrum = fft (frame .* win, nfft); 
    result[;i] = spectrum [1:outrows];
  }

  // move inside loop if memory problems
  result = log (abs (result));

  return result;
};

//-------------------------------------------------------------------//
//  roots

//  Syntax: roots(P)

//  Description:

//  Find roots of polynomial P of degree n.
//
//  Case 1:
//    P is a vector (row or column) with n+1 components representing
//    polynomial coefficients in descending powers.
// 
//  Case 2:
//    P is a linked-list of n+1 square matrices, the n+1 matrices in P 
//    representing polynomial coefficients in descending powers.
//
//  Return a column vector containing roots of P.

//  Example 1:
//  The following script finds the roots of 
//  x^3 + 3*x^2 + 5 = 0
// 
//  > p=[1,3,0,5]
//   p =
//          1          3          0          5
//  > r=roots(p)
//   r =
//             0.213 - 1.19i
//             0.213 + 1.19i
//                -3.43 + 0i
//  > q=<<1;3;0;5>>;
//  > r=roots(q)
//   r =
//             0.213 - 1.19i
//             0.213 + 1.19i
//                -3.43 + 0i
//  
//  Example 2:
//  Find the damped and undamped frequencies of the following oscillation 
//  system:
//           2
//          d u     du
//        M --- + C -- + K u = 0
//            2     dt
//          dt  
//
//  where M =   5  0.5      C =  5   1      K = 50   10
//            0.5    5           1   5          10   50
//
//  The characteristic equation corresponding to the governing equation
//  is
//        M*s^2 + C*s + K = 0
//
//  > M=[5,0.5;0.5,5]; C=[5,1;1,5]; K=[50,10;10,50];
//  > // undamped frequencies
//  > uf = roots(<<M;zeros(2,2);K>>)
//  >  uf =
//  >        -3.97e-16 - 2.98i
//  >        -3.97e-16 + 2.98i
//  >          2.84e-16 - 3.3i
//  >          2.84e-16 + 3.3i
//  The undamped vibration frequencies are 2.98 and 3.3 rad/s.
//  > // damped frequencies
//  > df = roots(<<M;C;K>>)
//  >  df =
//  >           -0.444 - 2.95i
//  >           -0.444 + 2.95i
//  >           -0.545 - 3.26i
//  >           -0.545 + 3.26i
//  So we know the damped vibration frequencies are 2.95 and 3.26 rad/s.
//
//  Example 3:
//  Same as Example 2, but  C = 35   5
//                               5  35
//                            
//  > M=[5,0.5;0.5,5]; C=[35,5;5,35]; K=[50,10;10,50];
//  > f = roots(<<M;C;K>>)
//  >  f =
//        -5.16
//        -4.82
//        -2.12
//        -1.84
//  All roots are negative real ===> no oscillation but stable. 

//  See Also: poly

//  Tzong-Shuoh Yang 
// (tsyang@ce.berkeley.edu)  5/7/94  scalar polynomial roots
//                           3/2/95  matrix polynomial roots
//
//-------------------------------------------------------------------//
roots = function(P)
{
   local(P);

   if (class(P) == "num") {
     // scalar polynomial
     if (P.n <= 1) {
        error("Argument of roots() is a scalar, not a polynomial.");
     else if (min(size(P)) != 1) {
        error("Argument of roots() must be a column or a row vector.");
     }}
     p = P[:]';
     // trim leading and trailing zeros
     z  = find(p != 0);
     nz = p.n - z[z.n];
     p  = p[z[1]:z[z.n]];
     // find companion matrix
     c = compan(p);
   else if (class(P) == "list") {
     // matrix polynomial
     n = max(strtod(members(P)));
     if (n <= 1) {
        error("Argument list of roots() is not a matrix polynomial.");
     }
     ns = P.[1].nr;
     if (ns != P.[1].nc) {
        error("Argument list components of roots() must be square matrices.");
     }
     for (i in 2:n) {
        if (P.[i].nr != ns || P.[i].nc != ns) {
        error("Argument list components of roots() must be the same size.");        
        }
     }
     // find leading and trailing zero matrices
     z = [];
     for ( i in 1:n) {
       if (any((P.[i] != 0)[:])) {
          z = [z,i];
       }
     }
     nz = (n - z[z.n])*ns;     
     // find companion matrix c
     n0 = z[1];
     n1 = z[z.n];
     P.[n0] = factor(P.[n0],"g");
     for (i in (n0+1):n1) {
         P.[i] = -backsub(P.[n0], P.[i]);
     }
     n2 = (n1-n0)*ns;
     c = zeros(n2,n2);
     for (i in 1:(n2-ns)) {
        c[i;ns+i] = 1;
     }
     j = (n2-ns+1):n2;
     k = j;
     for(i in (n0+1):n1) {
        c[j;k] = P.[i];
        k = k - ns;
     }
   else {
     error("Wrong argument class in roots().");
   }}}   
   // find roots and stuff with trailing zero(s)
   r = [zeros(nz,1);eign(c).val'];   
   // trim complex part if all real
   if (all(imag(r) == 0)) {
	  r = real(r);
   }
   // if you don't want the roots sorted in ascending order, 
   // comment out the next line
   r = sort(r).val;
   return r;
};

//-------------------------------------------------------------------//

// Synopsis:	print and plot section info

// Syntax:	show_prop ( P , s, coord )

// Description:

//	The properties of polygonal sections may be calculated using rfile
//  section.  These section properties can be shown on the screen by 
//  this rfile.    
//  
//  The (x,y) coordinates of the vertices of the polygon are stored 
//  in P.  P is a two column matrix,  its first column stores xs and
//  its second column stores ys.   The coordinates of the vertces must
//  be stored sequentially for a complete clockwise path around the 
//  polygon.

//  s stores section properties (returned from section.r)

//  If coord is "polar", then the coordinates in P are in polar 
//  coordinates (r,theta), where theta is in degree.
//
// Dependencies
//   rfile plplot.r
//
//  Tzong-Shuoh Yang  8/10/94   (tsyang@ce.berkeley.edu)
//-------------------------------------------------------------------//

show_prop = function(P,s,coord)
{
   local(P,mx,mn,pp,x,y,xp,yp,R,t,T,ps)
   global (pi)

   // if the polygon is not closed, let the last point = 1st point
   if (P[P.nr;1] != P[1;1] || P[P.nr;2] != P[1;2] )
   {
       P = [P;P[1;1],P[1;2]];
   }
   // convert polar coordinates to cartesian coordinates
   if (exist(coord)) 
   {  if (coord == "polar")
      {
         P[;2] = P[;2]*(pi/180);
         P = [P[;1].*cos(P[;2]),P[;1].*sin(P[;2])];
      }
   }
   
   if (s.area < 0) 
   {
     printf(" Area = %g (hole ?)\n\n",s.area);
   else
     printf(" Area = %g\n\n",s.area);
   }
   printf(" Centroid = (%g,%g)\n\n",s.cgx,s.cgy);
   printf(" Moment of Inertia: (Original axis)\n");
   printf("                    Ixx = %g\n",s.Ixx);
   printf("                    Iyy = %g\n",s.Iyy);
   printf("                    Ixy = %g\n\n",s.Ixy);
   printf(" Moment of Inertia: (Centroid axis)\n");
   printf("                    Ixx = %g\n",s.Ixx0);
   printf("                    Iyy = %g\n",s.Iyy0);
   printf("                    Ixy = %g\n\n",s.Ixy0);
   printf(" Moment of Inertia: (Principal axis)\n");
   printf("                    Ixx = %g\n",s.pIxx);
   printf("                    Iyy = %g\n",s.pIyy);
   printf("                  angle = %g (deg)\n\n",s.angle);
   printf(" Polar Moment of Inertia:\n");
   printf("                      J = %g\n\n",s.J0);
   sprintf(ps,"Properties: A=%.3g I#+XX#+=%.3g I#+YY#+=%.3g I#+XY#+=%.3g",...
           s.area,s.Ixx0,s.Iyy0,s.Ixy0);
   
   mx = max(P);
   mn = min(P);
   pp = abs(mx-mn)*0.2;
   plimits(mn[1;1]-pp[1;1],mx[1;1]+pp[1;1],mn[1;2]-pp[1;2],mx[1;2]+pp[1;2]);
   // plaspect(1);
   // plgrid("abcnst","abcnst");
   ptitle(ps);
   xlabel("X");
   ylabel("Y");
   plegend();
   x = [mx[1;1]+pp[1;1]/2,s.cgy;mn[1;1]-pp[1;1]/2,s.cgy];
   y = [s.cgx,mx[1;2]+pp[1;2]/2;s.cgx,mn[1;2]-pp[1;2]/2];
   t = s.angle*pi/180;
   R = [cos(t),sin(t);-sin(t),cos(t)];
   T = [s.cgx,s.cgy;s.cgx,s.cgy];
   xp = (x-T)*R+T;
   yp = (y-T)*R+T;
   if (abs(s.angle) > 0.001) {
      plot(<<P;x;y;xp;yp>>);   
   else
      plot(<<P;x;y>>);
   }
   sprintf(ps," CG(%.3g,%.3g)",s.cgx,s.cgy);
   plptex(ps,s.cgx,s.cgy+pp[1;2]/5,1,0,0);
   plptex(" #+Y",s.cgx,mx[1;2]+pp[1;2]/2,1,0,0);
   plptex(" #+X",mx[1;1]+pp[1;1]/2,s.cgy,1,0,0); 
   if (abs(s.angle) > 0.001) {
      plptex(" #+Y#+'",yp[1;1],yp[1;2],1,0,0);
      plptex(" #+X#+'",xp[1;1],xp[1;2],1,0,0); 
      sprintf(ps," #gh=%.3g#uo",s.angle);
      plptex(ps,s.cgx,s.cgy+pp[1;2],1,0,0);   
   }
};

//
//  RLaB 4th Order Runge-Kutta Integrator
//  Fixed step size.
//  Ian Searle, 6/22/92

//
//  Inputs to rk4()
//  eval:	User-Function to evaluate state-derivative.
//		has arguments (time, y)
//  tzero:    	Start time
//  tfinal:   	Finish time
//  y0:	      	Initial conditions
//  dt:	      	Integration time step

//  Output:   	Matrix of time, and state vector.
//

static (collapse, rrk4);

rk4 = function(eval, tzero, tfinal, y0, dt) 
{
  local(i, y, lout, I);

  y = y0[:];

  lout = << [tzero, y0.'] >>; I = 2;
  for(i in tzero:(tfinal-dt):dt) 
  {
    lout.[I] = [i+dt, (y = rrk4 (y, i, dt, eval))'];
    I++;
  }
  return collapse (lout);
};

rrk4 = function(y, x, h, eval) 
{
  local(i, xh, hh, h6, dydx, dym, dyt, yt, yout);

  // Initialize
  hh = h*0.5;
  h6 = h/6;
  xh = x + hh;

  dydx = eval(x, y);      // 1st step
  yt = y + hh*dydx;

  dyt = eval(xh, yt);     // 2nd step
  yt = y + hh*dyt;

  dym = eval(xh, yt);     // 3rd step
  yt = y + h*dym;
  dym = dym + dyt;

  dyt = eval(x+h, yt);    // 4th step
  yout = y + h6*(dydx + dyt + 2.0*dym);

  return yout;
};

//
// Collapse a LIST of matrices into a single matrix.
//

collapse = function ( LIST )
{
  local (i, m, row, col);

  row = size (LIST.[members (LIST)[1]])[1];
  col = size (LIST.[members (LIST)[1]])[2];
  m = zeros (length (LIST)*row, col);

  for (i in 1:length (LIST))
  {
    m[i;] = LIST.[i];
  }
  return m;
};

//-------------------------------------------------------------------//

// Synopsis:	Companion matrix.

// Syntax:	compan ( P )

// Description:

//	There are three cases.

//	If P is a scalar then COMPAN(P) is the P-by-P matrix COMPAN(1:P+1).
//      If P is an (n+1)-vector, COMPAN(P) is the n-by-n companion matrix
//           whose first row is -P(2:n+1)/P(1).
//      If P is a square matrix, COMPAN(P) is the companion matrix
//           of the characteristic polynomial of P, computed as
//           COMPAN(POLY(P)).

//      References:
//      J.H. Wilkinson, The Algebraic Eigenvalue Problem,
//           Oxford University Press, 1965, p. 12.
//      G.H. Golub and C.F. Van Loan, Matrix Computations, second edition,
//           Johns Hopkins University Press, Baltimore, Maryland, 1989,
//           sec 7.4.6.
//      C. Kenney and A.J. Laub, Controllability and stability radii for
//          companion form systems, Math. Control Signals Systems, 1 (1988),
//          pp. 239-256. (Gives explicit formulas for the singular values of
//          COMPAN(P).)

//	This file is a translation of compan.m from version 2.0 of
//	"The Test Matrix Toolbox for Matlab", described in Numerical
//	Analysis Report No. 237, December 1993, by N. J. Higham.

//-------------------------------------------------------------------//

require poly

compan = function ( p )
{
  local (p)

  m = p.nr; n = p.nc;

  if (n == m && n > 1)
  {
    // Matrix argument.
    return $self (poly (p));
  }

  n = max (n,m);
  //  Handle scalar p.
  if (n == 1)
  {
    n = p+1;
    p = 1:n;
  }

  p = p[:]';                    // Ensure p is a row vector.

  // Construct matrix of order n-1.
  if (n == 2)
  {
    A = -p[2]/p[1];
  else
    A = diag(ones(1,n-2),-1);
    A[1;] = -p[2:n]/p[1];
  }

  return A;
};

//-------------------------------------------------------------------//
//LAGRANGE  Lagrange interpolation of arbitrary order. Y = LAGRANGE(TAB,X0,N)
//          returns an N-th order interpolated value from table TAB, looking
//          up X0 in the first column of TAB.

//          NOTE: TAB's 1st column is checked for monotonicity. It is an
//          error to request a value outside the range of the first column
//          of TAB for X0.

//          If the last argument SKIPM is specified, the monotonicity
//          check will be skipped.

//          Original Author: Michael F. Saucier 10-16-87
//-------------------------------------------------------------------//

lagrange = function (tab, x0, N, skipm)
{
  local (dx, i, j, jj, jmin, lden, lnum, ...
         m, n, seq, sig, tab2, y0);

  if (!exist (N)) 
  { 
    error("Wrong number of input arguments."); 
  }

  if (!exist (skipm))
  {
    dx = diff (tab[;1]);
    sig = sign (dx[1]);
    if (any (sign (dx) - sig))
    {
      error("First column of the table must be monotonic.");
    }
  }

  // Check range of 1st column versus x0

  if (tab[1;1] > x0 || tab[tab.nr;1] < x0) 
  {
    error ("lagrange: x0 must be within range of tab");
  }

  i = find (tab[;1] == x0);
  if (i != []) 
  {
    return tab[i;2];
  }

  m = tab.nr; n = tab.nc;
  jmin = min(max(min(find(tab[;1] > x0))-fix((N+1)/2),1),m-N);
  tab2 = tab[jmin:jmin+N;];
  jj = 1:N+1;

  seq = x0*ones (1, N+1) - tab2[jj;1]';
  lnum = prod (seq) ./ seq;

  lden = ones (1, N+1);
  for (i in jj)
  {
    for (j in jj)
    {
      if (j != i) 
      {
        lden[i] = lden[i] * (tab2[i;1] - tab2[j;1]);
      }
    }
  }
  
  y0 = sum (lnum' ./ lden' .* tab2[jj;2]);
  return y0;
};

//-------------------------------------------------------------------//
//
//  Syntax:	rank ( A )
//		rank ( A , tol )

//  Description:

//  Compute the rank of the matrix A. Rank returns the number of
//  singular values that are larger than:
//        max( size(x) ) * norm(x,"2") * eps. 

//  If the user specifies tol, the the number of singular values
//  larger than tol is returned.

//-------------------------------------------------------------------//

rank = function(x, tol)
{
  global (eps)

  s = svd(x);
  if (!exist (tol))
  { 
    tol = max(size(x)) * norm(x,"2") * eps;
  }
  return sum(s.sigma > tol);
};

#
# Perform integration tests to determine the effect
# of relerr, and abserr on the solution.
#

vdpol = function ( t , x ) 
{
  local (xp)
  xp = zeros(2,1);
  xp[1] = x[1] * (1 - x[2]^2) - x[2];
  xp[2] = x[1];
  return xp;
};

t0 = 0;
tf = 10;
x0 = [0; 0.25];
dtout = 0.05;

relerr = [1e-6, 1e-5, 1e-4, 1e-3, 1e-2, 1e-1];
abserr = relerr;

#
# Baseline
#

xbase = ode( vdpol, 0, 20, x0, 0.05, 1e-9, 1e-9);
results = zeros (relerr.n, abserr.n);
elapse = zeros (relerr.n, abserr.n);

"start testing loop"
for (i in 1:abserr.n)
{
  xode.[i] = <<>>;
  for (j in 1:relerr.n)
  {
    printf("\t%i %i\n", i, j);
    tic();
    xode.[i].[j] = ode( vdpol, 0, 20, x0, 0.05, relerr[j], abserr[i]);
    elapse[i;j] = toc();

    # Save results
    results[i;j] = max (max (abs (xode.[i].[j] - xbase)));
  }
}

results

//-------------------------------------------------------------------//
//  complement

//  Syntax:	complement ( A , B )

//  Description:

//  The complement function returns a vector-set that contains the
//  complement of A in B. In plain English: the elements of B that are
//  not in A.

//  See Also: intersection, set, union

//-------------------------------------------------------------------//

complement = function ( A, B )
{
  if (A.n == 0) { return [B]; }

  if (min (size (A)) != 1) 
  {
    error ("complement: 1st arg must be a vector");
  }

  if (min (size (B)) != 1) 
  {
    error ("complement: 2st arg must be a vector");
  }

  a = set (A); Comp = set (B);
  for (i in 1:a.n)
  {
    Comp = Comp[ find (a[i] != Comp) ];
  }
  return Comp
};

//
// A simple examples of computing
// A^p, where A is a matrix, and p
// is an integer power.
//

pow = function (a, p)
{
  local (mtmp1, mtmp2);

  if (p > 4)
  {
    mtmp1 = a*a;
    for (i in 1:(p/2 - 2))
    {
      mtmp2 = mtmp1*a;
      mtmp1 = mtmp2;
    }
    mtmp1 = mtmp1*mtmp1;
    if (mod(p,2) != 0) { mtmp1 = mtmp1*a; }
  }
  return mtmp1;
};

//
// @(#) mail.r
//
// ([{
//

// necessarily global parameters:
//   fircoeff
//   nfir
//   nsaved
//   sigsave
//   firout
//   desired
//   iter

// initialize model filter
initfir = function () 
{
  global(niter, fircoeff, nfir, nsaved, sigsave, firout, ...
         desired, iter, ninput, input, weight1, theta1, ...
         weight2, theta2, ndf, nhidden, mu, esquare, output, ...
         nwsave, wsave, skiplimit)

  // model filter parameters
  // fircoeff = [0.2;-0.4;1;-0.6;0.4];	// model filter coefficients
  fircoeff = [1];
  nfir = size(fircoeff)[1];
  nsaved = 20;			        // signal delay line length, must
  // be >= nfir
  rand("default");
  sigsave = rand(nsaved, 1);		// initialize
  
}

// model filter time step
stepfir = function () 
{
  global(niter, fircoeff, nfir, nsaved, sigsave, firout, ...
         desired, iter, ninput, input, weight1, theta1, ...
         weight2, theta2, ndf, nhidden, mu, esquare, output, ...
         nwsave, wsave, skiplimit)
  
  // excitation signal generation
  rand("default");
  //	signal = (rand() > 0.5) * 0.8 + 0.1; // exp
  //	signal = (rand() > 0.5) * 1.8 - 0.9; // tanh
  signal = (rand() > 0.5) * 1.8 - 0.9; // simple
  
  // filter update
  sigsave = [signal; sigsave[1:(nsaved - 1)]];
  firout = sigsave[1:nfir]' * fircoeff;
  
  // nonlinearity
  // firout = tanh(3 * firout);
  // firout = 2 * sin(3 * firout) + firout;
  
  // noise
  rand("normal", 0, 0.1);
  firout = firout + rand();
  
  // impulse noise
  rand("default");
  if (rand() > 0.7) 
  {
    firout = firout + 5;
  }
  
  // what we would like to adapt to
  // desired = firout;
  desired = sigsave[3;];
  
}

bp2init = function () 
{
  global(niter, fircoeff, nfir, nsaved, sigsave, firout, ...
         desired, iter, ninput, input, weight1, theta1, ...
         weight2, theta2, ndf, nhidden, mu, esquare, output, ...
         nwsave, wsave, skiplimit)

  // backprop parameters
  ninput = 10;			// input vector length
  input = zeros(ninput, 1);	// initialize
  ndf = 0;			// number of feedback taps
  nhidden = 10;
  rand("default");
  weight1 = (2 * rand(nhidden, ninput ) - 1) * 0.1;
  theta1  = (2 * rand(nhidden, 1      ) - 1) * 0.1;
  weight2 = (2 * rand(1      , nhidden) - 1) * 0.1;
  theta2  = (2 * rand(1      , 1      ) - 1) * 0.1;
  mu = 1.0;

  // miscellanea
  niter = 20000;
  skiplimit = 0;
  nwsave = niter - skiplimit;
  wsave = zeros(nwsave, 5);
  esquare = 0;
  output = 0;		// so that we can shift the first value into input[]
  
  initfir();
  
}

bp2steps = function (fromiter, toiter, skiplimit) 
{
  global(niter, fircoeff, nfir, nsaved, sigsave, firout, ...
         desired, iter, ninput, input, weight1, theta1, ...
         weight2, theta2, ndf, nhidden, mu, esquare, output, ...
         nwsave, wsave, skiplimit)

  for (iter in fromiter:toiter) 
  {
    
    mu = 0.01 * (niter - iter + 1) / niter;
    
    stepfir();
    
    // reconstrunction filter data generation
    input = [firout; input[1:(ninput - 1)]];
    
    // forward pass
    s1 = weight1 * input + theta1;
    hidden = s1 ./ (1 + abs(s1)); // simple
    s2 = weight2 * hidden + theta2;
    output = s2 ./ (1 + abs(s2)); // simple
    
    // error vectors
    e2 = (mu * (1 ./ ((1 + abs(s2)) .* (1 + abs(s2))) + 0.05)) ...
          .* (desired - output); // simple
    e1 = (1 ./ ((1 + abs(s1)) .* (1 + abs(s1))) + 0.05) ...
          .* (weight2' * e2); // simple

    // weight update
    weight1 = weight1 + e1 * input';
    weight2 = weight2 + e2 * hidden';
    
    // threshold update
    theta1 = theta1 + e1;
    theta2 = theta2 + e2;
    
    err = desired - output;
    esquare = 0.995 * esquare + 0.005 * (err' * err);
    if (iter > skiplimit) 
    {
      wsave[(iter - skiplimit);] = [desired, firout, output, err, esquare];
    }
    
  }
  
}

bp2 = function () 
{
  global(niter, fircoeff, nfir, nsaved, sigsave, firout, ...
         desired, iter, ninput, input, weight1, theta1, ...
         weight2, theta2, ndf, nhidden, mu, esquare, output, ...
         nwsave, wsave, skiplimit)

  iter = 1;
  toiter = 0;
  while (iter < niter) 
  {
    fromiter = toiter + 1;
    toiter = fromiter + 999;
    if (toiter > niter) 
    {
      toiter = niter;
    }
    
    bp2steps(fromiter, toiter, skiplimit);
    
    printf("Iteration %d: esquare = %g,\n", iter, esquare);
    printf("   weight1^2 = %g, theta1^2 = %g,\n", ...
               trace(weight1 * weight1'), theta1' * theta1);
    printf("   weight2^2 = %g, theta2^2 = %g\n", ...
               weight2 * weight2', theta2' * theta2);
  }
  
  plotdata = [((skiplimit + 1):niter)', wsave];
  
  plgrid();
  ptitle ( "RLaB Neural Net Example (contributed)" );
  xlabel ( "" );
  ylabel ( "" );
  plot(plotdata[nwsave-100:nwsave;]);
  
}

//-------------------------------------------------------------------//

//  Syntax:	disp ( S )

//  Description:

//  The disp function does two things,

//  1) If the argument is a matrix, it prints the matrix without the
//  variable label to the standard output.

//  2) If the argument is a string, it prints the string to the
//  standard output.

//-------------------------------------------------------------------//

disp = function ( S )
{
  if (class (S) == "string")
  {
    fprintf ("stderr", "%s\n", S[1]);
  else if (class (S) == "num") {
    S + 0 ?
  }}

  return 1;
};

//
// Modified Gram-Schmidt
// Given A (MxN), with rank(A) = N. The following algorithm computes
// the factorization A = Q*R (skinny QR) where Q (MxN) has orthonormal
// columns and R (NxN) is upper triangular
//
// From MATRIX Computations, G.H. Golub, C.F. Van Loan (page 219)
// 

mgs = function(A)
{
  local (A)

  m = A.nr;
  n = A.nc;
  for(k in 1:n)
    {
      r[k;k] = norm( A[1:m;k], "2");
      q[1:m;k] = A[1:m;k]/r[k;k];
      for(j in k+1:n)
	{
	  r[k;j] = q[1:m;k]' * A[1:m;j];
          A[1:m;j] = A[1:m;j] - q[1:m;k] * r[k;j];
        }
     }
  return << q = q; r = r >>;
};

#
# New plot.r for use with PLPLOT library.
# The help files for these functions are in
# misc/plhelp
#

# plplot.r

# This file is a part of RLaB ("Our"-LaB)
# Copyright (C) 1994  Ian R. Searle

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

# See the file ../COPYING

#
# If your system does not deal with Infs and NaNs well, then
# uncomment the following lines.
#

# static (isinf, isnan)
#
# isinf = function ( A ) { return (0); };
# isnan = function ( A ) { return (0); };

static (WIN)		# The static plot window structure
static (P)		# The active/current plot window

#
# Maintain the transformations for 3-D plots.
#

static (basex, basey, height)
basex = 2;
basey = 2;
height = 4;

#
# Static (private) functions. For use from within
# this file only.
#

static (create_plot_object)
static (check_plot_object)
static (xy_scales)
static (x_scales)
static (y_scales)
static (z_scales)
static (XYZ_scales)
static (list_scales)
static (list_sort)
static (hist_scales)
static (plot_matrix)
static (plot_list)
static (check_3d_list)
static (find_char)
static (get_style)
static (make_legend)
static (plhold_first)

#
# Defaults
#

static (grid_x_default, grid_y_default)
static (grid_3x_default, grid_3y_default, grid_3z_default)

grid_x_default = "bcnst";
grid_y_default = "bcnstv";
grid_3x_default = "bnstu";
grid_3y_default = "bnstu";
grid_3z_default = "bcdmnstuv";

static (subplot_f)
subplot_f = 0;

#
# Create the default plot-object.
# Initialize to all the default values
#

if (!exist (WIN)) 
{
  # Create the plot-object list
  WIN = <<>>;
}

create_plot_object = function ( N, nx, ny )
{
  if (!exist (N)) { N = 0; }
  
  pobj = <<>>;
  pobj.subplot = 0;		# The current subplot no.
  pobj.nplot = nx*ny;		# Total no. of plots on window
  
  pobj.fontld = 0;		# Loaded extended fonts?
  
  for (i in 1:(nx*ny))
  {
    pobj.style.[i] = "line";	# The type/style of plot to draw
    pobj.pstyle[i] = 1;	        # The point-style
    pobj.nbin[i] = 1j;          # The number of bins for a histogram
    pobj.width[i] = 1;		# The pen width for current plot
    pobj.font[i] = 1;		# The current font
    pobj.xlabel[i] = "";
    pobj.ylabel[i] = "";
    pobj.zlabel[i] = "";
    pobj.title[i] = "";
    pobj.orientation[i] = "portrait";
    pobj.desc.[i] = "default";		# The legend description
    pobj.gridx[i] =  grid_x_default;	# Plot axes style, 2D-X
    pobj.gridy[i] =  grid_y_default;	# Plot axes style, 2D-Y
    pobj.grid3x[i] = grid_3x_default;	# Plot axes style, 3D-X
    pobj.grid3y[i] = grid_3y_default;	# Plot axes style, 3D-Y
    pobj.grid3z[i] = grid_3z_default;	# Plot axes style, 3D-Z
    pobj.aspect[i] = 0;		        # Plot aspect style
    pobj.alt[i] = 60;
    pobj.az[i] = 45;
    
    pobj.xmin[i] = 1j;
    pobj.xmax[i] = 1j;
    pobj.ymin[i] = 1j;
    pobj.ymax[i] = 1j;
    pobj.zmin[i] = 1j;
    pobj.zmax[i] = 1j;
    
    pobj.page.xp = 0;
    pobj.page.yp = 0;
    pobj.xleng = 400;
    pobj.yleng = 300;
    pobj.xoff = 200;
    pobj.yoff = 200;

    for (j in 1:14) { pobj.color[i;j] = j; }       
    for (j in 1:8)  { pobj.lstyle[i;j] = j; }
  }
  
  #
  # Save the newly generated plot-object
  # in a list of plot-objects.
  
  WIN.[N] = pobj;
};

##############################################################################
#
# Check to make sure a plot-object exists. If one
# does not exist, create it.
#

check_plot_object = function ()
{
  if (length (WIN) == 0)
  {
    pstart();
    return 0;
  }
  return 1;
};

##############################################################################
#
# Set the current plot window
# Default value = 0
#

pwin = function ( N )
{
  check_plot_object ();
  if (!exist (N)) { N = 0; }
  
  # Check to make sure N is valid
  
  for (i in members (WIN))
  {
    if (N == strtod (i))
    {
      _plsstrm (N);
      return P = N;
    }
  }
  printf ("pwin: invalid argument, N = %i\n", N);
  printf ("      valid values are:\n");
  WIN?
};

##############################################################################
#
# Show the current plot-window, and the possibilities
#

showpwin = function ( all )
{
  if (length (WIN) == 0)
  {
    printf ("No plot objects\n");
    return 0;
  }
  
  printf ("Current plot-window is:\t\t%i\n", P);
  printf ("Available plot windows are:\t");
  for (i in members (WIN))
  {
    printf ("%s   ", i);
  }
  printf ("\n");

  if (exist (all))
  {
    for (i in members (WIN.[P]))
    {
      WIN.[P].[i]
    }
  }
};

getplot = function ( win_no )
{
  local (win_no)

  if (length (WIN) != 0)
  {
    if (!exist (win_no)) { win_no = P; }

    if (exist (WIN.[win_no]))
    {
      return (WIN.[win_no]);
    else
      return 0;
    }
  }
  return <<>>;
};


##############################################################################
#
# Set/start/select the plot device
#

pstart = function ( nx, ny, dev )
{
  if (!exist (nx)) { nx = 1; }
  if (!exist (ny)) { ny = 1; }
  if (!exist (dev)) { dev = "?"; }
  
  # Create the plot-object
  # First, figure out the index
  if (!exist (P))
  {
    P = 0;
  else
    P = P + 1;
  }
  
  create_plot_object (P, nx, ny);
  _plsstrm (P);
  
  #_plscolbg (255,255,255); # white
  # Default window size for X
  _plspage (0, 0, 400, 300, 200, 200);
  
  # Start up the plot-window
  _plstart (dev, nx, ny);
  
  _plwid (8);
  
  # Turn between plot pause off
  _plspause (0);
  _pltext ();
  
  return P;
};

##############################################################################
#
# Close a plot device. We must destroy the current plot-object
# And switch the output stream back to the default.
#

pclose = function ()
{
  if (size (WIN) > 1)
  {   
    #
    # Clear WIN.[P] and reset P to 1st plot-window
    #

    clear (WIN.[P]);
    _plend1 ();
    _plsstrm (strtod (members (WIN)[1]));
    P = strtod (members (WIN)[1]);
    return P;

  else if (size (WIN) == 1) {

    if (exist (WIN.[P])) 
    { 
      clear (WIN.[P]); 
      clear (P);
    }
    _plend1 ();
    return 1;

  else if (size (WIN) == 0) {

    return 0;

  } } }
};

##############################################################################
#
# Close ALL the plot-windows
#

pend = function ()
{
  _plend ();
  if (exist (WIN)) { clear (WIN); }
  if (exist (P)) { clear (P); }
  WIN = <<>>;
};

##############################################################################
#
# Change plot aspect ratio
#

plaspect = function ( aspect )
{
  check_plot_object ();
  i = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;
  if (!exist (aspect))
  {
    WIN.[P].aspect[i] = 0;
  else
    WIN.[P].aspect[i] = aspect;
  }
};

##############################################################################
#
# Change plot line style
#

plstyle = function ( style )
{
  check_plot_object ();
  i = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;

  if (exist (style)) 
  {
    if (class (style) == "string") 
    {
      WIN.[P].style.[i] = style;
    }
    return 1;
  }
  WIN.[P].style.[i] = "line";  
};

##############################################################################
#
# Get the right value of line-style
#

get_style = function ( STY, K )
{
  local (sty);
  sty = mod(K, STY.n);
  if(sty == 0) 
  { 
    sty = STY.n; 
  }
  return STY[sty];
};

##############################################################################
#
# Change fonts
#

plfont = function ( font )
{
  check_plot_object ();
  i = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;
  
  if (!exist (font)) { font = 1; }
  
  if (WIN.[P].fontld == 0)
  {
    _plfontld (1);
    WIN.[P].fontld = 1;
  }
  
  WIN.[P].font[i] = font;
  return P;
};

##############################################################################
#
# Change pen width
#

plwid = function ( width )
{
  check_plot_object ();
  i = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;
  
  if (!exist (width)) { width = 1; }
  WIN.[P].width[i] = width;
  return P;
};

##############################################################################
#
# Place some text on the plot
#

plptex = function ( text, x , y , dx , dy , just )
{
  if (!check_plot_object ()) 
  {
    printf ("Must use plot() before plptex()\n");
    return 0;
  }
  
  if (!exist (x)) { x = 0; }
  if (!exist (y)) { y = 0; }
  if (!exist (dx)) { dx = abs(x)+1; }
  if (!exist (dy)) { dy = 0; }
  if (!exist (just)) { just = 0; }
  
  _plptex (x, y, dx, dy, just, text);
};

##############################################################################
#
# Set up the viewing altitude for 3-D plots
#

plalt = function ( ALT )
{
  check_plot_object ();
  i = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;

  if (exist (ALT)) 
  { 
    WIN.[P].alt[i] = ALT; 
  else
    WIN.[P].alt[i] = 60;
  }
  return P;
};

##############################################################################
#
# Set the viewing azimuth for 3-D plots
#

plaz = function ( AZ )
{
  check_plot_object ();
  i = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;

  if (exist (AZ)) 
  { 
    WIN.[P].az[i] = AZ; 
  else
    WIN.[P].az[i] = 45;
  }
  return P;
};

##############################################################################
#
# Find a character in a string
#

find_char = function ( str , char )
{  
  tmp = strsplt (str);
  for (i in 1:tmp.n)
  {
    if (tmp[i] == char) 
    {
      return i;
    }
  }
  return 0;
};

##############################################################################
#
# Sort list element names/labels by numeric order, then string order.
#

list_sort = function ( L )
{
  tl = <<>>;
  j = k = 1;

  for (i in members (L))
  {
    if (!isnan (strtod (i)))
    {
      num[j] = i;
      j++;
      else
      char[k] = i;
      k++;
    }
  }
  
  # Sort the numeric labels
  
  if (exist (num))
  {
    num = sort (strtod (num)).val;
    tl.num = num;
  }

  if (exist (char))
  {
    tl.char = char;
  }

  return tl;
};

##############################################################################
#
# Set the subplot, this overides the action in plot().
#

subplot = function ( sub )
{
  check_plot_object ();
  
  if (!exist (sub))
  {
    subplot_f = 0;
    _pladv (0);
  else
    if (sub > WIN.[P].nplot)
    {
      error ("Current window does not have this many subplots");
    }
    if (sub > 0)
    {
      WIN.[P].subplot = sub - 1;
      subplot_f = 1;
      _pladv (sub);
    else
      if (sub == 0)
      {
        # Do not advance, stay at current subplot
        WIN.[P].subplot = WIN.[P].subplot - 1;
        subplot_f = 1;
      }
    }
  }
};

##############################################################################
#
# Plot the columns of a matrix (X-Y plot).
#
##############################################################################

plot = function ( data, key, textf )
{
  check_plot_object ();
  
  p = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;	# The current index
  if (!exist (key)) { key = 1; }
  if (!exist (textf)) { textf = 1; }

  #
  # Draw the graph
  # Step through the matrix plotting
  # each column versus the 1st
  #
  
  if (class (data) == "num")
  {
    #
    # Set up the plot basics
    #

    if (abs (key) > data.nc)
    {
      error_1 ("plot: KEY argument > M.nc");
    }
    
    _plgra ();
    _plcol (1);
    _pllsty (1);
    _plfont (WIN.[P].font[p]);
    _plwid (WIN.[P].width[p]);

    if (!subplot_f) 
    {
      _pladv (0);        # Advance 1 subplot
    else
      subplot_f = 0;     # The user has set the subplot
    }

    if (WIN.[P].aspect[p] != 0)
    {
      _plvasp (WIN.[P].aspect[p]);
    else
      _plvsta ();
    }
    
    #
    # Compute scale limits
    #

    k = find ((1:data.nc) != abs (key));
    if (key > 0)
    {
      if (data.nc != 1)
      {
	x_scales ( real(data)[;key], p, xmin, xmax );
	y_scales ( real(data)[;k],   p, ymin, ymax );
      else
	x_scales ( (1:data.nr)', p, xmin, xmax );
	y_scales ( real(data),   p, ymin, ymax );
      }
    else if (key < 0) {
      x_scales ( real(data)[;k],   p, xmin, xmax );
      y_scales ( real(data)[;abs(key)], p, ymin, ymax );
    else
      x_scales ( (1:data.nr)', p, xmin, xmax );
      y_scales ( real(data),   p, ymin, ymax );
    } }

    _plwind (xmin, xmax, ymin, ymax);
    _plbox (WIN.[P].gridx[p], 0, 0, WIN.[P].gridy[p], 0, 0);
    if (plot_matrix ( data, key, p, 0, xmin, xmax, ymin, ymax, ymax-ymin ) < 0) 
    {
      return -1;
    }
    
    else if (class (data) == "list") {
      
      _plgra ();
      _plcol (1);
      _pllsty (1);
      _plfont (WIN.[P].font[p]);
      _plwid (WIN.[P].width[p]);

      list_scales ( data, key, p, xmin, xmax, ymin, ymax );

      if (!subplot_f) 
      {
	_pladv (0);        # Advance 1 subplot
      else
	subplot_f = 0;     # The user has set the subplot
      }

      if (WIN.[P].aspect[p] != 0)
      {
	_plvasp (WIN.[P].aspect[p]);
      else
       _plvsta ();
      }
      
      _plwind (xmin, xmax, ymin, ymax);
      _plbox (WIN.[P].gridx[p], 0, 0, WIN.[P].gridy[p], 0, 0);
      if (plot_list ( data, key, p, xmin, xmax, ymin, ymax ) < 0) 
      { 
	return -1;
      }

    else
      error ("plot: un-acceptable argument");
  } }

  _pllsty (1);
  _plcol (1);
  _pllab (WIN.[P].xlabel[p], WIN.[P].ylabel[p], WIN.[P].title[p]);  
  _plflush ();
  if (textf)
  {
    _pltext ();
  }
  
  #
  # Increment the plot no. so that next time
  # we use the correct settings.
  #
  
  WIN.[P].subplot = WIN.[P].subplot + 1;
  return P;
};

#
# plhold:
# Plot some data, and "hold" on for more.
# Plot the data, setting up the plot as usual the first time.
# On subsequent plots do not do any setup, just plot some
# more. plhold_off must be called to finish up.
#

plhold_first = 1;	# True (1) if plhold() has NOT been used.
                        # Or if plhold_off() has been used.
			# False (0) if plhold is in use

static (hxmin, hxmax, hymin, hymax)

plhold = function ( data, key )
{
  check_plot_object ();
  
  p = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;	# The current index
  if (!exist (key)) { key = 1; }
  if (abs (key) > data.nc)
  {
    error_1 ("plot: KEY argument > M.nc");
  }
  
  if (plhold_first)
  {
    if (class (data) == "num")
    {
      #
      # Do the setup ONCE
      #
      hxmin = hxmax = hymin = hymax = 0;
      _plgra ();
      _plcol (1);
      _pllsty (1);
      _plfont (WIN.[P].font[p]);
      _plwid (WIN.[P].width[p]);

      if (!subplot_f) 
      {
	_pladv (0);        # Advance 1 subplot
      else
	subplot_f = 0;     # The user has set the subplot
      }

      if (WIN.[P].aspect[p] != 0)
      {
	_plvasp (WIN.[P].aspect[p]);
      else
	_plvsta ();
      }

      xy_scales ( real(data), p, hxmin, hxmax, hymin, hymax );
      
      k = find ((1:data.nc) != abs (key));
      if (key > 0)
      {
	x_scales ( real(data)[;key], p, xmin, xmax );
	if (data.nc != 1)
	{
	  y_scales ( real(data)[;k],   p, ymin, ymax );
        else
	  y_scales ( (1:data.nr)',   p, ymin, ymax );
	}
      else if (key < 0) {
	x_scales ( real(data)[;k],   p, xmin, xmax );
	y_scales ( real(data)[;abs(key)], p, ymin, ymax );
      else
	x_scales ( (1:data.nr)', p, xmin, xmax );
	y_scales ( real(data),   p, ymin, ymax );
      } }

      _plwind (hxmin, hxmax, hymin, hymax);
      _plbox (WIN.[P].gridx[p], 0, 0, WIN.[P].gridy[p], 0, 0);
      _pllab (WIN.[P].xlabel[p], WIN.[P].ylabel[p], WIN.[P].title[p]);
    else
      error ("plot: un-acceptable argument");
    }
    plhold_first = 0;
  }
  
  if (plot_matrix ( data, key, p, 0, hxmin, hxmax, hymin, hymax, hymax-hymin ) < 0) 
  { 
    return -1; 
  }

  _plcol (1);
  _plflush ();
  _pltext ();

  return P;
};

##############################################################################
#
# Clean up the plotting environment and get ready
# for normal interactive usage.
#

plhold_off = function ( )
{
  p = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;	# The current index
  plhold_first = 1;  
  _plcol (1);
  _plflush ();
  _pltext ();
  WIN.[P].subplot = WIN.[P].subplot + 1;
  return P;
};

##############################################################################
#
# Plot a 3-Dimensional graph. The data is composed in a list, with
# elements `x', `y', and `z'. x and y are single-dimension arrays
# (row or column matrices), and z is a two-dimensional array. The
# array z, is a function of x and y: z = f(x,y). Thus, the values in
# the array x can be thought of a "row-labels", and the values of y
# can be thought of as "column-lables" for the 2-dimensioal array z.
#
# At present plot3 can plot 3 distinct lists. Each list may have
# different X, Y, and Z scales.
#
##############################################################################

plot3 = function ( L31, L32, L33 )
{
  check_plot_object ();

  #
  # 1st check list contents
  #
  
  if (exist (L31)) { check_3d_list (L31); }
  if (exist (L32)) { check_3d_list (L32); }
  if (exist (L33)) { check_3d_list (L33); }
  
  p = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;	# The current index

  #
  # Figure out the scale limits. 
  # Needs improvement!
  #
  
  xmin = xmax = ymin = ymax = zmin = zmax = 0;
  if (exist (L31)) 
  {
    XYZ_scales (L31.x, L31.y, L31.z, p, Xmin, Xmax, Ymin, Ymax, Zmin, Zmax);
    xmin = Xmin; xmax = Xmax;
    ymin = Ymin; ymax = Ymax;
    zmin = Zmin; zmax = Zmax;
  }
  if (exist (L32)) 
  {
    XYZ_scales (L32.x, L32.y, L32.z, p, Xmin, Xmax, Ymin, Ymax, Zmin, Zmax);
    if (Xmin < xmin) { xmin = Xmin; } if (Xmax > xmax) { xmax = Xmax; }
    if (Ymin < ymin) { ymin = Ymin; } if (Ymax > ymax) { ymax = Ymax; }
    if (Zmin < zmin) { zmin = Zmin; } if (Zmax > zmax) { zmax = Zmax; }
  }   
  if (exist (L33)) 
  {
    XYZ_scales (L33.x, L33.y, L33.z, p, Xmin, Xmax, Ymin, Ymax, Zmin, Zmax);
    if (Xmin < xmin) { xmin = Xmin; } if (Xmax > xmax) { xmax = Xmax; }
    if (Ymin < ymin) { ymin = Ymin; } if (Ymax > ymax) { ymax = Ymax; }
    if (Zmin < zmin) { zmin = Zmin; } if (Zmax > zmax) { zmax = Zmax; }
  }
  
  _plgra ();
  _plcol (1);
  _pllsty (1);
  _plfont (WIN.[P].font[p]);
  _plwid (WIN.[P].width[p]);
  
  # basex = 2; basey = 2; height = 4;
  xmin2d = -2.0; xmax2d = 2.0;
  ymin2d = -3.0; ymax2d = 5.0;
  
  _plenv (xmin2d, xmax2d, ymin2d, ymax2d, 0, -2);
  _plw3d (basex, basey, height, xmin, xmax, ymin, ymax, ...
          zmin, zmax, WIN.[P].alt[p], WIN.[P].az[p]);
  _plbox3 (WIN.[P].grid3x[p], WIN.[P].xlabel[p], 0, 0, ...
           WIN.[P].grid3y[p], WIN.[P].ylabel[p], 0, 0, ...
           WIN.[P].grid3z[p], WIN.[P].zlabel[p], 0, 0);
  _plmtex ("t", 1.0, 0.5, 0.5, WIN.[P].title[p]);

  if (exist (L31))
  {
    if (find_char (WIN.[P].grid3x[p], "l"))
    { x = log10 (real (L31.x)); else x = real (L31.x); }
    if (find_char (WIN.[P].grid3y[p], "l"))
    { y = log10 (real (L31.y)); else y = real (L31.y); }
    if (find_char (WIN.[P].grid3z[p], "l"))
    { z = log10 (real (L31.z)); else z = real (L31.z); }
    
    _plcol (2);
    _plot3d (x, y, z, L31.x.n, L31.y.n, 3, 0);
  }
  if (exist (L32))
  {
    if (find_char (WIN.[P].grid3x[p], "l"))
    { x = log10 (real (L32.x)); else x = real (L32.x); }
    if (find_char (WIN.[P].grid3y[p], "l"))
    { y = log10 (real (L32.y)); else y = real (L32.y); }
    if (find_char (WIN.[P].grid3z[p], "l"))
    { z = log10 (real (L32.z)); else z = real (L32.z); }
    
    _plcol (3);
    _pllsty (2);
    _plot3d (x, y, z, L32.x.n, L32.y.n, 3, 0);
  }
  if (exist (L33)) 
  {
    if (find_char (WIN.[P].grid3x[p], "l"))
    { x = log10 (real (L33.x)); else x = real (L33.x); }
    if (find_char (WIN.[P].grid3y[p], "l"))
    { y = log10 (real (L33.y)); else y = real (L33.y); }
    if (find_char (WIN.[P].grid3z[p], "l"))
    { z = log10 (real (L33.z)); else z = real (L33.z); }
    
    _plcol (4);
    _pllsty (3);
    _plot3d (x, y, z, L33.x.n, L33.y.n, 3, 0);
  }
  
  _plflush ();
  _pltext ();
  
  #
  # Increment the plot no. so that next time
  # we use the correct settings.
  #
  
  WIN.[P].subplot = WIN.[P].subplot + 1;
  
  return P;
};

##############################################################################
#
# Plot a 3-Dimensional graph. The data is composed in a list, with
# elements `x', `y', and `z'. x and y are single-dimension arrays
# (row or column matrices), and z is a two-dimensional array. The
# array z, is a function of x and y: z = f(x,y). Thus, the values in
# the array x can be thought of a "row-labels", and the values of y
# can be thought of as "column-lables" for the 2-dimensioal array z.
#
# At present plmesh can plot 3 distinct lists. Each list may have
# different X, Y, and Z scales.
#
##############################################################################

plmesh = function ( L31, L32, L33 )
{
  check_plot_object ();
  
  #
  # 1st check list contents
  #
  
  if (exist (L31)) { check_3d_list (L31); }
  if (exist (L32)) { check_3d_list (L32); }
  if (exist (L33)) { check_3d_list (L33); }
  
  p = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;	# The current index

  #
  # Figure out the scale limits. 
  # Needs improvement!
  #
  
  xmin = xmax = ymin = ymax = zmin = zmax = 0;
  if (exist (L31)) 
  {
    XYZ_scales (L31.x, L31.y, L31.z, p, Xmin, Xmax, Ymin, Ymax, Zmin, Zmax);
    xmin = Xmin; xmax = Xmax;
    ymin = Ymin; ymax = Ymax;
    zmin = Zmin; zmax = Zmax;
  }
  if (exist (L32)) 
  {
    XYZ_scales (L32.x, L32.y, L32.z, p, Xmin, Xmax, Ymin, Ymax, Zmin, Zmax);
    if (Xmin < xmin) { xmin = Xmin; } if (Xmax > xmax) { xmax = Xmax; }
    if (Ymin < ymin) { ymin = Ymin; } if (Ymax > ymax) { ymax = Ymax; }
    if (Zmin < zmin) { zmin = Zmin; } if (Zmax > zmax) { zmax = Zmax; }
  }   
  if (exist (L33)) 
  {
    XYZ_scales (L33.x, L33.y, L33.z, p, Xmin, Xmax, Ymin, Ymax, Zmin, Zmax);
    if (Xmin < xmin) { xmin = Xmin; } if (Xmax > xmax) { xmax = Xmax; }
    if (Ymin < ymin) { ymin = Ymin; } if (Ymax > ymax) { ymax = Ymax; }
    if (Zmin < zmin) { zmin = Zmin; } if (Zmax > zmax) { zmax = Zmax; }
  }

  _plgra ();
  _plcol (1);
  _pllsty (1);
  _plfont (WIN.[P].font[p]);
  _plwid (WIN.[P].width[p]);
  
  # basex = 2; basey = 2; height = 4;
  xmin2d = -2.0; xmax2d = 2.0;
  ymin2d = -3.0; ymax2d = 5.0;
  
  _plenv (xmin2d, xmax2d, ymin2d, ymax2d, 0, -2);
  _plw3d (basex, basey, height, xmin, xmax, ymin, ymax, ...
          zmin, zmax, WIN.[P].alt[p], WIN.[P].az[p]);
  _plbox3 (WIN.[P].grid3x[p], WIN.[P].xlabel[p], 0, 0, ...
           WIN.[P].grid3y[p], WIN.[P].ylabel[p], 0, 0, ...
           WIN.[P].grid3z[p], WIN.[P].zlabel[p], 0, 0);
  _plmtex ("t", 1.0, 0.5, 0.5, WIN.[P].title[p]);

  if (exist (L31))
  {
    if (find_char (WIN.[P].grid3x[p], "l"))
    { x = log10 (real (L31.x)); else x = real (L31.x); }
    if (find_char (WIN.[P].grid3y[p], "l"))
    { y = log10 (real (L31.y)); else y = real (L31.y); }
    if (find_char (WIN.[P].grid3z[p], "l"))
    { z = log10 (real (L31.z)); else z = real (L31.z); }
    
    _plcol (2);
    _plmesh (x, y, z, L31.x.n, L31.y.n, 3);
  }
  if (exist (L32))
  {
    if (find_char (WIN.[P].grid3x[p], "l"))
    { x = log10 (real (L32.x)); else x = real (L32.x); }
    if (find_char (WIN.[P].grid3y[p], "l"))
    { y = log10 (real (L32.y)); else y = real (L32.y); }
    if (find_char (WIN.[P].grid3z[p], "l"))
    { z = log10 (real (L32.z)); else z = real (L32.z); }
    
    _plcol (3);
    _pllsty (2);
    _plmesh (x, y, z, L32.x.n, L32.y.n, 3);
  }
  if (exist (L33)) 
  {
    if (find_char (WIN.[P].grid3x[p], "l"))
    { x = log10 (real (L33.x)); else x = real (L33.x); }
    if (find_char (WIN.[P].grid3y[p], "l"))
    { y = log10 (real (L33.y)); else y = real (L33.y); }
    if (find_char (WIN.[P].grid3z[p], "l"))
    { z = log10 (real (L33.z)); else z = real (L33.z); }
    
    _plcol (4);
    _pllsty (3);
    _plmesh (x, y, z, L33.x.n, L33.y.n, 3);
  }

  _plflush ();
  _pltext ();
  
  #
  # Increment the plot no. so that next time
  # we use the correct settings.
  #
  
  WIN.[P].subplot = WIN.[P].subplot + 1;
  
  return P;
};

##############################################################################
#
# Plot contours. The data is composed in a list, with
# elements `x', `y', and `z'. x and y are single-dimension arrays
# (row or column matrices), and z is a two-dimensional array. The
# array z, is a function of x and y: z = f(x,y). Thus, the values in
# the array x can be thought of a "row-labels", and the values of y
# can be thought of as "column-lables" for the 2-dimensioal array z.
#
##############################################################################

plcont = function ( CL )
{
  check_plot_object ();
  
  #
  # 1st check list contents
  #
  
  if (exist (CL)) { check_3d_list (CL); }

  p = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;	# The current index
  
  #
  # Figure out the scale limits. 
  # Needs improvement!
  #

  xmin = xmax = ymin = ymax = zmin = zmax = 0;
  if (exist (CL)) 
  {
    XYZ_scales (CL.x, CL.y, CL.z, p, Xmin, Xmax, Ymin, Ymax, Zmin, Zmax);
    if (Xmin < xmin) { xmin = Xmin; } if (Xmax > xmax) { xmax = Xmax; }
    if (Ymin < ymin) { ymin = Ymin; } if (Ymax > ymax) { ymax = Ymax; }
    if (Zmin < zmin) { zmin = Zmin; } if (Zmax > zmax) { zmax = Zmax; }
  }

  _plgra ();
  _plcol (1);
  _pllsty (1);
  _plfont (WIN.[P].font[p]);
  _plwid (WIN.[P].width[p]);

  #
  # Set up the 1st viewport for drawing the plot.
  #

  if (!subplot_f) 
  {
    _pladv (0);        # Advance 1 subplot
  else
    subplot_f = 0;     # The user has set the subplot
  }

  _plvpas (0.15, 0.75, 0.15, 0.85, WIN.[P].aspect[p]);
  # _plvpor (0.15, 0.75, 0.15, 0.85);
  _plwind (xmin, xmax, ymin, ymax);
  _plbox (WIN.[P].gridx[p], 0, 0, WIN.[P].gridy[p], 0, 0);

  # Convert the data to log data if necessary.
  if (find_char (WIN.[P].gridx[p], "l"))
  { x = log10 (real (CL.x)); else x = real (CL.x); }
  if (find_char (WIN.[P].gridy[p], "l"))
  { y = log10 (real (CL.y)); else y = real (CL.y); }
  z = real (CL.z);
  
  if (exist (CL.clevel))
  {
    clevel = CL.clevel;
  else
    clevel = linspace(zmin, zmax, 10);
  }

  #
  # Draw the contours
  #

  l = 1;
  for (i in 1:clevel.n)
  {
    k = mod (i-1, 14) + 1;
    j = mod (i-1, 8) + 1;
    _pllsty(j);
    _plcol (1+k);
    if (_plcont (x, y, z, 1, CL.x.n, 1, CL.y.n, clevel[i]))
    {
      llevel[l] = clevel[i];
      l = l + 1;
    }
  }

  #
  # Reset color and draw the labels.
  #

  _plcol (1);
  _pllab (WIN.[P].xlabel[p], WIN.[P].ylabel[p], WIN.[P].title[p]);  

  #
  # Draw the contour legend. Use a new viewport to the right
  # of the contour plot.
  #

  #_plvpas (0.75, 1.0, 0.15, 0.85, WIN.[P].aspect[p]);
  _plvpor (0.75, 1.0, 0.15, 0.85);
  _plwind (0, 1, 0, 1);

  v = 1 - 1/(2*llevel.n);

  for (i in 1:llevel.n)
  {
    xl = [0.1, 0.2, 0.3]';
    yl = [v, v, v]';
    v = v - 1/llevel.n;

    k = mod (i-1, 14) + 1;
    j = mod (i-1, 8) + 1;

    _plcol (1+k);
    _pllsty (j);

    _plline (3, xl, yl);
    sprintf (stmp, "%.2g", llevel[i]);
    plptex (stmp, xl[3]+.1, yl[3], , , 0);
  }

  # Flush  and go back to text mode.
  _plflush ();
  _pltext ();
  
  #
  # Increment the plot no. so that next time
  # we use the correct settings.
  #
  
  WIN.[P].subplot = WIN.[P].subplot + 1;
  
  return P;
};

##############################################################################
#
# Plot 3-D lines, etc...
#

pl3d = function ( X, Y, Z, BR )
{
  local (X, Y, Z, BR)
  check_plot_object ();
  
  p = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;	# The current index

  #
  # Some basic checks
  #

  if ((N = X.n) != Y.n) { error ("pl3d: X and Y must have same length"); }
  if (N != Z.n) { error ("pl3d: X and Z must have same length"); }

  if (!exist (BR)) { BR = N; }
  if (mod (N, BR) != 0) { error ("pl3d: X.n must be divisible by BR"); }
  iBR = int (N / BR);
  if (iBR == 1) { k = N; else k = BR; }

  #
  # Figure out the scale limits. 
  # Needs improvement!
  #
  
  xmin = xmax = ymin = ymax = zmin = zmax = 0;
  XYZ_scales (X, Y, Z, p, xmin, xmax, ymin, ymax, zmin, zmax);

  _plgra ();
  _plcol (1);
  _pllsty (1);
  _plfont (WIN.[P].font[p]);
  _plwid (WIN.[P].width[p]);
  
  if (!subplot_f) 
  {
    _pladv (0);        # Advance 1 subplot
    else
    subplot_f = 0;     # The user has set the subplot
  }

  if (find_char (WIN.[P].grid3x[p], "l"))
  { X = log10 (real (X)); else X = real (X); }
  if (find_char (WIN.[P].grid3y[p], "l"))
  { Y = log10 (real (Y)); else Y = real (Y); }
  if (find_char (WIN.[P].grid3z[p], "l"))
  { Z = log10 (real (Z)); else Z = real (Z); }
    
  # basex = 2; basey = 2; height = 4;
  xmin2d = -2.0; xmax2d = 2.0;
  ymin2d = -3.0; ymax2d = 5.0;
  
  _plvasp (WIN.[P].aspect[p]);
  _plwind (xmin2d, xmax2d, ymin2d, ymax2d);
  _plw3d (basex, basey, height, xmin, xmax, ymin, ymax, ...
          zmin, zmax, WIN.[P].alt[p], WIN.[P].az[p]);
  _plbox3 (WIN.[P].grid3x[p], WIN.[P].xlabel[p], 0, 0, ...
           WIN.[P].grid3y[p], WIN.[P].ylabel[p], 0, 0, ...
           WIN.[P].grid3z[p], WIN.[P].zlabel[p], 0, 0);
  _plmtex ("t", 1.0, 0.5, 0.5, WIN.[P].title[p]);

  _plcol (2);
  for (i in 1:iBR)
  {
    j = [(i-1)*k+1:i*k];
    _plline3 (k, X[j], Y[j], Z[j]);
  }
  _plflush ();
  _pltext ();
  
  #
  # Increment the plot no. so that next time
  # we use the correct settings.
  #
  
  WIN.[P].subplot = WIN.[P].subplot + 1;
  
  return P;
};

##############################################################################
#
# error bar plot
#

plerry = function (x, y, y_low, y_high)
{
  check_plot_object ();
  
  p = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;	# The current index
  WIN.[P].desc.[p] = 1j;    // use own legend
  
  if (x.nr != y.nr || x.nr != y_low.nr || x.nr != y_high.nr) 
  {
    error(" Size inconsistent in plerry.");
  }
  _plgra ();
  _plcol (1);
  _pllsty (1);
  _plfont (WIN.[P].font[p]);
  _plwid (WIN.[P].width[p]);
  xy_scales ( real([x,y,y_low,y_high]), p, xmin, xmax, ymin, ymax );
  
  if (!subplot_f) 
  {
    _pladv (0);        # Advance 1 subplot
  else
    subplot_f = 0;     # The user has set the subplot
  }

  if (WIN.[P].aspect[p] != 0)
  {
    _plvasp (WIN.[P].aspect[p]);
  else
    _plvsta ();
  }

  _plwind (xmin, xmax, ymin, ymax);
  _plbox (WIN.[P].gridx[p], 0, 0, WIN.[P].gridy[p], 0, 0);

  if (plot_matrix ( [x,y], p, 0, xmin, xmax, ymin, ymax, ymax-ymin ) < 0) 
  { 
    return -1; 
  }

  _plcol (3);
  _plerry(x.nr, x, y_low, y_high);
  _plcol (1);
  _pllab (WIN.[P].xlabel[p], WIN.[P].ylabel[p], WIN.[P].title[p]);  
  _plflush ();
  _pltext ();
  
  #
  # Increment the plot no. so that next time
  # we use the correct settings.
  #
  
  WIN.[P].subplot = WIN.[P].subplot + 1;
  return P;      
};

##############################################################################
#
# Plot a Histogram(s), from the columns of a matrix.
#
##############################################################################

plhist = function ( M , nbin )
{
  check_plot_object ();
  
  if (!exist (nbin)) { nbin = 10; }
  
  p = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;	# The current index
  np = M.nr;
  
  # Compute max/min values of data
  
  ymin = min (min (real (M)));
  ymax = max (max (real (M)));
  
  #
  # Check computed scale limits against user's
  #
  
  if (WIN.[P].ymin[p] != 1j) { ymin = WIN.[P].ymin[p]; }
  if (WIN.[P].ymax[p] != 1j) { ymax = WIN.[P].ymax[p]; }

  _plgra ();
  _plcol (1);
  _plfont (WIN.[P].font[p]);
  _plwid (WIN.[P].width[p]);
  
  for (i in 1:M.nc) 
  { 
    hscale[i] = hist_scales (M[;i], nbin);
  }  

  if (!subplot_f) {
    _pladv (0);        # Advance 1 subplot
  else
    subplot_f = 0;     # The user has set the subplot
  }

  if (WIN.[P].aspect[p] != 0)
  {
    _plvasp (WIN.[P].aspect[p]);
  else
    _plvsta ();
  }

  _plwind (ymin, ymax, 0, max (hscale));
  _plbox (WIN.[P].gridx[p], 0, 0, WIN.[P].gridy[p], 0, 0);

  v = max (hscale);
  xmax = ymax;
  for (i in 1:M.nc)
  {
    k = mod (i, 14) + 1;
    _plcol (WIN.[P].color[p;k]);
    _plhist (np, real(M[;i]), ymin, ymax, nbin, 1);
    
    if (!any (any (WIN.[P].desc.[p] == 1j)))
    {
      # Use the default if necessary
      if (WIN.[P].desc.[p][1] == "default") 
      {
	desc = "c"+num2str(i);
      else if (WIN.[P].desc.[p].n >= i) {
	desc = WIN.[P].desc.[p][i];
      else
	# Not sure what to do, user has messed up.
	desc = "";
      } }

      v = v - max(hscale)/11;
      xl = (ymax-ymin)*[10.5/12, 11/12, 11.5/12]' + ymin;
      yl = [v, v, v]';

      _plline (3, xl, yl);
      plptex(desc, xl[1]-(ymax-ymin)/25, yl[3], , , 1);
    }
  }

  _plcol (1);
  _pllab (WIN.[P].xlabel[p], WIN.[P].ylabel[p], WIN.[P].title[p]);  
  _plflush ();
  _pltext ();

  #
  # Increment the plot no. so that next time
  # we use the correct settings.
  #
  
  WIN.[P].subplot = WIN.[P].subplot + 1;

  return 1;
};

##############################################################################
#
# Various support functions for the WIN list
#
##############################################################################

#
# Replot
#

replot = function ( )
{
  check_plot_object ();
  _replot ();
};

##############################################################################
#
# Set the X-axis label
#

xlabel = function ( xstr )
{
  check_plot_object ();
  if (!exist (xstr)) { xstr = ""; }
  i = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;
  WIN.[P].xlabel[i] = xstr;
};

##############################################################################
#
# Set the Y-axis label
#

ylabel = function ( xstr )
{
  check_plot_object ();
  if (!exist (xstr)) { xstr = ""; }
  i = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;
  WIN.[P].ylabel[i] = xstr;
};

##############################################################################
#
# Set the Z-axis label
#

zlabel = function ( xstr )
{
  check_plot_object ();
  if (!exist (xstr)) { xstr = ""; }
  i = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;
  WIN.[P].zlabel[i] = xstr;
};

##############################################################################
#
# Set the plot-title
#

ptitle = function ( xstr )
{
  check_plot_object ();
  if (!exist (xstr)) { xstr = ""; }
  p = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;	# The current index
  WIN.[P].title[p] = xstr;
};

##############################################################################
#
# Set the scale limits.
#

plimits = function ( xmin, xmax, ymin, ymax, zmin, zmax )
{
  check_plot_object ();
  i = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;

  if (exist (xmin)) 
  {
    WIN.[P].xmin[i] = xmin;
  else
    WIN.[P].xmin[i] = 1j;
  }
  if (exist (xmax)) 
  { 
    WIN.[P].xmax[i] = xmax;
  else
    WIN.[P].xmax[i] = 1j;
  }

  if (exist (ymin)) 
  {
    WIN.[P].ymin[i] = ymin;
  else
    WIN.[P].ymin[i] = 1j;
  }
  if (exist (ymax)) 
  {
    WIN.[P].ymax[i] = ymax;
  else
    WIN.[P].ymax[i] = 1j;
  }

  if (exist (zmin)) 
  {
    WIN.[P].zmin[i] = zmin;
  else
    WIN.[P].zmin[i] = 1j;
  }
  if (exist (zmax)) 
  {
    WIN.[P].zmax[i] = zmax;
  else
    WIN.[P].zmax[i] = 1j;
  }
};

##############################################################################
#
# Set 2-D grid styles. A not-so-friendly interface.
#

plgrid = function ( sty_x, sty_y )
{
  check_plot_object ();
  i = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;

  if (exist (sty_x)) 
  { 
    if (class (sty_x) == "string")
    {
      WIN.[P].gridx[i] = sty_x;
    else
      error ("plgrid: requires string argument GRID_STY_X");
    }
  else
    WIN.[P].gridx[i] = grid_x_default;
  }
  if (exist (sty_y)) 
  { 
    if (class (sty_y) == "string")
    {
      WIN.[P].gridy[i] = sty_y;
    else
      error ("plgrid: requires string argument GRID_STY_Y");
    }
  else
    WIN.[P].gridy[i] = grid_y_default;
  }
};

##############################################################################
#
# Set 3-D grid (axis) styles
#

plgrid3 = function ( sty_x, sty_y, sty_z )
{  
  check_plot_object ();
  i = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;
  if (exist (sty_x)) 
  { 
    if (class (sty_x) == "string")
    {
      WIN.[P].grid3x[i] = sty_x;
    else
      error ("plgrid3: requires string argument GRID_STY_X");
    }
  else
    WIN.[P].grid3x[i] = grid_3x_default;
  }
  if (exist (sty_y)) 
  { 
    if (class (sty_y) == "string")
    {
      WIN.[P].grid3y[i] = sty_y;
    else
      error ("plgrid3: requires string argument GRID_STY_Y");
    }
  else
    WIN.[P].grid3y[i] = grid_3y_default;
  }
  if (exist (sty_z)) 
  { 
    if (class (sty_z) == "string")
    {
      WIN.[P].grid3z[i] = sty_z;
    else
      error ("plgrid3: requires string argument GRID_STY_Z");
    }
  else
    WIN.[P].grid3z[i] = grid_3z_default;
  }
};

##############################################################################
#
# A friendlier interface to changing 2-D grid/axis
# styles.
#

plaxis = function ( X_STR, Y_STR )
{
  check_plot_object ();
  i = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;
  
  if (exist (X_STR))
  {
    if (X_STR == "log") { WIN.[P].gridx[i] = "bcngstl"; }
  else
    WIN.[P].gridx[i] = grid_x_default;
  }
  
  if (exist (Y_STR))
  {
    if (Y_STR == "log") { WIN.[P].gridy[i] = "bcngstlv"; }
  else
    WIN.[P].gridy[i] = grid_y_default;
  }
  return P;
};

##############################################################################
#
# Various internal support functions. Eventually these will be static.
#
##############################################################################

#
# Find the X or Y scale limits .
# M can be a multi-column matrix, all columns
# will be used.
#

x_scales = function ( M, p, xmin, xmax )
{  
  #
  # 1st check for un-plottable data
  #
  
  if (any (any (isinf (M))))
  { error ("plot: cannot plot Infs"); }
  if (any (any (isnan (M))))
  { error ("plot: cannot plot NaNs"); }
  
  xmin = min (min (M));
  xmax = max (max (M));
  
  #
  # Check computed scale limits against user's
  #
  
  if (WIN.[P].xmin[p] != 1j) { xmin = WIN.[P].xmin[p]; }
  if (WIN.[P].xmax[p] != 1j) { xmax = WIN.[P].xmax[p]; }

  #
  # Check for potential errors
  #
  
  if (xmin == xmax) 
  { 
    # As good a guess as any
    xmin = xmin - 1;
    xmax = xmax + 1;
  }
  
  #
  # Finally, adjust if log-scales
  #
  
  if (find_char (WIN.[P].gridx[p], "l"))
  {
    if (xmin <= 0 || xmax <= 0) { error ("cannot plot log(x<=0)"); }
    xmin = log10 (xmin);
    xmax = log10 (xmax);
  }
  
  return 1;
};

y_scales = function ( M, p, xmin, xmax )
{
  
  #
  # 1st check for un-plottable data
  #
  
  if (any (any (isinf (M))))
  { error ("plot: cannot plot Infs"); }
  if (any (any (isnan (M))))
  { error ("plot: cannot plot NaNs"); }
  
  xmin = min (min (M));
  xmax = max (max (M));
  
  #
  # Check computed scale limits against user's
  #
  
  if (WIN.[P].ymin[p] != 1j) { xmin = WIN.[P].ymin[p]; }
  if (WIN.[P].ymax[p] != 1j) { xmax = WIN.[P].ymax[p]; }

  #
  # Check for potential errors
  #
  
  if (xmin == xmax) 
  { 
    # As good a guess as any
    xmin = xmin - 1;
    xmax = xmax + 1;
  }
  
  #
  # Finally, adjust if log-scales
  #
  
  if (find_char (WIN.[P].gridy[p], "l"))
  {
    if (xmin <= 0 || xmax <= 0) { error ("cannot plot log(y<=0)"); }
    xmin = log10 (xmin);
    xmax = log10 (xmax);
  }
  
  return 1;
};

z_scales = function ( M, p, xmin, xmax )
{
  
  #
  # 1st check for un-plottable data
  #
  
  if (any (any (isinf (M))))
  { error ("plot: cannot plot Infs"); }
  if (any (any (isnan (M))))
  { error ("plot: cannot plot NaNs"); }
  
  xmin = min (min (M));
  xmax = max (max (M));
  
  #
  # Check computed scale limits against user's
  #
  
  if (WIN.[P].zmin[p] != 1j) { xmin = WIN.[P].zmin[p]; }
  if (WIN.[P].zmax[p] != 1j) { xmax = WIN.[P].zmax[p]; }

  #
  # Check for potential errors
  #
  
  if (xmin == xmax) 
  { 
    # As good a guess as any
    xmin = xmin - 1;
    xmax = xmax + 1;
  }
  
  #
  # Finally, adjust if log-scales
  #
  
  if (find_char (WIN.[P].gridz[p], "l"))
  {
    if (xmin <= 0 || xmax <= 0) { error ("plot: cannot plot log(z<=0)"); }
    xmin = log10 (xmin);
    xmax = log10 (xmax);
  }
  
  return 1;
};

##############################################################################
#
# Find the X and Y scales for a single matrix. (OLD)
#

xy_scales = function ( M, p, xmin, xmax, ymin, ymax )
{  
  #
  # 1st check for un-plottable data
  #
  
  if (any (any (isinf (M))))
  { error ("plot: cannot plot infs"); }
  if (any (any (isnan (M))))
  { error ("plot: cannot plot NaNs"); }
  
  if (M.nc == 1)
  {
    xmin = 1;
    xmax = M.nr;
    ymin = min (M);
    ymax = max (M);
  else
    xmin = min (M[;1]);
    xmax = max (M[;1]);
    ymin = min (min (M[;2:M.nc]));
    ymax = max (max (M[;2:M.nc]));
  }
  
  #
  # Check computed scale limits against user's
  #
  
  if (WIN.[P].xmin[p] != 1j) { xmin = WIN.[P].xmin[p]; }
  if (WIN.[P].xmax[p] != 1j) { xmax = WIN.[P].xmax[p]; }
  if (WIN.[P].ymin[p] != 1j) { ymin = WIN.[P].ymin[p]; }
  if (WIN.[P].ymax[p] != 1j) { ymax = WIN.[P].ymax[p]; }
  
  #
  # Check for potential errors
  #
  
  if (xmin == xmax) 
  { 
    xmin = xmin - 1;
    xmax = xmax + 1;
  }
  
  if (ymin == ymax)
  {
    ymin = ymin - 1;
    ymax = ymax + 1;
  }
  
  #
  # Finally, adjust if log-scales
  #
  
  if (find_char (WIN.[P].gridx[p], "l"))
  {
    if (xmin <= 0 || xmax <= 0) { error ("plot: cannot plot log <= 0"); }
    xmin = log10 (xmin);
    xmax = log10 (xmax);
  }
  if (find_char (WIN.[P].gridy[p], "l"))
  {
    if (ymin <= 0 || ymax <= 0) { error ("plot: cannot plot log <= 0"); }
    ymin = log10 (ymin);
    ymax = log10 (ymax);
  }
  
  return 1;
};

##############################################################################
#
# Find the X, Y and Z scales for a single matrix.
#

XYZ_scales = function ( X, Y, Z, p, xmin, xmax, ymin, ymax, zmin, zmax )
{
  # X - scale
  if (any (any (isinf (X))))
  { error ("cannot plot infs"); }
  if (any (any (isnan (X))))
  { error ("cannot plot NaNs"); }
  
  xmin = min (real (X));
  xmax = max (real (X));
  
  # Y - scale
  if (any (any (isinf (Y))))
  { error ("cannot plot infs"); }
  if (any (any (isnan (Y))))
  { error ("cannot plot NaNs"); }
  
  ymin = min (real (Y));
  ymax = max (real (Y));
  
  # Z - scale
  if (any (any (isinf (Y))))
  { error ("cannot plot infs"); }
  if (any (any (isnan (Y))))
  { error ("cannot plot NaNs"); }
  
  zmin = min (min (real (Z)));
  zmax = max (max (real (Z)));
  
  #
  # Check computed scale limits against user's
  #
  
  if (WIN.[P].xmin[p] != 1j) { xmin = WIN.[P].xmin[p]; }
  if (WIN.[P].xmax[p] != 1j) { xmax = WIN.[P].xmax[p]; }
  if (WIN.[P].ymin[p] != 1j) { ymin = WIN.[P].ymin[p]; }
  if (WIN.[P].ymax[p] != 1j) { ymax = WIN.[P].ymax[p]; }
  if (WIN.[P].zmin[p] != 1j) { zmin = WIN.[P].zmin[p]; }
  if (WIN.[P].zmax[p] != 1j) { zmax = WIN.[P].zmax[p]; }
  
  #
  # Check for potential errors
  #
  
  if (xmin == xmax) 
  { 
    # As good a guess as any
    xmin = xmin - 1;
    xmax = xmax + 1;
  }
  
  if (ymin == ymax) 
  { 
    # As good a guess as any
    ymin = ymin - 1;
    ymax = ymax + 1;
  }
  
  if (zmin == zmax) 
  { 
    # As good a guess as any
    zmin = zmin - 1;
    zmax = zmax + 1;
  }
  
  #
  # Finally, adjust if log-scales
  #
  
  if (find_char (WIN.[P].grid3x[p], "l"))
  {
    if (xmin <= 0 || xmax <= 0) { error ("plot: cannot plot log(x<=0)"); }
    xmin = log10 (xmin);
    xmax = log10 (xmax);
  }
  
  if (find_char (WIN.[P].grid3y[p], "l"))
  {
    if (ymin <= 0 || ymax <= 0) { error ("plot: cannot plot log(y<=0)"); }
    ymin = log10 (ymin);
    ymax = log10 (ymax);
  }
  
  if (find_char (WIN.[P].grid3z[p], "l"))
  {
    if (zmin <= 0 || zmax <= 0) { error ("plot: cannot plot log(z<=0)"); }
    zmin = log10 (zmin);
    zmax = log10 (zmax);
  }
  
  return 1;
};

##############################################################################
#
# Find the X and Y scales for a list of matrices
#

list_scales = function ( data, key, p, Xmin, Xmax, Ymin, Ymax )
{
  once = 1;
  
  for (i in members (data))
  {
    M = real (data.[i]);
    if (class (M) != "num") { continue; }
    
    if (abs (key) > M.nc)
    {
      error_1 ("plot: KEY argument > M.nc");
    }
    
    #
    # 1st check for un-plottable data
    #
    
    if (any (any (isinf (M))))
    { error ("plot: cannot plot infs"); }
    if (any (any (isnan (M))))
    { error ("plot: cannot plot NaNs"); }
    
    k = find ((1:M.nc) != abs (key));
    if (key > 0)
    {
      if (M.nc != 1)
      {
	x_scales ( real(M)[;key], p, xmin, xmax );
	y_scales ( real(M)[;k],   p, ymin, ymax );
      else
	x_scales ( (1:M.nr)', p, xmin, xmax );
	y_scales ( real(M),   p, ymin, ymax );
      }
    else if (key < 0) {
      x_scales ( real(M)[;k],        p, xmin, xmax );
      y_scales ( real(M)[;abs(key)], p, ymin, ymax );
    else
      x_scales ( (1:M.nr)', p, xmin, xmax );
      y_scales ( real(M),   p, ymin, ymax );
    } }

    if (once) 
    { 
      Xmin = xmin; Xmax = xmax; Ymin = ymin; Ymax = ymax; 
      once = 0; 
    }
    if (xmin < Xmin) { Xmin = xmin; }
    if (xmax > Xmax) { Xmax = xmax; }
    if (ymin < Ymin) { Ymin = ymin; }
    if (ymax > Ymax) { Ymax = ymax; }
  }
  
  return 1;
};

##############################################################################
#
# Find the maximum number of elements in a bin for a single 
# column matrix.
#

hist_scales = function ( data, nbin )
{
  dmin = min (real (data));
  dmax = max (real (data));
  dbin = linspace (dmin, dmax, nbin+1);
  binval = zeros (nbin, 1);
  
  for (i in 1:nbin)
  {
    binval[i] = length (find (data >= dbin[i] && data < dbin[i+1]));
  }
  
  return max (binval);
};

##############################################################################
#
# Plot the columns of a matrix (core function)
#
# Notes: This is the core function for plotting a matrix. If the
# matrix is a single column, then the matrix elements are plotted
# versus the row numbers. If it is a multi-column matrix, then
# columns 2:N are plotted versus column 1.
#
# p, K, k and l are indices for plot features.
# p: the current plot index (the plot #)
# K: usually 0. This index is used to start of the line style and
# color index (k = color index, l = line-style index). This is mostly
# used by plot_list, which may call plot_matrix repeatedly.
# k: the line color index. This value determines the line color used
# for each column of data. If K = 0, then k goes like 2:14, then
# flops back to 1:14.
# l: the line style inex. This value determines the line style used
# for each column of data - not the line-type (points, or lines). If
# K = 0, then l goes like 2:8, then flops back to 1:8.
#
##############################################################################

plot_matrix = function ( M, key, p, K, xmin, xmax, ymin, ymax, v )
{
  np = M.nr;
  
  if (M.nc == 1)
  {
    x = 1:M.nr;
    y = real (M);
    k = mod (1+K, 14) + 1;
    l = mod (1+K, 8);
    
    if (find_char (WIN.[P].gridx[p], "l"))
    { x = log10 (x); }
    if (find_char (WIN.[P].gridy[p], "l"))
    { y = log10 (y); }
    
    _plcol (WIN.[P].color[p;k]);
    _pllsty (WIN.[P].lstyle[p;l]);
    
    if (get_style (WIN.[P].style.[p], k-1) == "line") 
    {
      _plline (M.nr, x, y);
    else if (get_style (WIN.[P].style.[p], k-1) == "point") {
      _plpoin (M.nr, x, y, WIN.[P].pstyle[p]+k);
    else if (get_style (WIN.[P].style.[p], k-1) == "line-point") {
      _plline (M.nr, x, y);
      _plpoin (M.nr, x, y, WIN.[P].pstyle[p]+k);
    else {
      _plline (M.nr, x, y);
    }}}}

    #
    # Now do the legend 
    #
    
    if (!any (any (WIN.[P].desc.[p] == 1j)))
    {
      # Use the default if necessary
      if (WIN.[P].desc.[p][1] == "default") 
      {
	desc = "c1";
      else if (WIN.[P].desc.[p].n >= k-1) {
	desc = WIN.[P].desc.[p][k-1];
      else
	# Not sure what to do, user has messed up.
	desc = "";
      } }
             
      v = v - (ymax-ymin)/11;
      xl = (xmax-xmin)*[10.5/12, 11/12, 11.5/12]' + xmin;
      yl = [v, v, v]' + ymin;
      
      if (get_style (WIN.[P].style.[p], k-1) == "line") 
      {
	_plline (3, xl, yl);
      else if (get_style (WIN.[P].style.[p], k-1) == "point") {
	_plpoin (3, xl, yl, WIN.[P].pstyle[p]+k);
      else if (get_style (WIN.[P].style.[p], k-1) == "line-point") {
	_plline (3, xl, yl);
	_plpoin (3, xl, yl, WIN.[P].pstyle[p]+k);
      } } }

      plptex(desc, xl[1]-(xmax-xmin)/25, yl[3], , , 1);
      
    }

  else

    #
    # Check for large column dimension
    #
    
    if (M.nc > 3*M.nr)
    {
      printf (" Plot %i columns and %i rows, are you sure (y/n) ? "...
               , M.nc, M.nr);
      ans = getline ("stdin");
      if (ans.[1] != "y") { return -1; }
    }
    
    ki = find ((1:M.nc) != abs (key));
    for (i in ki)
    {
      if (key > 0)
      {
	x = real (M[;key]);
	y = real (M[;i]);
      else if (key < 0) {
	x = real (M[;i]);
	y = real (M[;abs(key)]);
      else
	x = (1:M.nr)';
	y = real (M[;i]);
      } }

      # Check for log scales, adjust if necessary
      if (find_char (WIN.[P].gridx[p], "l"))
      { x = log10 (x); }
      if (find_char (WIN.[P].gridy[p], "l"))
      { y = log10 (y); }
      
      k = mod (i-1 + K, 14) + 1;
      l = mod (8 + i-2 + K, 8) + 1;
      
      _plcol (WIN.[P].color[p;k]);
      _pllsty (WIN.[P].lstyle[p;l]);
      
      if (get_style (WIN.[P].style.[p], k-1) == "line") 
      {
	_plline (np, x, y);
      else if (get_style (WIN.[P].style.[p], k-1) == "point") {
	_plpoin (np, x, y, WIN.[P].pstyle[p]+k);
      else if (get_style (WIN.[P].style.[p], k-1) == "line-point") {
	_plline (np, x, y);
	_plpoin (np, x, y, WIN.[P].pstyle[p]+k);
      else {
	_plline (np, x, y);
      }}}}

      #
      # Now do the legend 
      #
      
      if (!any (any (WIN.[P].desc.[p] == 1j)))
      {
	# Use the default if necessary
	if (WIN.[P].desc.[p][1] == "default") 
	{
	  desc = "c" + num2str (i);
        else if (WIN.[P].desc.[p].n >= k-1) {
	  desc = WIN.[P].desc.[p][k-1];
        else
	  # Not sure what to do, user has messed up.
	  desc = "";
        }}
             
	v = v - (ymax-ymin)/11;
	xl = (xmax-xmin)*[10.5/12, 11/12, 11.5/12]' + xmin;
	yl = [v, v, v]' + ymin;
	
	if (get_style (WIN.[P].style.[p], k-1) == "line") 
	{
	  _plline (3, xl, yl);
        else if (get_style (WIN.[P].style.[p], k-1) == "point") {
	  _plpoin (3, xl, yl, WIN.[P].pstyle[p]+k);
        else if (get_style (WIN.[P].style.[p], k-1) == "line-point") {
	  _plline (3, xl, yl);
	  _plpoin (3, xl, yl, WIN.[P].pstyle[p]+k);
        }}}
	
	plptex(desc, xl[1]-(xmax-xmin)/25, yl[3], , , 1);
	
      }
    }
  }
  
  return k-1;
};

##############################################################################
#
# Plot all of the matrices in a list on the same plot
#

plot_list = function ( L, key, p, xmin, xmax, ymin, ymax )
{
  k = 0;
  v = ymax - ymin;
  
  #
  # Sort out the list members
  #

  sl = list_sort (L);

  # Plot the list members with numeric labels 1st.
  if (exist (sl.num))
  {
    for (i in sl.num)
    {
      M = L.[i];
      if (class (M) != "num") { continue; }
      if ((k = plot_matrix (M, key, p, k, xmin, xmax, ymin, ymax, v)) < 0) 
      { 
	return k; 
      }
    }
  }

  # Now plot the list members with string labels.
  if (exist (sl.char))
  {
    for (i in sl.char)
    {
      M = L.[i];
      if (class (M) != "num") { continue; }
      if ((k = plot_matrix (M, key, p, k, xmin, xmax, ymin, ymax, v)) < 0) 
      { 
	return k; 
      }
    }
  }
  return 1;
};

##############################################################################
#
# Check the elements of LIST.
# LIST must contain elements `x', `y',
# and `z'
#

check_3d_list = function ( LIST )
{
  #
  # Check existence and types
  #
  
  if (class (LIST) != "list") {
    error ("plot3: argument must be a list");
  }
  if (!exist (LIST.x)) {
    error ("plot3: arg must contain `x' member");
  else if (class (LIST.x) != "num") {
    error ("plot3: x must be numeric");
  } }
  if (!exist (LIST.y)) {
    error ("plot3: arg must contain `y' member");
  else if (class (LIST.y) != "num") {
    error ("plot3: y must be numeric"); 
  } }
  if (!exist (LIST.z)) {
    error ("plot3: arg must contain `z' member");
  else if (class (LIST.z) != "num") {
    error ("plot3: z must be numeric");
  } }

  #
  # Check sizes
  #
  
  if (LIST.x.n != LIST.z.nr) 
  {
    error ("plot3: x.n != z.nr");
  }
  
  if (LIST.y.n != LIST.z.nc) 
  {
    error ("plot3: y.n != z.nc");
  }
  
};

##############################################################################
#
# A special type of histogram plot.
#

plhistx = function ( M , nbin )
{
  check_plot_object ();
  
  if (!exist (nbin)) { nbin = 10; }
  
  p = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;	# The current index
  np = M.nr;
  
  # Compute max/min values of data
  
  ymin = min (min(real (M)));
  ymax = max (max(real (M)));
  
  #
  # Check computed scale limits against user's
  #
  
  if (WIN.[P].ymin[p] != 1j) { ymin = WIN.[P].ymin[p]; }
  if (WIN.[P].ymax[p] != 1j) { ymax = WIN.[P].ymax[p]; }
  
  _plgra ();
  _plcol (15);
  _plfont (WIN.[P].font[p]);
  _plwid (WIN.[P].width[p]);
  
  dbin = (linspace (ymin, ymax, nbin+1))';
  for (j in 1:M.nc) 
  {
    // counting
    for (i in 1:nbin) 
    {
      binval[i;j] = length (find (M[;j] >= dbin[i] && M[;j] < dbin[i+1]));
    }
  }
  
  if (!subplot_f) {
    _pladv (0);        # Advance 1 subplot
  else
    subplot_f = 0;     # The user has set the subplot
  }

  if (WIN.[P].aspect[p] != 0)
  {
    _plvasp (WIN.[P].aspect[p]);
  else
    _plvsta ();
  }

  xmin = 0;
  xmax =  max(max(binval));
  _plwind (ymin, ymax, xmin, xmax);
  _plbox (WIN.[P].gridx[p], 0, 0, WIN.[P].gridy[p], 0, 0);

  #
  # Now reorganize dbin and binval so we plot points in
  # the middle of the bins.
  #

  delbin = abs(dbin[2] - dbin[1]);
  dbin = (linspace (ymin+delbin/2, ymax-delbin/2, nbin))';
  dbin = [ymin ; dbin ; ymax];
  binval = [zeros(1,binval.nc); binval; zeros(1,binval.nc)];

  v = xmax;
  for (i in 1:M.nc)
  {
    k = mod (i, 14) + 1;
    l = mod (i,  8) + 1;
    _plcol (WIN.[P].color[p;k]);
    _pllsty (WIN.[P].lstyle[p;l]);
    
    if      (get_style (WIN.[P].style.[p], k-1) == "line") 
    {
      _plline (nbin+2, dbin, binval[;i]);
    else if (get_style (WIN.[P].style.[p], k-1) == "point") {
      _plpoin (nbin+2, dbin, binval[;i], WIN.[P].pstyle[p]+k);
    else if (get_style (WIN.[P].style.[p], k-1) == "line-point") {
      _plline (nbin+2, dbin, binval[;i]);
      _plpoin (nbin+2, dbin, binval[;i], WIN.[P].pstyle[p]+k);     
    } } }

    // write legend around upper-right corner.
    // it is better to have user to choose location for legend.
    
    if (!any (any (WIN.[P].desc.[p] == 1j)))
    {
      # Use the default if necessary
      if (WIN.[P].desc.[p][1] == "default") 
      {
	desc = "c"+num2str(i);
      else if (WIN.[P].desc.[p].n >= i) {
	  desc = WIN.[P].desc.[p][i];
      else
	# Not sure what to do, user has messed up.
	desc = "";
      } }

      v = v - (xmax)/11;
      xt = (ymax-ymin)*[10.5/12, 11/12, 11.5/12]' + ymin;
      yt = [v, v, v]';
      
      if      (get_style (WIN.[P].style.[p], k-1) == "line") 
      {
	_plline (3, xt, yt);
      else if (get_style (WIN.[P].style.[p], k-1) == "point") {
	_plpoin (3, xt, yt, WIN.[P].pstyle[p]+k);
      else if (get_style (WIN.[P].style.[p], k-1) == "line-point") {
	_plline (3, xt, yt);
	_plpoin (3, xt, yt, WIN.[P].pstyle[p]+k);
      } } }

      plptex(desc, xt[1]-(ymax-ymin)/25, yt[3], , , 1);
    }
  }
  
  _plcol (15);
  _pllab (WIN.[P].xlabel[p], WIN.[P].ylabel[p], WIN.[P].title[p]);  
  _plflush ();
  _pltext ();
  
  #
  # Increment the plot no. so that next time
  # we use the correct settings.
  #
  
  WIN.[P].subplot = WIN.[P].subplot + 1;
  
  return 1;
};


##############################################################################
#
# Create a legend in the current plot window
#
# if pobj.desc.[p] = inf()		no legend
# if pobj.desc.[p] = "default"		default ("c1", "c2", ...)
# if pobj.desc.[p] = "string"		use "string" as description
#

#
# Set the current plot legend string
#

plegend = function ( LEGEND )
{
  check_plot_object ();
  
  p = mod (WIN.[P].subplot, WIN.[P].nplot) + 1;	# The current index
  
  if (!exist (LEGEND)) 
  {
    WIN.[P].desc.[p] = 1j;
    return P;
  }
  
  if (class (LEGEND) == "string")
  {
    WIN.[P].desc.[p] = LEGEND;
  }
  
  return P;
};

set3d = function (bx, by, h)
{
  if (!exist (bx)) { basex = 2; else basex = bx; }
  if (!exist (by)) { basey = 2; else basey = by; }
  if (!exist (h)) { height = 4; else height = h; }
};

//-------------------------------------------------------------------//
// Synopsis:    Compute correlations faster than DSP toolbox, 
//              and with bandpassing

// Usage:

//   y = corr(x)
//   Compute the autocorrelation of vector x.  Does NOT handle
//   matrices  the way xcorr (in the Signal Processing toolbox) does;
//   instead, a matrix is treated as a vector (with reshape). 

//   y = corr(x1,x2)
//   Return the cross-correlation of vectors x1 and x2, which need not
//   be  the same length.  This is similar to xcorr, but faster (the
//   latter efficiently computes 4 correlations and throws 3 away).
//   Also, if  length(x1) is different from length(x2), xcorr returns
//   a wrong-length  result.

//   y = corr(x1,x2,f) 
//   As above, but also filter by the bandpass filter f.  f is a
//   two-element vector, with values in [0,1], that specifies the
//   passband; in f, the value 1 represents the Nyquist frequency.

// 2/94 David K. Mellinger  dkm1@cornell.edu
// This file is a translation of corr.m from the Osprey toolbox.

require isreal
require nextpow2 

//-------------------------------------------------------------------//

corr = function (in1, in2, f)
{
  local (in1, in2, f)

  if (!exist (in2)) { in2 = in1; }

  x1 = in1[:];
  x2 = in2[:];
  n1 = length (x1);
  n2 = length (x2);

  // pad with 0's for fft & circular corr
  nfft = 2 * 2^nextpow2 (max (n1,n2));

  y = conj (fft ([x1;zeros(nfft-n1,1)])) .* fft([x2;zeros(nfft-n2,1)]);
  if (exist (f))
  {
    if (length(f) == 1)
    {
      f = [0, f];    // one number means lowpass filter
    }
    n = nfft/2;
    i0 = round(f[1] * n);
    i1 = round(f[2] * n);
    y[   1 : i0] = zeros (i0,1);
    y[i1+1 : n]  = zeros (n-i1,1);
    y[nfft+1-i0 : nfft]    = zeros (i0,1);
    y[nfft+1-n  : nfft-i1] = zeros (n-i1, 1);
  }

  y = ifft (y);
  y = [y[nfft+2-n1:nfft]; y[1:n2]];
  
  // Make output have same form as input.
  if (all (isreal (in1)) && all (isreal (in2)))
  {
    y = real(y);
  }

  if (in1.nr == 1)
  {
    y = y.'; 
  }

  return y;
};

//-------------------------------------------------------------------//

// Synopsis:	Create a Householder matrix.

// Syntax:	house ( X )

//	If HOUSE(x), which returns a list containing elements `v' and
//	`beta',  then H = EYE - beta*v*v' is a Householder matrix such
//	that Hx = -sign(x(1))*norm(x)*e_1. 
//	NB: If x = 0 then v = 0, beta = 1 is returned.
//            x can be real or complex.
//            sign(x) := exp(i*arg(x)) ( = x./abs(x) when x ~= 0).

//	Theory: (textbook references Golub & Van Loan 1989, 38-43;
//	         Stewart 1973, 231-234, 262; Wilkinson 1965, 48-50).
//      Hx = y: (I - beta*v*v')x = -s*e_1.
//      Must have |s| = norm(x), v = x+s*e_1, and
//      x'y = x'Hx =(x'Hx)' real => arg(s) = arg(x(1)).
//      So take s = sign(x(1))*norm(x) (which avoids cancellation).
//      v'v = (x(1)+s)^2 + x(2)^2 + ... + x(n)^2
//          = 2*norm(x)*(norm(x) + |x(1)|).

//	References:
//        G.H. Golub and C.F. Van Loan, Matrix Computations, second edition,
//           Johns Hopkins University Press, Baltimore, Maryland, 1989.
//        G.W. Stewart, Introduction to Matrix Computations, Academic Press,
//           New York, 1973,
//        J.H. Wilkinson, The Algebraic Eigenvalue Problem, Oxford University
//           Press, 1965.

//	This file is a translation of house.m from version 2.0 of
//	"The Test Matrix Toolbox for Matlab", described in Numerical
//	Analysis Report No. 237, December 1993, by N. J. Higham.

//-------------------------------------------------------------------//

house = function ( x )
{
  local (x)

  m = x.nr; n = x.nc;
  if (n > 1) { error ("Argument must be a column vector."); }

  s = norm(x,"2") * (sign(x[1]) + (x[1]==0)); // Modification for sign(0)=1.
  v = x;
  if (s == 0)	// Quit if x is the zero vector.
  {
    beta = 1; 
    return << beta = beta ; v = v >>;
  }

  v[1] = v[1] + s;
  beta = 1/(s'*v[1]);		// NB the conjugated s.

  // beta = 1/(abs(s)*(abs(s)+abs(x(1)) would guarantee beta real.
  // But beta as above can be non-real (due to rounding) only 
  // when x is complex.

  return << beta = beta ; v = v >>;
};

//-------------------------------------------------------------------//

// Synopsis:	Compute Auto-Spectra of the input sequence

// Syntax:	autospec ( X, dt, M, WIN, raw );

// Description:

//      Compute the auto-spectra (psd) of the input vector X. autospec
//      returns a two-column matrix. The 1st column is the frequency
//      scale and the second column is the values of the one-sided
//      spectra.

//	X:	Input sequence
//	dt:	Sample interval 
//              (default = 1)
//	M:	Length of sequence to use for computations. The
//		sequence X is "cut-up" into M-point sequences
//              (default = length (X))
//      WIN:    Window type: "hann", "rect", "hamm"
//              (default = "rect")
//      raw:    If raw == 1, then output the "raw" auto-spectra.
//              Otherwise output the auto-spectra from 0-Nyq/2
//              with a time-scale.
//              (default = 0)

// Dependencies

   rfile window
   rfile detrend

//-------------------------------------------------------------------//

autospec = function ( X , dt, M, WIN, raw )
{
  local ( X , dt, M, WIN, raw )

  X = X[:];		// Make sure it is a row
  if (!isreal (X)) { error ("autospec: X must be real"); }
  n = length (X);

  //
  // Set the defaults.
  //

  if (!exist (dt)) { dt = 1; }
  if (!exist (M)) { M = n; }
  if (!exist (WIN)) { WIN = "rect"; }
  if (!exist (raw)) { raw = 0; }

  // Some error checking

  if (M > n) { error ("spectrum: M > n not allowed"); }
  if (M < 0) { error ("spectrum: M < 0 not allowed"); }

  // Create the frequncy scale (in Hertz) up to the Nyquist

  fscale = (((0:M-1)/M)/dt)';

  k = fix (n/M);	// The number of windows
  index = 1:M;

  // Create the window

  w = window (M, WIN);          // Window specification
  U = k*sqrt(sum(w.^2)/w.n);	// Normalizing scale factor

  Pxx = zeros (M, 1);

  for (i in 1:k)
  {
    xw = w .* detrend (X[index]);
    index = index + M;
    Xx = (2/(M*dt)) * abs (dt * fft (xw)) .^ 2;
    Pxx = Pxx + Xx;
  }

  if (raw)
  {

    //
    // Return the "raw" spectrum.
    //

    return Pxx/U;
  else

    //
    // Select 1st half and eliminate DC value.
    // Return a matrix with the frequency scale in the 1st column
    // and the PSD in the 2nd.
    //

    Pxx = Pxx[2:(M/2)+1]/U;
    return [fscale[2:(M/2)+1], Pxx];
  }
};

//-------------------------------------------------------------------//
// 
//  Syntax:	eye ( S1 , S2 )
//		eye ( A )
//
//  Description:

//  Create an identity matrix with number of rows and columns
//  specified by two scalars (S1 - rows, and S2 - columns).

//  If the input is A, a matrix, with two elements, then the 1st
//  element of A determines the number of rows, and the 2nd element of
//  A determines the number of columns of the new identity matrix.

//  The matrix input option exists so that:
//
//		eye( size( X ) )
//  will work.

//  See Also: ones, zeros
//-------------------------------------------------------------------//

eye = function( m , n ) 
{
  local(m, n)

  if (!exist (n))
  {
    if(m.n != 2) { error("only 2-el MATRIX allowed as eye() arg"); }
    new = zeros (m[1], m[2]);
    N = min ([m[1], m[2]]);
  else
    if (class (m) == "string" || class (n) == "string") {
      error ("eye(), string arguments not allowed");
    }
    if (max (size (m)) == 1 && max (size (n)) == 1)
    {
      new = zeros (m[1], n[1]);
      N = min ([m[1], n[1]]);
    else
      error ("matrix arguments to eye() must be 1x1");
    }
  }
  for(i in 1:N)
  {
    new[i;i] = 1.0;
  }
  return new;
};

//-------------------------------------------------------------------//
//  Syntax:	lu ( A )

//  Description:

//  Lu computes the "LU" factors of the input MATRIX. The input MATRIX
//  must be square. lu() returns l, u, and pvt in a LIST. The
//  factorization has the form: 

//  A = p*l*u			where A is the input matrix

//  The function lu is a user-function that utilizes the built-in
//  function factor. Factor does the factorization using the LAPACK
//  functions DGETRF/ZGETRF, and DGECON/ZGECON.

//  Example:

//  > a = [1,2,3;4,5,6;7,8,0]
//   a =
//   matrix columns 1 thru 3
//             1           2           3
//             4           5           6
//             7           8           0
//  > f = lu(a)
//    l            pvt            u            
//  > f.p
//   matrix columns 1 thru 3
//             0           0           1
//             1           0           0
//             0           1           0
//  > f.l
//   matrix columns 1 thru 3
//             1           0           0
//         0.143           1           0
//         0.571         0.5           1
//  > f.u
//   matrix columns 1 thru 3
//             7           8           0
//             0       0.857           3
//             0           0         4.5
//  > f.p*f.l*f.u
//   matrix columns 1 thru 3
//             1           2           3
//             4           5           6
//             7           8           0

//  See Also: backsub, factor, inv, solve
//-------------------------------------------------------------------//

static (swap);

lu = function ( A )
{
  if (A.nr != A.nc) { error ("lu() requires square A"); }

  x = factor (A, "g");	// Do the factorization

  //
  // Now create l, u, and pvt from lu and pvt.
  //

  l = tril (x.lu, -1) + eye (size (x.lu));
  u = triu (x.lu);
  pvt = eye (size (x.lu));

  //
  // Now re-arange the columns of pvt
  //

  for (i in 1:max (size (x.lu)))
  {
    pvt = pvt[ ; swap (1:pvt.nc, i, x.pvt[i]) ];
  }
  return << l = l; u = u; pvt = pvt >>;
};

//
//  In vector V, swap elements I, J
//

swap = function ( V, I, J )
{
  local (v, tmp);
  v = V;
  tmp = v[I];
  v[I] = v[J];
  v[J] = tmp;
  return v;
};

% QUADR Numerical evaluation of an integral.
%	Q = QUADS(F,X1,X2) approximates the integral of F(X)
%	from X1 to X2 with relative error  1e-4.  'F' is a string
%	containing the name of the function such as 'sin' or expression
%	depending on x (such as '1/(x+1)^2'). Function or expression F
%	must return a vector of output values of the same size as a
%	vector of input values.
%
%	Q = QUADS(F,X1,X2,TOL) integrates to a relative error of TOL.
%	Q = QUADS(F,X1,X2,TOL,TRACE) also traces the function
%	evaluations with a point plot (with different colors for each
%	recursion level).
%	Q = QUADS(F,X1,X2,TOL,TRACE,P1,P2,...) allows parameters P1, P2
%	to be passed directly to a function F in the form F(X,P1,P2,...).
%	When F stands for expression, its parameter dependence must
%	contain 'p1' ... explicitly, such as '(x-p1)/(x+p2)^p3'.
%	[Q,X,Y] = QUADS(F,...) also returns vector of points X of
%	function evaluation and corresponding function values Y.

%  Kirill K. Pankratov,  kirill@plume.mit.edu
%  01/30/95

require lininsrt

quadr = function (fun, x1, x2, tol, trace, p1, p2, p3, p4, p5)
{
  local (x1, x2, tol, trace, p1, p2, p3, p4, p5)

  % Defaults and parameters ..................................
  tol_dflt = 1e-4; % Default tolerance for integral estimation
  trace_dflt = 0;  % No plotting by default
  n_max = 7;       % Max. number of points inserted at one
                   % iteration between 2 old points
  max_lev = 8;     % Max. number of iterations (recursion level)
  pow = 1/4;       % Power index for estimation of number of
                   % inserted points

  % Coefficients ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
  % Function interpolation coefficients ..........
  % (Lagrange polynomials interp. from 4 basis pts to 3 pts.
  ci =  [-1/6, 2/3,  0,  2/3, -1/6];   % [1 2 4 5] to 3

  % Integral approximation coefficients ..........
  cq = [0.31111111111111;
        1.42222222222222;
        0.53333333333334;
        1.42222222222222;
        0.31111111111111];


  % Handle input .............................................
  if (nargs < 5) { trace = trace_dflt; }
  if (nargs < 4) { tol = tol_dflt; }
  if (trace == []) { trace = trace_dflt; }
  if (tol == [] || all([tol[:]; -1]) <= 0) { tol = tol_dflt; }

  % Set up function call .....................................
  if (class (fun) == "function")
  {
    call = "fun ( x";
    for (n in 1:nargs-5)
    {
      call = call + ", p" + num2str(n);
    }
    call = "f = " + call + ");";

  else               % .. Expression

    call = "f = " + fun + ";";
  }

  % Initial layout ..............................
  g = sqrt(3)/3;  % Initial layout section ratio (just some
                  % number close but not equal to 1/2)
  span = x2 - x1;
  x_o = [x1, x1+[1-g, 1+g/117, 1+g]*span/2, x2];

  % Auxillary ...................................
  ci5 = ci[5];
  ci = ci[1:4];
  cq5 = cq[5];
  cq = cq[1:4]';
  tol_f = tol/sqrt(span)*16;
  o4 = ones(4,1);

  % Initialize output and control parameters ....
  f_o = [];
  n_ins = 3;
  n_i = 1;
  last = 1;
  iter = 0;
  is_more = 1;

  % Begin recursively refine approximations ..................
  while (is_more)  % While not enough accuracy ``````````````````0
  {
    iter = iter + 1;

    % Insert new points ..........................
    F = n_ins[o4;];
    </ mask ; x_o /> = lininsrt(x_o, F);
    if (iter == 1) { mask = ones(size(mask)); }

    % Expand "last" vector
    last = last[o4;1:n_i];
    last = [last[:]', last[n_i]];

    % Evaluate function at new points ............
    x = x_o[find (mask)];
    eval(call);

    % Insert new points in the output and control vectors
    n_ins = find(!mask);
    misfit = find(mask);
    if (iter > 1)
    {
      f_o[n_ins] = f_o;
      last[n_ins] = last;
    }
    f_o [misfit] = f;
    last[misfit] = ones(size(misfit));

    % Reshape function values vector ............
    l_o = length(x_o);
    n_i = (l_o - 1)/4;
    F = reshape(f_o[1:l_o-1], 4, n_i);

    % Calculate difference between actual 
    % and interpolated values ...................
    misfit = ci*F+ci5*f_o[5:l_o:4];  % Interpolation
    misfit = abs(misfit-F[3;]);      % Difference

    % Calculate how many points need to be inserted
    scale = mean(abs(f_o));
    n_ins = (misfit/(tol_f*scale)).^pow-1;

    % Smooth (moving average)
    if (iter > 2)
    {
      misfit = cumsum(n_ins);
      n_ins[3:n_i-2] = (misfit[5:n_i] - misfit[1:n_i-4])/4;
      n_ins[[1, 2, n_i-1, n_i]] = n_ins[3, 3, n_i-2, n_i-2];
    }
    
    % Make it integer and upper bounded
    n_ins = min(ceil(n_ins), n_max*ones(size(n_ins)));

    % If previous iteration was accurate
    % enough, do not insert new points .........
    misfit = n_ins > 1;
    n_ins = max(n_ins, last[5:l_o:4]);
    last = misfit;

    is_more = any(n_ins);   % If needs more points inserted

    if (trace)    % Plot new points ..............
    {
      plot([ x, f ]);
    }

    % If still not enough accuracy .............
    if (iter > max_lev)
    {
      disp(" Recursion level limit reached. Singularity likely.");
      is_more = 0;
    }

  }  
  % End while (recursion) ''''''''''''''''''''''''''''''''0

  if (trace) { "hold off" }

  % Now calculate the integral itself .........
  last = 5:l_o:4;
  misfit = cq*F+cq5*f_o[last];
  Q = (x_o[last] - x_o[last - 1])*misfit';

  return << Q=Q; x_o=x_o; f_o=f_o >>;
};

//-------------------------------------------------------------------//

//  Syntax: poly(A)

//  Description:

//  Find characteristic polynomial of A
//
//  If A is an n by n matrix, poly(A) is an n+1 element row vector
//  whose elements are the coefficients of the characteristic polynomial
//      det(A-zI) = 0.
//  The output coefficients are stored in decending powers as
//      [C1,C2,....,Cn+1]
//  It represents polynomial
//      C[1]*z^n + C[2]*z^(n-1) + .... + C[n]*z + C[n+1]  
//
//  If A is an n by 1 column vector, elements of A are roots of 
//  polynomial
//      (z-A[1])(z-A[2]) ... (z-A[n]) = 0
//  The output coefficients represents the expanded form of above
//  polynomial.

//  Example:
//  > X=[5,-6;1,0]
//   X =
//          5         -6
//          1          0
//  > p=poly(X)
//   p =
//          1         -5          6
//  > r=roots(p)
//   r =
//          2
//          3
//  > p1=poly(r)
//   p1 =
//          1         -5          6
//

//  See Also: roots
//
//  Tzong-Shuoh Yang (tsyang@ce.berkeley.edu)  5/7/94
//
//-------------------------------------------------------------------//

poly = function(A)
{ 
    if (A.nc == A.nr) {
      // A is a matrix, find its eigenvalues
      e = eig(A).val';
      l = inf();
      // trim INFs
      e = e[find(e != l && e != -l)];
    else if (A.nr == 1 || A.nc == 1) {
      // elements of A are roots of the polynomial
      e = A[:];	// force a column vector
    else
      error("Argument of poly() must be a square matrix or a vector");
    }}
    // construct char. polynomial
    c = [1,zeros(1,e.nr)];
    for (i in 1:e.nr) {
       j = i + 1;
       c[2:j] = c[2:j] - e[i]*c[1:i];
    }
        
    if (all(imag(c) == 0)) {
       c = real(c);
    }
	return c;
};

//-------------------------------------------------------------------//

//  Syntax:	pause ( )

//  Description:

//  The pause function stops execution of an RLaB program until the
//  return key is pressed.

//  See Also: fprintf, getline
//-------------------------------------------------------------------//

pause = function ( message )
{
  if (!exist (message))
  { 
    message = "\tHit return to continue"; 
  }
  fprintf ("stdout", "%s\n", message);
  getline ("stdin");
};

//-------------------------------------------------------------------//

//  Syntax:	funm ( A , FUN )

//  Description:

//  The funm function computes the matrix function of A as described
//  in scalar context by FUN. For example:

//	funm ( A , exp )

//  calculates the matrix exponential (using expm() is better though).

//  The second argument, FUN is NOT a string, it is a variable, in
//  this particular case, it is a variable representing either a
//  builtin, or user-function.

//  Funm uses Parlett's method. See Golub and VanLoan (1983), p. 384.

//  See Also: expm, logm
//-------------------------------------------------------------------//

funm = function ( A , fun )
{
  global (eps)

  S = schur (A + zeros (size (A))*1i);	// get Complex Schur form
  F = diag (fun (diag (S.t)));
  tol = eps*norm (S.t,"1");
  n = max (size (A));
  for (p in 1:n-1)
  {
    for (i in 1:n-p)
    {
      j = i+p;
      s = S.t[i;j]*(F[j;j] - F[i;i]);
      if (p > 1)
      {
        k = i+1:j-1;
        s = s + S.t[i;k]*F[k;j] - F[i;k]*S.t[k;j];
      }
      d = S.t[j;j] - S.t[i;i];
      if (abs (d) <= tol)
      {
        fprintf ("stderr", "WARNING: Result from FUNM is probably inaccurate.");
        d = tol;
      }
      F[i;j] = s/d;
    }
  }
  return S.z*F*S.z';
};

//---------------------------------------------------------------------------
//  fftplot.r

//  Syntax:	fftplot ( Y )
//		fftplot ( Y , T )

//  Fftplot compute and plot the magnitude in dB and phase in degrees
//  of the FFT data in Y
//
//  T = sampling period, if this parameter is not given it is assumed
//      to be equal to one.

//  The magnitude and phase are returned in list elements `mag' and
//  `ph' respectively. The values for the frequency scale are returned
//  in list element `freq'. The magnitude and phase are truncated
//  above the Nyquist frequency. If plotf exists, then a plot of the
//  magnitude of Y (in dB) versus frequency is produced.
//
//---------------------------------------------------------------------------

fftplot = function ( Y, T, plotf )
{

  lab = ["DIGITAL FREQUENCY / pi" , "FREQUENCY HERTZ"];
  ly = log (Y[:]);
  mag = 20 * real(ly) / log(10);
  ph = imag (ly);
  n = max (size (Y))/2;
  f = ((0:n-1)/n)';
  if (!exist (T)) 
  { 
    labid = 1;
  else
    f = 0.5*f/T;
    labid = 2;
  }

  if (exist (plotf))
  {
    plot ("set title 'MAGNITUDE'");
    plot ("set xlabel '"+lab[labid]+"'");
    plot ("set ylabel 'dB'");

    plot ( [f, mag[1:n] ] );
  }

  return << freq = f; mag = mag[1:n]; ph = ph[1:n] >>
};

//-------------------------------------------------------------------//

// Synopsis:	Pascal matrix.

// Syntax:	P = pascal ( N )

// Description:

//	The Pascal matrix of order N: a symmetric positive definite
//	matrix with integer entries taken from Pascal's triangle. The
//	Pascal matrix is totally positive and its inverse has integer
//	entries.  Its eigenvalues occur in reciprocal pairs. COND(P)
//	is approximately 16^N/(N*PI) for large N. PASCAL(N,1) is the
//	lower triangular Cholesky factor (up to signs of columns) of
//	the Pascal matrix.   It is involutary (is its own
//	inverse). PASCAL(N,2) is a transposed and permuted version of
//	PASCAL(N,1) which is a cube root of the identity.

//      References:
//      R. Brawer and M. Pirovino, The linear algebra of the Pascal matrix,
//           Linear Algebra and Appl., 174 (1992), pp. 13-23 (this paper
//           gives a factorization of L = PASCAL(N,1) and a formula for the
//           elements of L^k).
//      S. Karlin, Total Positivity, Volume 1, Stanford University Press,
//           1968.  (Page 137: shows i+j-1 choose j is TP (i,j=0,1,...).
//                   PASCAL(N) is a submatrix of this matrix.)
//      M. Newman and J. Todd, The evaluation of matrix inversion programs,
//           J. Soc. Indust. Appl. Math., 6(4):466--476, 1958.
//      H. Rutishauser, On test matrices, Programmation en Mathematiques
//           Numeriques, Editions Centre Nat. Recherche Sci., Paris, 165,
//           1966, pp. 349-365.  (Gives an integral formula for the
//           elements of PASCAL(N).)
//      J. Todd, Basic Numerical Mathematics, Vol. 2: Numerical Algebra,
//           Birkhauser, Basel, and Academic Press, New York, 1977, p. 172.
//      H.W. Turnbull, The Theory of Determinants, Matrices, and Invariants,
//           Blackie, London and Glasgow, 1929.  (PASCAL(N,2) on page 332.)

//	This file is a translation of pascal.m from version 2.0 of
//	"The Test Matrix Toolbox for Matlab", described in Numerical
//	Analysis Report No. 237, December 1993, by N. J. Higham.

//      Dependencies
        require rot90

//-------------------------------------------------------------------//

pascal = function ( n , k )
{
  local (n, k)

  if (!exist (k)) { k = 0; }

  P = diag( (-1).^[0:n-1] );
  P[; 1] = ones(n,1);

  //  Generate the Pascal Cholesky factor (up to signs).

  for (j in 2:n-1)
  {
    for (i in j+1:n)
    {
      P[i;j] = P[i-1;j] - P[i-1;j-1];
    }
  }

  if (k == 0)
  {
    P = P*P';
  else if (k == 2) {
    P = rot90(P,3);
    if (n/2 == round(n/2)) { P = -P; }
  }}

  return P;
};

// detrend.r:
//  Remove a linear trend from a vector.
//  y = detrend(x) removes the best straight-line fit 
//  from the data in vector x and returns it in vector y.

detrend = function(x) 
{
  local(a, b, m, q1, qra, r, x, y, z);

  m = max(size(x));
  y = x;

  // Least Squares Solution

  a = [(1:m)./m; ones(1,m)]';
  qra = qr(a);
  q1 = qra.q[;1:size(a)[2]];
  r = qra.r[1:size(a)[2];];

  z = y*q1;
  b = solve(r, z');

  // Subtract out trend
  y = y' - a*b;

  return y';
};

//
// Simple example using above function
//

 t=0:100;
 y = t + t .* sin(t/2);
 ydt = detrend(y);

 plgrid ();
 ptitle ( "RLaB Data Detrend Example" );
 xlabel ( "Independent Variable" );
 ylabel ( "Dependent Variable" );

 plot( [ [t;y;ydt]' ] );

//-------------------------------------------------------------------//
// Synopsis:    Next integer power of 2.

// Usage:       nextpow2 ( N )

// Description:

//      nextpow2 returns the first integer such tht 2^P >= N. If N is
//      a vector, then nextpow2 computes P such that 2^P >= length(N).

// See Also: frexp

//-------------------------------------------------------------------//

nextpow2 = function ( n )
{
  local (n)

  if (length (n) > 1) 
  {
    n = length (n);
  }

  </ e ; f /> = frexp (abs(n));
  
  //
  // If e == 0.5, then the exponent is 1 > than the value we want.
  //

  if (f == 0.5)
  {
    e = e - 1;
  }

  return e;
};

//-------------------------------------------------------------------//
//
//  Syntax:     min2 ( A, B )

//  Description:

//  Return a matrix the same size as A and B with the smallest
//  elements taken from A and B.

//  Note: the builtin function min now handles this condition.
//        This file is maintained for backward compatibility.
//-------------------------------------------------------------------//

min2 = function(a,b)
{
  return min(a,b);  
  // return (b+(a-b).*(a<b));
};

// Create the data
X = -2:2:.2;
Y = X;
Z = [];
for (i in 1:X.n) { 
  for (j in 1:Y.n) { 
    Z[i;j] = X[i] * exp (-X[i]^2 - Y[j]^2);
  }
}
// Make the plot
pstart(,,"xwin");
plwid(4);
ptitle("Sample 3-D Plot");
xlabel("X-Axis");
ylabel("Y-Axis");
zlabel("Z-Axis");
plmesh( << x = X; y = Y; z = Z >> );
plprint("3d.ps");

#
# Test 2-D plots
#

pstart (2,2);

x = (0.25:4:.25)';

//-----------------------------------------------------------------//
ptitle ("Multiple Line Colors and Styles");
xlabel ("X-axis Label");
ylabel ("Y-axis Label");
plot ( [x, x, 2*x, 3*x] );

subplot (4);
ptitle ("Multiple Point Colors and Styles");
plstyle ("point");
plot ( [x, x, 2*x, 3*x] );
pause ("Type RETURN to continue");

//-----------------------------------------------------------------//
ptitle("Plot 1, No Grid");
plgrid ("", "");
plot ([x,exp(-x*0.5)]);

ptitle("Plot 2, Grid Box Only");
plgrid ("bc", "bcv");
plot ([x,2*x,3*x,4*x]);

ptitle("Plot 3, Box, and Coordinates");
plgrid ("bcnt", "bcnvt");
plot ([x,-2*x,2*x]);

ptitle("Plot 4, ");
plgrid ("bcngst", "bcngvst");
plot ([x,x,cos(2*pi*x*0.25)]);
pause ("Type RETURN to continue");

plgrid ();  # Reset axis

//-----------------------------------------------------------------//
# Show off axis types
ptitle("Linear Axes");
plgrid();
plot ([x,exp(-x*0.5)]);

ptitle("Log X - Axis");
plgrid("bcngstl");
plot ([x,exp(-x*0.5)]);

ptitle("Log Y - Axis");
plgrid("bcngst", "bcngstlv");
plot ([x,exp(-x*0.5)]);

ptitle("Log  Axes");
plgrid("bcngstl", "bcngstlv");
plot ([x,exp(-x*0.5)]);
pause ("Type RETURN to continue");

plgrid ();  # Reset axis


//-----------------------------------------------------------------//
# Data with different scales
y = (0.5:6:.2)';
ptitle("Plot Data with Different Scales");
plgrid ();
plot (<< [x,exp(-x*0.5)] ; [y, exp (y*0.25), exp(y*0.1)] >>);

# Histograms

rand("normal", 0, pi);
r = rand(2000,1);

plgrid ();
ptitle("Histogram, Default No. of Bins");
plhist (r);

ptitle("Histogram, 30 Bins");
plgrid ();
plhist (r, 30);

ptitle("2 Histograms, 30 Bins");
plgrid ();
plhist ([r, 2*r], 30);
pause ("Type RETURN to continue");

//-----------------------------------------------------------------//

# Some more histograms...

xlabel(); ylabel(); plgrid (); plstyle();
ptitle("Histogram, Default No. of Bins");
plhist (r);

xlabel(); ylabel(); plgrid (); plstyle("line-point");
ptitle("Histogram, Default No. of Bins");
plhistx (r);

xlabel(); ylabel(); plgrid (); plstyle();
ptitle("Histogram, 30 Bins");
plgrid ();
plhist (r, 30);

xlabel(); ylabel(); plgrid (); plstyle("line-point");
ptitle("Histogram, 30 Bins");
plhistx (r, 30);
pause ("Type RETURN to continue");

//-----------------------------------------------------------------//
# Make 3D data

# Sombrero

NX = 20;
NY = 20;
xx = zeros (1, NX);
yy = zeros (1, NY);
for (i in 1:NX) { xx[i] = (i - NX/2)/(NX/2); }
for (i in 1:NY) { yy[i] = (i - NY/2)/(NY/2); }

zz = zeros (NX, NY);

for (i in 1:NX)
{
  for (j in 1:NY)
  {
    r = sqrt (xx[i]^2 + yy[j]^2);
    zz[i;j] = exp (-r * r) * cos (2*pi*r);
  }
}

# Now create some plots

ptitle("3-D Plot, Sombrero");
plmesh (<< x = xx; y = yy; z = zz>>);

# Sin - Cos surface

x1 = -3:3:.2;
y1 = -3:3:.2;
z1 = zeros (x1.n, y1.n);

for (i in 1:x1.n)
{
  for(j in 1:y1.n)
  {
    z1[i;j] = sin(y1[j]) * cos(x1[i]);
  }
}

ptitle("3-D Plot, Cos-Sine Surface");
plmesh (<< x = x1; y = y1; z = z1>>);

# Slanted plane

x2 = 1:10;
y2 = 1:10;
z2 = zeros (x2.n, y2.n);
for (i in 1:x2.n) { z2[i;] = i*ones(1,y2.n); }
 
ptitle("3-D Plot, Plane");
plmesh (<< x = x2; y = y2; z = z2>>);

# Two Slanted planes
z3 = -2*z2;
ptitle("3-D Plot, 2 - Planes");
plmesh (<< x = x2; y = y2; z = z2>>, <<x = x2; y = y2; z = z3 >>);

pause ("Type RETURN to continue");

//-----------------------------------------------------------------//

# Now show 3-D viewing angles

ptitle("3-D Plot, Sombrero, Default View, Alt = 60, Az = 45");
plmesh (<< x = xx; y = yy; z = zz>>);

ptitle("3-D Plot, Sombrero, Alt = 10, Az = 10");
plalt(10); 
plaz(10);
plmesh (<< x = xx; y = yy; z = zz>>);

ptitle("3-D Plot, Sombrero, Alt = 20, Az = 30");
plalt(20); 
plaz(30);
plmesh (<< x = xx; y = yy; z = zz>>);

ptitle("3-D Plot, Sombrero, Alt = 80, Az = 60");
plalt(80); 
plaz(60);
plmesh (<< x = xx; y = yy; z = zz>>);

pause ("Type RETURN to continue");

//-----------------------------------------------------------------//

#
# Simple contour plotting demonstration
#

NX = 20;
NY = 20;
xx = zeros (1, NX);
yy = zeros (1, NY);
for (i in 1:NX) { xx[i] = (i - NX/2)/(NX/2); }
for (i in 1:NY) { yy[i] = (i - NY/2)/(NY/2); }

zz = zeros (NX, NY);

for (i in 1:NX)
{
  for (j in 1:NY)
  {
    r = sqrt (xx[i]^2 + yy[j]^2);
    zz[i;j] = exp (-r * r) * cos (2*pi*r);
  }
}

# Sin - Cos surface

x1 = -3:3:.2;
y1 = -3:3:.2;
z1 = zeros (x1.n, y1.n);

for (i in 1:x1.n)
{
  for(j in 1:y1.n)
  {
    z1[i;j] = sin(y1[j]) * cos(x1[i]);
  }
}

# Now create some plots

xlabel("X-Axis");
ylabel("Y-Axis");
ptitle ("Contour Demonstration");
plalt();
plaz();
plmesh (<< x = xx; y = yy; z = zz>>);

xlabel("X-Axis");
ylabel("Y-Axis");
ptitle ("Contour Demonstration");
plalt();
plaz();
plcont (<< x = xx; y = yy; z = zz>>);

xlabel("X-Axis");
ylabel("Y-Axis");
ptitle ("Contour Demonstration");
plalt();
plaz();
plmesh (<< x = x1; y = y1; z = z1>>);

xlabel("X-Axis");
ylabel("Y-Axis");
ptitle ("Contour Demonstration");
plalt();
plaz();
plcont (<< x = x1; y = y1; z = z1>>);

pause ("Type RETURN to continue");

//-----------------------------------------------------------------//

// Now try some diff scale settings (log)

plgrid3(); 
ptitle("3-D Plot, Sombrero");
plmesh (<< x = xx; y = yy; z = zz>>);

plgrid3("bnstul", "bnstul");
ptitle("3-D Plot, Sombrero (log-scales)");
plmesh (<< x = xx+5; y = yy+5; z = zz>>);

plgrid3(); 
plaxis ("log", "log");
ptitle("3-D Plot, Cos-Sine Surface");
plmesh (<< x = x1; y = y1; z = z1>>);

plgrid3("bnstul", "bnstul");
plaxis ("log", "log");
ptitle("3-D Plot, Cos-Sine Surface (log-scales)");
plmesh (<< x = x1+5; y = y1+5; z = z1>>);

pause ("Type RETURN to continue");

//-------------------------------------------------------------------//

//  Syntax:	std ( A )

//  Description:

//  Compute the Standard Deviation. For a vector (row-matrix), std()
//  returns the standard deviation. For a MxN matrix, std() returns a
//  row-matrix containing the standard deviation of each column.

//  See Also: mean, rand, srand
//-------------------------------------------------------------------//

std = function(x)
{
  if(class(x) != "num") { error("std() requires NUMERICAL input"); }

  m = x.nr;
  if( m == 1 ) 
  { 
    return sqrt( sum( (x - mean(x)) .^ 2 ) / (x.nc - 1) );
  else
    for( i in 1:x.nc) {
      s[i] = sqrt( sum( (x[;i] - mean(x[;i])) .^ 2 ) / (x.nr - 1) );
    }
    return s;
  }
};

//
// The 3n + 1 problem
//

collatz = function(start)
{
  local(c, n);
  c = n = start;

  while(n > 1)
  {
    if(mod(n,2) == 0) {
      n = n/2;
    else
      n = 3*n + 1;
    }
    c = [c, n];
  }
  return c;
};

//
// Try it out
//
 c = collatz(100);

 plgrid ();
 ptitle ( "RLaB Collatz Example" );
 xlabel ( "Independent Variable" );
 ylabel ( "Dependent Variable" );
 plot( [1:c.nc; c]' );
 pause ();
 plgrid ( ,"bcgnstlv");
 plot( [1:c.nc; c]' );

//-------------------------------------------------------------------
//
// banner
//
// Syntax: banner(string)
//
//  Prints the string in the center of the page with horizontal
//  lines above and below
//
// Originally written for MATLAB by Lee P. Peterson
// Modified by Jeff Layton and ported to RLaB by Jeff Layton
//-------------------------------------------------------------------

rfile center

banner = function(string)
{
   local(width,line,j)

   if (string.class != "string") {
       error("banner only works with strings.")
   }

   width=length(string);
   line="";

   for (j in 1:width) {
     line=line+"-";
   }

// printf("%s"," ");
   center(line);
   center(string);
   center(line);
// printf("%s"," ");

};

//-------------------------------------------------------------------//

//  Syntax:  whos ( L )

//  Description:

//  The whos function prints a tabular listing (to stdout) of the
//  contents of the list, or symbol-table L. Information on functions
//  is not output. If no argument is provided whos prints out 
//  information from the global-symbol table.

//  See Also: sizeof, who, what

//-------------------------------------------------------------------//

static (whos_1, Btotal);

whos = function ( LIST )
{
  Btotal = 0;
  if (!exist (LIST)) 
  {
    whos_1 ($$);
  else
    whos_1 (LIST);
  }
  printf ("Total MBytes = %f\n", Btotal/1.e6);
};

whos_1 = function ( LIST )
{
  printf ("\tName            Class\tType\tSize\t\tNBytes\n");
  for (i in members (LIST))
  {
    nbytes = sizeof (LIST.[i]);
    Btotal = Btotal + nbytes;
    if (class (LIST.[i]) == "function") { continue }
    if (class (LIST.[i]) == "list")
    {
      m = size (LIST.[i]);
      printf ("\t%-15s", i);
      printf ("\t%s\t%s\t%i\t\t%i\n", ...
              class (LIST.[i]), type (LIST.[i]), m[1], nbytes);
    else
      m = size (LIST.[i]);
      printf ("\t%-15s", i);
      printf ("\t%s\t%s\t%i\t%i\t%i\n", ...
              class (LIST.[i]), type (LIST.[i]), m[1], m[2], nbytes);
    }
  }
};

//-------------------------------------------------------------------//

// Synopsis:	Rotate a matrix by 90 degrees.

// Syntax:	rot90 ( A )
//		rot90 ( A , K )

// Description:

//	If K is omitted, then A (M x N) is rotated by 90
//	degrees. Otherwise, A is rotated by K*90 degrees. K can take
//	on positive or negative values. 

//	rot90 is useful with plmesh() and plot3d(). Using rot90, the
//	user can rotate the surface by 90 degrees in either direction.

//-------------------------------------------------------------------//

rot90 = function ( A , k )
{
  local (k, B, m, n)

  m = A.nr; n = A.nc;
  if (!exist (k)) 
  {
    k = 1; 		// default
  else
    k = mod(k,4);	// take out 360 deg. rotations
    if (k < 0)
    {
      k = k + 4;	// Force positve
    }
  }

  if (k == 1)
  {
    B = A'[n:1:-1;];		// 90
  else if (k == 2) {
    B = A[m:1:-1;n:1:-1];	// 180
  else if (k == 3) {
    B = (A[m:1:-1;])';		// 270
  else
    B = A;			// 360
  }}}

  return B;
};

pstart();

# Make 3D data

# Sombrero

NX = 20;
NY = 20;
xx = zeros (1, NX);
yy = zeros (1, NY);
for (i in 1:NX) { xx[i] = (i - NX/2)/(NX/2); }
for (i in 1:NY) { yy[i] = (i - NY/2)/(NY/2); }

zz = zeros (NX, NY);

for (i in 1:NX)
{
  for (j in 1:NY)
  {
    r = sqrt (xx[i]^2 + yy[j]^2);
    zz[i;j] = exp (-r * r) * cos (2*pi*r);
  }
}

# Sin - Cos surface

x1 = -3:3:.2;
y1 = -3:3:.2;
z1 = zeros (x1.n, y1.n);

for (i in 1:x1.n)
{
  for(j in 1:y1.n)
  {
    z1[i;j] = sin(y1[j]) * cos(x1[i]);
  }
}

# Slanted plane

x2 = 1:10;
y2 = 1:10;
z2 = zeros (x2.n, y2.n);
for (i in 1:x2.n) { z2[i;] = i*ones(1,y2.n); }
 
# Now create some plots

ptitle("PLOT3");
plot3 (<< x = xx; y = yy; z = zz>>);
pause();
ptitle("PLMESH");
plmesh (<< x = xx; y = yy; z = zz>>);
pause();

ptitle("PLOT3");
plot3 (<< x = x1; y = y1; z = z1>>);
pause();
ptitle("PLMESH");
plmesh (<< x = x1; y = y1; z = z1>>);
pause();

ptitle("PLOT3");
plot3 (<< x = x2; y = y2; z = z2>>);
pause();
ptitle("PLMESH");
plmesh (<< x = x2; y = y2; z = z2>>);
pause();

//-------------------------------------------------------------------//

// Synopsis: Median value

// Syntax:   median ( X )

// Description:

//      median computes the median (middle) value for the input
//      vector/matrix X. If X is a vector, then a single value is
//      returned. If X is a matrix, then a row-vector of the median
//      values for each column is returned.

//-------------------------------------------------------------------//

median = function ( x )
{
  local (x)

  m = x.nr;
  n = x.nc;

  x = sort(x).val;
  
  if (m == 1)                     // Row-vector
  {
    if (mod(n,2))                 // n is odd
    {
      y = x[(n+1)/2];
    else                          // n is even
      y = (x[n/2] + x[n/2+1])/2;
    }
  else                            // Column Vector / Matrix
    if (mod(m,2))                 // m is odd
    {
      y = x[(m+1)/2;];
    else                          // m is even
      y = (x[m/2;] + x[m/2+1;])/2;
    }
  }
  return y;
};

//---------------------------------------------------------------------------
//  fmin.r:
//  x = fmin(f,ax,bx,tol,print)
//
//  find the minimum of the function f(x) in the interval [ax,bx]
//
//  f = The real-values function of a single variable.
//
//  ax,bx = left and right endpoints of search interval
//
//  tol = maximum length of interval of uncertainty of minimum
//        tol >= 0
//
//  print = an optional last agrument, if nonzero a printed tracing of
//          the steps is given
//
//  x = the value of x approximating where f attains a minimum in [ax,bx]

//  This algorithm is from: "Computer Methods for Mathematical
//  Computations", Forsythe, Malcolm, and Moler, Prentice-Hall, 1976.

//  Adapted by: Duane Hanselman, University of Maine, (207)-581-2246
// initialization
//---------------------------------------------------------------------------

fmin = function ( f, ax, bx, tol, _print)
{
  global (eps)

  if (!exist (_print)) { print = 0; else print = _print; }
  num = 1;
  seps = sqrt(eps);
  c = 0.5*(3.0 - sqrt(5.0));
  a = ax; b = bx;
  v = a + c*(b-a);
  w = v; x = v;
  d = 0.0; e = 0.0;
  fx = f (x);
  if (print) { fmin_data = [1, x, fx] ? }
  fv = fx; fw = fx;
  xm = 0.5*(a+b);
  tol1 = seps*abs(x) + tol/3.0;
  tol2 = 2.0*tol1;

  // main loop

  while (abs (x-xm) > (tol2 - 0.5*(b-a)))
  {
    num = num+1;
    gs = 1;

    // is parabolic fit possible
 
    if (abs(e) > tol1)		// yes, so fit parabola
    {
      gs = 0;
      r = (x-w)*(fx-fv);
      q = (x-v)*(fx-fw);
      p = (x-v)*q-(x-w)*r;
      q = 2.0*(q-r);
      if (q > 0.0) { p = -p; }
      q = abs (q);
      r = e;
      e = d;

      // is parabola acceptable

      if ((abs (p) < abs (0.5*q*r)) && (p > q*(a-x)) && (p<q*(b-x)))
      {
        // yes, parabolic interpolation step
        d = p/q;
        u = x+d;
        step = "   num        x        fx       parabolic";

        // f must not be evaluated too close to ax or bx

        if (((u-a) < tol2) || ((b-u) < tol2))
        {
          si = sign(xm-x) + ((xm-x) == 0);
          d = tol1*si;
        }
      else	// not acceptable, must do a golden section step
        gs=1;
      }
    }
    if (gs)	// a golden-section step is required
    {
      if (x >= xm) { e = a-x; else e = b-x; }
      d = c*e;
      step = "   num        x        fx       golden   ";
    }

    // f must not be evaluated too close to x

    si = sign(d) + (d == 0);
    u = x + si * max ([abs (d), tol1]);
    fu = f (u);
    if (print) { fmin_data = [num, u, fu] ? disp(step) ? }

    // update a, b, v, w, x, xm, tol1, tol2
    if (fu <= fx)
    {
      if (u >= x) { a = x; else b = x; }
      v = w; fv = fw;
      w = x; fw = fx;
      x = u; fx = fu;
    else	// fu > fx
      if (u < x) { a = u; else b = u; }
      if ( (fu <= fw) || (w == x) )
      {
        v = w; fv = fw;
        w = u; fw = fu;
      else if ( (fu <= fv) || (v == x) || (v == w) ) {
        v = u; fv = fu;
      }}
    }
    xm = 0.5*(a+b);
    tol1 = seps*abs(x) + tol/3.0;
    tol2 = 2.0*tol1;
  }

  return x
};

//-------------------------------------------------------------------//

// Synopsis:	Calculate the section properties (area, center of
//              geometry, moment of inertia) of a region.

// Syntax:	section ( P , coord )

// Description:

//	The properties of polygonal sections may be calculated using this 
//  rfile.  
//  
//  The (x,y) coordinates of the vertices of the region are stored 
//  in P.  P is a two column matrix,  its first column stores xs and
//  its second column stores ys.   The coordinates of the vertces must
//  be stored sequentially for a complete clockwise path around the 
//  region.  Holes inside the region can be subtracted by tracing 
//  around them in counter clockwise direction.
//  If coord is "polar", then the coordinates in P are in polar 
//  coordinates (r,theta), where theta is in degree.
//
//      Reference: (many more)
//      Wojciechowski, F., "Properties of Plane Cross Sections,"
//      Machine Design, Jan. 1976, p.105.
//
// Example 1:  Section properties of a rectangle
//
//  A = [0,0;0,4;2,4;2,0;0,0];
//  S = section(A);
//  show_prop(A,S);
//  pause();
//
// Example 2:  Section properties of a triangle
//
//  P = [0,0;0,1;1,0;0,0];
//  S = section(P);
//  show_prop(P,S);
//  pause();
//
// Example 3:  Section properties of an unit circle
//
//  theta = (360:0:-5)';
//  r = ones(theta.nr,1);
//  S = section([r,theta],"polar");
//  show_prop([r,theta],S,"polar");
//  pause();
//
// Example 4:  Section properties of a C section
//
//  P = [1,75;ones(42,1),(80:285:5)';1.2,285;ones(42,1)*1.2,(280:75:-5)'];
//  S = section(P,"polar");
//  show_prop(P,S,"polar");
//  pause();
//
// Example 5:  Section properties of a square with a center hole
//  s2 = sqrt(2);
//  P = [10,0;10*s2,-45;10*s2,225;10*s2,135;10*s2,45;10,0;...
//       5*ones(73,1),(0:360:5)';10,0];
//  S = section(P,"polar");
//  show_prop(P,S,"polar");
//  pause();
//
// Todo:
//  1. make P a linked-list of several regions (may be holes), return
//     the total properties.
//  2. add thickness and mass density to each region in 1., so the mass, 
//     the center of mass, and the mass moment of inertia can be 
//     calculated.
//   
// Tzong-Shuoh Yang  8/10/94   (tsyang@ce.berkeley.edu)
//-------------------------------------------------------------------//
section = function( P, coord )
{  
   local(P,B,N,N1,np,prop,q);
   global (eps, pi)

   if (P.nr <= 2) 
   {
      error("section.r: A polygon must have at least 3 points.");
   }

   // if the polygon is not closed, let the last point = 1st point
   if (P[P.nr;1] != P[1;1] || P[P.nr;2] != P[1;2] )
   {
       P = [P;P[1;1],P[1;2]];
   }
      
   // convert polar coordinates to cartesian coordinates
   if (exist(coord)) 
   {  if (coord == "polar")
      {
         P[;2] = P[;2]*(pi/180);
         P = [P[;1].*cos(P[;2]),P[;1].*sin(P[;2])];
      }
   }
   
   np = P.nr - 1;
   N  = 1:np;
   N1 = 2:P.nr;
   prop = <<>>;
   B  = P[N1;1].*P[N;2] - P[N;1].*P[N1;2];
   prop.area = sum(B)/2; 
   prop.cgx  = B'*(P[N;1]+P[N1;1])/6/prop.area;
   prop.cgy  = B'*(P[N;2]+P[N1;2])/6/prop.area;
   prop.Ixx  = B'*(P[N;2].^2 + P[N;2].*P[N1;2] + P[N1;2].^2)/12;
   prop.Iyy  = B'*(P[N;1].^2 + P[N;1].*P[N1;1] + P[N1;1].^2)/12;
   prop.Ixy  = B'*(P[N;1].*(2*P[N;2]+P[N1;2]) + P[N1;1].*(2*P[N1;2]+P[N;2]))/24;
   // centroid values
   prop.Ixx0 = prop.Ixx - prop.cgy^2*prop.area;
   prop.Iyy0 = prop.Iyy - prop.cgx^2*prop.area;
   prop.Ixy0 = prop.Ixy - prop.cgx*prop.cgy*prop.area;
   // pricipal values
   if (abs(prop.Ixy0) < eps) {
      q = 0;
   else if (prop.Ixx0 == prop.Iyy0) {
      q = pi/4;
   else
      q = 0.5*atan(2*prop.Ixy0/(prop.Iyy0 - prop.Ixx0));
   }}
   prop.pIxx  = prop.Ixx0*cos(q)^2 + prop.Iyy0*sin(q)^2 - prop.Ixy0*sin(2*q);
   prop.pIyy  = prop.Ixx0*sin(q)^2 + prop.Iyy0*cos(q)^2 + prop.Ixy0*sin(2*q);
   // polar moi
   prop.J0    = prop.pIxx + prop.pIyy;
   // convert angle to degree
   prop.angle = q*180/pi;
   
   return prop;
};

//-------------------------------------------------------------------//

// Synopsis:	Band reduction by two-sided unitary transformations.

// Syntax:	bandred ( A , KL, KU )

// Description:

//	bandred(A, KL, KU) is a matrix unitarily equivalent to A with
//	lower bandwidth KL and upper bandwidth KU (i.e. B(i,j) = 0 if
//	i > j+KL or j > i+KU).  The reduction is performed using
//	Householder transformations. If KU is omitted it defaults to
//	KL. 

//	Called by randsvd.
//	This is a `standard' reduction.  Cf. reduction to bidiagonal
//	form prior to computing the SVD.  This code is a little
//	wasteful in that it computes certain elements which are
//	immediately set to zero! 
//
//      Reference:
//      G.H. Golub and C.F. Van Loan, Matrix Computations, second edition,
//      Johns Hopkins University Press, Baltimore, Maryland, 1989.
//      Section 5.4.3.

//	This file is a translation of bandred.m from version 2.0 of
//	"The Test Matrix Toolbox for Matlab", described in Numerical
//	Analysis Report No. 237, December 1993, by N. J. Higham.

// Dependencies
   require house

//-------------------------------------------------------------------//

bandred = function ( A , kl , ku )
{
  local (A, kl, ku)

  if (!exist (ku)) { ku = kl; else ku = ku; }

  if (kl == 0 && ku == 0) {
    error ("You''ve asked for a diagonal matrix.  In that case use the SVD!");
  }

  // Check for special case where order of left/right transformations matters.
  // Easiest approach is to work on the transpose, flipping back at the end.

  flip = 0;
  if (ku == 0)
  {
    A = A';
    temp = kl; kl = ku; ku = temp; flip = 1;
  }

  m = A.nr; n = A.nc; 

  for (j in 1 : min( min(m, n), max(m-kl-1, n-ku-1) ))
  {
    if (j+kl+1 <= m)
    {
       </beta; v/> = house(A[j+kl:m;j]);
       temp = A[j+kl:m;j:n];
       A[j+kl:m;j:n] = temp - beta*v*(v'*temp);
       A[j+kl+1:m;j] = zeros(m-j-kl,1);
    }

    if (j+ku+1 <= n)
    {
       </beta; v/> = house(A[j;j+ku:n]');
       temp = A[j:m;j+ku:n];
       A[j:m;j+ku:n] = temp - beta*(temp*v)*v';
       A[j;j+ku+1:n] = zeros(1,n-j-ku);
    }
  }

  if (flip) {
    A = A';
  }

  return A;
};

//
// From MATRIX Computations, G.H. Golub, C.F. Van Loan
//

//
// house_v(): Given an N-vector V, generate an n-vector V
// with V[1] = 1, such that (eye(n,n) - 2*(V*V')/(V'*V))*X
// is zero in all but the 1st component.
//

static (sign)

house_v = function(v)
{
  local(v)
  
  n = max( size(v) );
  u = norm(v, "2");
  if(u != 0)
  {
    b = v[1] + sign(v[1])*u;
    if(n > 1) 
    {
      v[2:n] = v[2:n]/b;
    }
  }
  v[1] = 1;
  return v;
};
      
//
// house_row(): Given an MxN matrix A and a non-zero M-vector V
// with V[1] = 1, the following algorithm overwrites A with 
// P*A, where P = eye(m,m) - 2*(V*V')/(V'*V)
//

house_row = function(A, v)
{
  local(A)
  
  b = -2/(v'*v);
  w = b*A'*v;
  A = A + v*w';
  return A;
};

//
// house_col(): Given an MxN matrix A, and an N-vector V, 
// with V[1] = 1, the following algorithm overwrites A with A*P
// where P = eye(N,N) - 2*(V*V')/(V'*V)
//
 
house_col = function(A, v)
{
  local(A)
  
  b = -2/(v'*v);
  w = b*A*v;
  a = A + w*v';
  
  return A;
};

//
// Given A, with M >= N, the following function finds Householder
// matrices H1,...Hn, such that if Q = H1*...Hn, then Q'*A = R is
// upper triangular.

// House_qr returns a MxN matrix, with the upper triangular part 
// containing [R]

house_qr = function ( A )
{
  local (A)

  m = A.nr; n = A.nc;
  v = zeros(m,1);
  q = eye (m, m);

  for(j in 1:n)
  {
    // Generate the Householder vector
    v[j:m] = house_v( A[j:m;j] );

    // Apply the Householder reflector to A
    A[j:m;j:n] = house_row( A[j:m;j:n], v[j:m] );

    // Create Q
    if(j < m) 
    {
      q = P ([ zeros (j-1,1); 1; v[j+1:m] ]) * q;
    }
  }
  return << q = q'; r = A >>;
};

//
//  Generate P matrix
//

P = function ( V )
{
  m = max( size(V) );
  return [ eye(m,m) - 2*(V*V')./(V'*V) ];
};

sign = function ( X )
{
  if (X >= 0)
  { 
    return 1; 
  else 
    return -1;
  }
};

//-------------------------------------------------------------------//

//  Syntax:	input ( STRING )
//		input ( STRING , "s" )

//  Description:

//  The input function provides an easy method for users to get a
//  simple response from the keyboard. The STRING argument is printed
//  on the standard output (usually the screen), and the program waits
//  until input is entered. Input then returns the input, which can be
//  either a string, or a number. If you want to force the input to be
//  a string, then use the second, and optional argument, "s" to force
//  the return value to be a string.

//  If the user does not enter anything when prompted, then input
//  returns an empty matrix.

//-------------------------------------------------------------------//

input = function ( STRING, S )
{
  if (!exist (STRING)) { STRING = "input: "; }

  fprintf ("stdout", "%s", STRING);
  ans = getline ("stdin");

  if (length (ans) == 0)
  {
    return [];
  else
    if (exist (S))
    {
      if (class (ans.[1]) == "num")
      {
        return num2str (ans.[1])
      else
        return ans.[1];
      }
    else
      return ans.[1]
    }
  }
};

t = (0:10:.05)';
x = exp (-0.5*t) .* (cos (2*pi*3*t) + sin (2*pi*7*t));
X = fft (x);
rfile faxis
freq = faxis (X, .05, 3);
mag = abs (X);
rfile angle
phase = angle (X);
pstart (1,2,"xwin");

ptitle ("Magnitude of FFT")
xlabel ("Frequency (Hertz)");
plwid(6);
plot ([freq,mag]);

ptitle ("Angle (atan2(imag/real)) of FFT")
xlabel ("Frequency (Hertz)");
ylabel ("Angle (radians)");
plwid(6);
plot ([freq,phase]);
plprint ("p3.ps");

//-------------------------------------------------------------------//

// Synopsis:    Hilbert transform

// Syntax:      hilbert ( X )

// Description:

//      Hilbert computes the Hilbert transform of a real
//      sequence. Hilbert returns a complex valued analytic function
//      Z, such that:

//              Z = X + jXh

//      Where X is the original series, Xh

//      Properties: y = hilbert (x);
//                  A = abs (y) is an envelope of x.
//                  ph= angle (y) is the instaneous phase of x.
//                  -N*eps < real (y)' * imag (y) < N*eps

//                  
// Reference: J. S. Bendat, A. G. Piersol, Random Data, Analysis 
//            and Measurement Procedures. 2nd Edition, 1986, 
//            J. Wiley and Sons. 

// See Also: fft, ifft

//-------------------------------------------------------------------//

hilbert = function ( x )
{
  local (x)

  y = fft (real (x[:]));  # Make sure it is a vector.
  n = y.n;
  if (n != 1)
  {
    b = [1;                      # B_1(0) term
         2*ones ((n-1)/2,1);     # f > 0
         ones (1-mod(n,2),1);    # B_1(0) again (symmetric ?)
         zeros ((n-1)/2,1) ];    # f < 0
    y = b.*y;
  }

  return ifft(y);
};

//  QQ_NORMAL
//  Input: e = unsorted error residual vector to be checked.
//  Output: eq = sample quantile (sorted e)
//          nq = theoretical N(0,1) quantile.
//  Plot (nq,eq) as (x,y) pairs to make a Q-Q plot.
//  
//    ^ Usage: ^
//  [nq,eq]=QQ_NORMAL(e);
//  plot(nq,eq,'o')
//  xlabel('Theoretical Normal N(0,1) Quantile')
//  ylabel('Sorted data values (user units)')

//   ^ Uses Matlab function "inverf", inverse error fn. ^
//   Tests the elements of vector e to examine whether they
//   are distributed according to a normal distribution.  The
//   output of this function may be used to construct a q-q
//   plot, for visual inspection of the distribution. If a normal
//   distribution is appropriate, the resulting locus of (nq,eq)
//   pairs will approximately follow a straight line, whose
//   intercept and slope respectively correspond to the mean
//   and standard deviation of the normal distribution.
//   Outliers, if present, appear as departures from linearity,
//   usually away from the origin, and are easily identified.
//   Keywords: Outliers, Robust Statistics, Data analysis

//   Copyright (c) 1989 by Peter R. Shaw
//   Permission to copy all or part of this work is granted, provided
//   that the copies are not distributed for resale, and that the
//   copyright notice and this notice are retained.
//  
//   If you make any improvements, please let me know.

//   Peter R. Shaw
//   Woods Hole Oceanographic Institution
//   Woods Hole, MA 02543
//   (508) 457-2000 ext. 2473
//   pshaw@aqua.whoi.edu

//   Translated to RLaB 5/10/93, Ian Searle

//   Reference:
//   Lewis, T. and N. I. Fisher, Graphical methods for investigating
//   the fit of a Fisher distribution to spherical data; Geophys. J.
//   R. Astr. Soc., 69:1-13, 1987.

require erf

qq_normal = function ( e )
{
  local (eq, ivec, n, n2, nq, neg, pos);

  n = e.nr; 
  n2 = e.nc;

  if (n2 > 1) { error("(qq_normal): e must be a vector."); }

  n = length (e);
  eq = sort(e).val;
  ivec = ((1:n)'-.5)./n;
  pos = (ivec >= .5);
  neg = !pos;
  nq = zeros (size (e));
  nq[find (neg)] = -sqrt (2)*inverf (2*(.5-ivec[find (neg)]));
  nq[find (pos)] = +sqrt (2)*inverf (2*(ivec[find (pos)]-.5));

  return [nq, eq];
}

//
//  Integrate the Van der Pol equation
//

vdpol = function ( t , x ) 
{
  local(xdot);

  xdot[1;1] = x[1] * (1 - x[2]^2) - x[2];
  xdot[2;1] = x[1];
  return xdot;
};

vdpol_out = function ( t , x )
{
  return [t; x; 2*x];
};

// system( "/usr/ucb/ps -aux | grep rlab" );
t0 = 0;
tf = 20
x0 = [0; 0.25];
tic();
// out = ode23( vdpol, t0, tf, x0, vdpol_out);
// rfile ode78
// out = ode78( vdpol, t0, tf, x0, vdpol_out );
// rfile ode4
// out = ode4( vdpol, t0, tf, x0, vdpol_out );
out = ode (vdpol, t0, tf, x0, , , , vdpol_out);
printf(" Elapsed integration time: %i\n", toc() );

plgrid ();
ptitle ( "RLaB ODE Example (vdpol)" );
xlabel ( "Time (seconds)" );
ylabel ( "States" );

plot( out );

//-------------------------------------------------------------------//
// Synopsis: Short-Time ENerGy.

// Syntax: </ TSCALE ; Y /> = sp_steng(X,FRAME,OVERLAP,FS,WIN)

// Description:

//      steng computes the short-time energy of X using a size FRAME
//      (seconds) and a percentage OVERLAP (%) between successive
//      frames using a rectangular data window.  The sampling
//      frequency is given by FS (samples/second). The short-time
//      energy curve is returned in Y and a time scale corresponding
//      to the end of the data frame is returned in TSCALE.  The curve
//      may be displayed with the command `plot([tscale,y])'.

//      The last, and optional argument, WIN, specifies the data
//      window used before computing the short-time energy.  WIN can
//      be one of the following:

//          hamming    "hamm"
//          hanning    "hann"
//          blackman   "blac"
//          triangular "tria"

//      See also: SP_STENG, SP_STZCR, AVSMOOTH, MDSMOOTH

//      Matlab original by:
//       LT Dennis W. Brown 7-11-93, DWB 11-11-94
//       Naval Postgraduate School, Monterey, CA
//       May be freely distributed.
//       Not for use in commercial products.

//       Ref: Rabiner & Schafer, Digital Processing of Speech
//       Signals, 1978, ss 4.2, pp 120-126.

//-------------------------------------------------------------------//

require window

steng = function (x, frame, overlap, fs, win)
{
  local (x, frame, overlap, fs, win)

  // default values
  y = [];
  tscale = [];

  // must have at least 3 args
  if (nargs < 4)
  {
    error("sp_steng: Requires first three arguments.");
  }

  // percentage must be in range 0-100
  if (overlap < 0 || overlap > 100)
  {
    error("sp_steng: Overlap percentage must be in range 0-100%");
  }

  // figure out if we have a vector
  if (min(size(x)) != 1)
  {
    error("sp_steng: Input arg \"x\" must be a 1xN or Nx1 vector.");
  }

  // work with Nx1 vectors
  x = x[:];
  // variables
  Ns = length(x);                         // number of samples
  N = floor(fs * frame);                  // samples-per-frame
  Ndiff = floor(N * (1 - overlap/100));   // samples between windows
  L = floor((Ns-N)/Ndiff);                // number of windows
  y = zeros(L,1);                         // space for answer
  tscale = zeros(L,1);                    // space for indices

  // data window
  datawindow = ones(N,1);                 // rectangular default
  if (nargs == 5)
  {
    datawindow = window (N, win);
  }

  // square the data and the window
  datawindow = datawindow .^ 2;
  x = x .^ 2;

  // windows with overlap
  for (k in 1:L)
  {
    s1 = (k-1) * Ndiff + 1;    	// start of window
    tscale[k;1] = k * Ndiff/fs;
    y[k;1] = sum(x[s1:s1+N-1;1] .* datawindow);
  }

  return << y=y; tscale=tscale >>;
};

#
#MDSMAX  [x, fmax, nf] = MDSMAX(fun, x0, STOPIT, SAVIT) attempts to
#        maximize the function specified by the string fun, using the
#        starting vector x0.  The method of multi-directional search is used.
#        Output arguments:
#               x    = vector yielding largest function value found,
#               fmax = function value at x,
#               nf   = number of function evaluations.
#        The iteration is terminated when either
#               - the relative size of the simplex is <= STOPIT(1)
#                 (default 1e-3),
#               - STOPIT(2) function evaluations have been performed
#                 (default inf, i.e., no limit), or
#               - a function value equals or exceeds STOPIT(3)
#                 (default inf, i.e., no test on function values).
#        The form of the initial simplex is determined by STOPIT(4):
#           STOPIT(4) = 0: regular simplex (sides of equal length, the default)
#           STOPIT(4) = 1: right-angled simplex.
#        Progress of the iteration is not shown if STOPIT(5) = 0 (default 1).
#        If a non-empty fourth parameter string SAVIT is present, then
#        `SAVE SAVIT x fmax nf' is executed after each inner iteration.
#        NB: x0 can be a matrix.  In the output argument, in SAVIT saves,
#            and in function calls, x has the same shape as x0.

# This implementation uses 2n2 elements of storage (two simplices), where x0
# is an n-vector.  It is based on the algorithm statement in [2, sec.3],
# modified so as to halve the storage (with a slight loss in readability).

# References:
# [1] V.J. Torczon, Multi-directional search: A direct search algorithm for
#     parallel machines, Ph.D. Thesis, Rice University, Houston, Texas, 1989.
# [2] V.J. Torczon, On the convergence of the multi-directional search
#     algorithm, SIAM J. Optimization, 1 (1991), pp. 123-145.
# [3] N.J. Higham, Optimization by direct search in matrix computations,
#     Numerical Analysis Report No. 197, University of Manchester, UK, 1991;
#     to appear in SIAM J. Matrix Anal. Appl, 14 (2), April 1993.

# By Nick Higham, Department of Mathematics, University of Manchester, UK.
#                 na.nhigham@na-net.ornl.gov
# July 27, 1991.

#
# Translated to RLaB, Ian Searle
# Febuary 1994.
#

# Dependencies
require rem

mdsmax = function (fun, X, stopit, savit)
{
  global (eps)

  x = X;	# Copy input
  n = prod(size(x));
  x0 = x[:];	# Work with column vector internally.

  mu = 2;      # Expansion factor.
  theta = 0.5; # Contraction factor.

  # Set up convergence parameters etc.
  if (!exist(stopit)) { stopit[1] = 1e-3; }
  tol = stopit[1];  # Tolerance for cgce test based on relative size of simplex.
  if (max(size(stopit)) == 1) { stopit[2] = inf(); }	# Max no. of f-evaluations.
  if (max(size(stopit)) == 2) { stopit[3] = inf(); }	# Default target for f-values.
  if (max(size(stopit)) == 3) { stopit[4] = 0; }	# Default initial simplex.
  if (max(size(stopit)) == 4) { stopit[5] = 1; }	# Default: show progress.
  trace  = stopit[5];
  if (!exist(savit)) { savit = []; }			# File name for snapshots.

  V = [zeros(n,1), eye(n,n)]; T = V;
  f = zeros(n+1,1); ft = f;
  V[;1] = x0; 
  x = reshape (x0, x.nr, x.nc);
  f[1] = fun (x);
  fmax_old = f[1];

  if (trace) { printf("f(x0) = %9.4e\n", f[1]); }

  k = 0; m = 0;

  # Set up initial simplex.
  scale = max([norm(x0,"i"),1]);
  if (stopit[4] == 0)
  {
    # Regular simplex - all edges have same length.
    # Generated from construction given in reference [18, pp. 80-81] of [1].
    alpha = scale / (n*sqrt(2)) * [ sqrt(n+1)-1+n, sqrt(n+1)-1 ];
    V[;2:n+1] = (x0 + alpha[2]*ones(n,1)) * ones(1,n);
    for (j in 2:n+1)
    {
      V[j-1;j] = x0[j-1] + alpha[1];
      x = reshape (V[;j], x.nr, x.nc);
      f[j] = fun (x);
    }
  else
    # Right-angled simplex based on co-ordinate axes.
    alpha = scale*ones(n+1,1);
    for (j in 2:n+1)
    {
      V[;j] = x0 + alpha[j]*V[;j];
      x = reshape (V[;j], x.nr, x.nc);
      f[j] = fun (x);
    }
  }
  nf = n+1;
  msize = 0;		# Integer that keeps track of expansions/contractions.
  flag_break = 0;	# Flag which becomes true when ready to quit outer loop.

  while (1)	###### Outer loop.
  {
    k = k+1;

    # Find a new best vertex  x  and function value  fmax = f(x).
    fmax = max (f); j = maxi (f);
    V[;1,j] = V[;j,1]; 
    v1 = V[;1];
    if (!isempty(savit)) { x = reshape(v1, x,nr, x.nc); write ("savit", x,fmax,nf); }
    f[1,j] = f[j,1];
    if (trace)
    {
      printf("Iter. %2.0f,  inner = %2.0f,  size = %2.0f,  ", k, m, msize);
      printf("nf = %3.0f,  f = %9.4e  (%2.1f)\n", nf, fmax, ...
             100*(fmax-fmax_old)/(abs(fmax_old)+eps));
    }
    fmax_old = fmax;

    # Stopping Test 1 - f reached target value?
    if (fmax >= stopit[3])
    {
      msg = "Exceeded target...quitting\n";
      break  # Quit.
    }

    m = 0;
    while (1)   ### Inner repeat loop.
    {
      m = m+1;
  
      # Stopping Test 2 - too many f-evals?
      if (nf >= stopit[2])
      {
        msg = "Max no. of function evaluations exceeded...quitting\n";
        flag_break = 1; 
        break  # Quit.
      }
  
      # Stopping Test 3 - converged?   This is test (4.3) in [1].
      size_simplex = norm(V[;2:n+1] - v1[;ones(1,n)],"1") / max([1, norm(v1,"1")]);
      if (size_simplex <= tol)
      {
        sprintf(msg, "Simplex size %9.4e <= %9.4e...quitting\n", ...
                size_simplex, tol);
        flag_break = 1; 
        break  # Quit.
      }
  
      for (j in 2:n+1)      # ---Rotation (reflection) step.
      {
        T[;j] = 2*v1 - V[;j];
        x = reshape (T[;j], x.nr, x.nc);
        ft[j] = fun (x);
      }
      nf = nf + n;
  
      replaced = ( max(ft[2:n+1]) > fmax );
  
      if (replaced)
      {
        for (j in 2:n+1)	# ---Expansion step.
        {
          V[;j] = (1-mu)*v1 + mu*T[;j];
          x = reshape (V[;j], x.nr, x.nc);
          f[j] = fun (x);
        }
        nf = nf + n;
        # Accept expansion or rotation?
        if (max(ft[2:n+1]) > max(f[2:n+1]))
        {
          V[;2:n+1] = T[;2:n+1];
          f[2:n+1] = ft[2:n+1];	# Accept rotation.
        else
          msize = msize + 1;	# Accept expansion (f and V already set).
        }
      else
        for (j in 2:n+1)	# ---Contraction step.
        {
          V[;j] = (1+theta)*v1 - theta*T[;j];
          x = reshape (V[;j], x.nr, x.nc);
          f[j] = fun (x);
        }
        nf = nf + n;
        replaced = ( max(f[2:n+1]) > fmax );
        # Accept contraction (f and V already set).
        msize = msize - 1;
      }
  
      if (replaced) { break }
      if (trace && rem(m,10) == 0) 
      { 
        printf("        ...inner = %2.0f...\n",m);
      }
    }		### Of inner repeat loop.

    if (flag_break) { break }

  }	###### Of outer loop.

  # Finished.
  if (trace) { printf(msg); }
  x = reshape (v1, x.nr, x.nc);

  return << x = x; fmax = fmax; nf = nf>>;
};

//
// Calculate Fourier transform of a finite signal (SLOWLY)
//

sfft = function ( x )
{
  global (pi)

  if(class (x) != "num") 
  {
    error ("input to sfft must be a matrix");
  }

  X = zeros ( size (x) );
  
  for( k in 1:x.n )
  {
    for( n in 1:x.n )
    {
      X[k] = X[k] + x[n]*exp( (-1i*2*pi*(k-1)*(n-1))/x.n );
    }
  }
  
  return X;
};

//-------------------------------------------------------------------//

//  Synopsis:   Check R-files for global variable references.

//  Syntax:	lcheck ( FR )

//  Description:

//  lcheck uses the built-in function, fvscope, to look for global
//  variable references from within functions. Global variable
//  references, from within functions are not necessarily
//  bad. However, when writing a library of R-files for widespread
//  usage it is best to avoid references to global variables, other
//  than functions.

//  lcheck takes a single string argument, FR, which is the
//  filename(s) of the R-files to be checked. FR will be expanded by
//  the shell, so shell meta-characters are allowed.

//         lcheck ("*.r");

//  The above will check all the R-files (files with a suffix of `.r')
//  with fvscope, prompting the user for a return between files.

//  Note: Do not execute this function on itself.

//  Dependencies:
//     This file requires AWK, preferrable mawk.

//-------------------------------------------------------------------//

//
// A simple AWK program
//

static (fname_awk)
fname_awk = "/=[ ]*function[ ]*\(*/ { fn = 1; print $1 }"+...
            "END { if (!fn) { printf(\"NO_FUNCTION_NAMES...\\n\"); }}";

static (AWK)
AWK = "mawk";

lcheck = function ( FR )
{
  local (ans, flist, i, fname, str1, str2, str3, str4)

  if (class (FR) != "string") 
  {
    error ("lcheck: requires a string argument");
  }

  str1 = "| ls "+FR;
  str3 = "| "+ AWK + " '/\*/'";

  while (length (ans = getline (str1)))
  {
    for (i in members (ans))
    {
      str2 = "| "+AWK+" '" + fname_awk + "' < "+ans.[i];
      flist = getline (str2);
      if (flist.[1] != "NO_FUNCTION_NAMES...")
      {
	fname = flist.[1];
	printf ("Checking variable scope in: %s\n", fname);
	load (ans.[i]);
	str4 = "fvscope (" + fname + ",\"" + str3 + "\")";
	eval (str4);
	close (str3);
	pause ();
      }
      close (str2);
    }
  }
  close (str1);
};

//
// For testing how various math libraries will respond
//

diary();

Inf = inf();
NaN = nan();

//
// Trig Functions
//

cos( Inf )
sin( Inf )
tan( Inf )
acos( Inf )
asin( Inf )
atan( Inf )

cos( -Inf )
sin( -Inf )
tan( -Inf )
acos( -Inf )
asin( -Inf )
atan( -Inf )

cos( NaN )
sin( NaN )
tan( NaN )
acos( NaN )
asin( NaN )
atan( NaN )

//
// Hyperbolic trig functions
//

sinh( Inf )
cosh( Inf )
tanh( Inf )

sinh( -Inf )
cosh( -Inf )
tanh( -Inf )

sinh( NaN )
cosh( NaN )
tanh( NaN )

//
// Misc.
//

exp( Inf )
log( Inf )
log10( Inf )
sqrt( Inf )

exp( -Inf )
log( -Inf )
log10( -Inf )
sqrt( -Inf )

exp( NaN )
log( NaN )
log10( NaN )
sqrt( NaN )

//-------------------------------------------------------------------//
//
//  A Simple Least Squares Data Fitting Example
//

//
//  Set the random number generator to uniform distribution, with
//  lower bound = -2, and upper bound = 5.
//

  rand("uniform",-2, 5);

//  Generate random data with a linearly varying component.  The
//  linearly varying component is formed, and stored in `off'. The
//  simulated, measured data is stored in `b'.
//

  off = 0:-20:-.2;
  b = ((off + 22) + rand( size(off) ));

//
//  Generate the Data matrix, A.
//
//      | 1  t  t^2 |
//  A = | 1  t  t^2 |
//      | 1  t  t^2 |
//        .  .   .
//        .  .   .
//        .  .   .
//

  m = b.n;
  t = (1:m)/m;

  A = [ ones(m,1), t', (t.^2)' ];

//
//  Now use left division (least squares) to solve for `x'.
//

  x = A\b';

//
//  Create a simple function that uses the computed parameters to
//  make predictions.
//

  ls = function(t)
  {
    global (x)
    return x[1] + x[2]*t + x[3]*t.^2;
  }

//
//  Plot a comparison of the original data, and the computed
//  values.
//

  plgrid ();
  ptitle ( "RLaB Least Squares Example" );
  xlabel ( "Independent Variable" );
  ylabel ( "Dependent Variable" );

  plot( [ t; b; ls( t ) ]' );
